package 
{
    import CompoClock.*;
    import MGameEvents.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.utils.*;
    import mgame.manager.*;

    public class CompoClock extends MGSprite
    {
        public var playerNo:int = 0;
        public var TimeCount:int = 15;
        private var isDispatchEvent:Boolean = true;
        public var callBackFunction:Function;
        private var timer:Timer;
        private var curFrame:BitmapData;
        private var canvas:Sprite;
        private static var atlas:BitmapData;

        public function CompoClock() : void
        {
            this.curFrame = new BitmapData(95, 116);
            this.timer = new Timer(100, 1);
            this.timer.addEventListener(TimerEvent.TIMER_COMPLETE, this.onTimerComplete);
            this.timer.addEventListener(TimerEvent.TIMER, this.onUpdate);
            this.canvas = new Sprite();
            this.addChild(this.canvas);
            this.canvas.scaleY = 1.6;
            this.drawFrame();
            return;
        }// end function

        private function drawFrame() : void
        {
            this.canvas.graphics.clear();
            drawImage(this.timer.currentCount, this.curFrame);
            this.canvas.graphics.beginBitmapFill(this.curFrame, new Matrix(1, 0, 0, 1.1));
            this.canvas.graphics.drawRect(0, 0, this.curFrame.width, this.curFrame.height + 8);
            this.canvas.graphics.endFill();
            return;
        }// end function

        public function Start(param1:Boolean = true) : void
        {
            this.isDispatchEvent = param1;
            this.timer.stop();
            this.timer.reset();
            this.timer.delay = this.TimeCount * 1000 / 296;
            this.timer.repeatCount = 296;
            this.timer.start();
            this.canvas.visible = true;
            this.drawFrame();
            return;
        }// end function

        private function onUpdate(event:Event = null) : void
        {
            var _loc_2:* = this.timer.currentCount * this.timer.delay / 1000;
            if (this.timer.currentCount < 296)
            {
                this.drawFrame();
            }
            if (this.callBackFunction != null)
            {
                this.callBackFunction(_loc_2);
            }
            return;
        }// end function

        private function onTimerComplete(event:Event = null) : void
        {
            if (this.isDispatchEvent)
            {
                this.dispatchEvent(new TimeOverEvent(TimeOverEvent.TIME_OUT, {playerNo:this.playerNo}, true));
            }
            return;
        }// end function

        public function Stop() : void
        {
            this.timer.stop();
            this.canvas.visible = false;
            return;
        }// end function

        private static function drawImage(param1:int, param2:BitmapData) : void
        {
            if (atlas == null)
            {
                atlas = new CompoClockAtlas();
            }
            var _loc_3:* = param1 % 21 * 95;
            var _loc_4:* = (param1 - param1 % 21) / 21 * 116;
            var _loc_5:* = new Rectangle(_loc_3, _loc_4, 95, 116);
            param2.copyPixels(atlas, _loc_5, new Point(0, 0));
            return;
        }// end function

    }
}
