package 
{
    import CompoSettingM.*;
    import ICompoLuat.*;
    import MGameEvents.*;
    import MGameUtilities.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    import net.king.entities.*;
    import net.mGame.controllers.*;
    import net.mgame.keys.*;
    import net.mgame.models.*;

    public class CompoSettingM extends Sprite
    {
        private var gameLoader:GameLoader;
        public var mainMovie:Setting_mc = null;
        private var _compoLuatGame:ICompoLuat = null;
        private var _BetTime:int = 20;
        private var _TimeOut:String = "30,ch?m;20,Trung bnh;15,nhanh";
        private var _BetCoin:Number = 0;
        private var _MaxBet:Number = 0;
        private var _MinBet:Number = 0;
        private var _Status:String = "";
        private var TempHeight:Number = 0;
        public var isOpenSettingAfterMatch:Boolean;
        private var boardPassWord:String = "";
        public var currUnit:int;
        private var _isSolo:Boolean = false;
        private var listCustomMaxPlayer:MyCompoBox;
        public static var DEFAULT_HEGHT:int = 342;
        public static const TRIEU:int = 1000000;
        public static const NGHIN:int = 1000;

        public function CompoSettingM() : void
        {
            this.gameLoader = GameLoader.getInstance();
            this.mainMovie = new Setting_mc();
            this.addChild(this.mainMovie);
            this.isOpenSettingAfterMatch = false;
            this.mainMovie.settingResource.addEventListener(MouseEvent.CLICK, this.processClickEvent);
            this.mainMovie.settingResource.addEventListener(RadioButton.EVENT_CHANGE, this.radioChangeStatus);
            this.mainMovie.settingResource.btn_Close.addEventListener(MouseEvent.CLICK, this.onHide, false, 0, true);
            this.mainMovie.txtBetCoin.addEventListener(Event.CHANGE, this.onChangeBetCoin, false, 0, true);
            this.currUnit = NGHIN;
            return;
        }// end function

        public function get isSolo() : Boolean
        {
            return this._isSolo;
        }// end function

        public function set isSolo(param1:Boolean) : void
        {
            this._isSolo = param1;
            if (this._compoLuatGame)
            {
                this._compoLuatGame.isSolo = param1;
            }
            return;
        }// end function

        public function get isGopGa() : Boolean
        {
            if (this.mainMovie)
            {
                return this.mainMovie.chk_gopGa.selected;
            }
            return false;
        }// end function

        public function set isGopGa(param1:Boolean) : void
        {
            if (this.mainMovie)
            {
                if (param1)
                {
                    this.mainMovie.chk_gopGa.enabled = false;
                }
                else
                {
                    this.mainMovie.chk_gopGa.enabled = true;
                }
                this.mainMovie.chk_gopGa.selected = param1;
            }
            return;
        }// end function

        public function get BoardPassWord() : String
        {
            return this.boardPassWord;
        }// end function

        public function set BoardPassWord(param1:String) : void
        {
            this.boardPassWord = param1;
            return;
        }// end function

        override public function set scaleX(param1:Number) : void
        {
            super.scaleX = param1;
            this.mainMovie.cboTimeOut.dropdownWidth = 377 * this.scaleX;
            var _loc_2:* = new TextFormat();
            _loc_2.font = "Arial";
            _loc_2.align = "center";
            _loc_2.color = 0;
            _loc_2.bold = false;
            _loc_2.italic = false;
            _loc_2.size = 42 * (this.scaleX > this.scaleY ? (this.scaleY) : (this.scaleX));
            this.mainMovie.cboMaxPlayer.dropdownWidth = 270 * this.scaleX;
            this.mainMovie.cboMaxPlayer.width = 270 * this.scaleX;
            this.mainMovie.cboMaxPlayer.dropdown.rowHeight = 60 * this.scaleY;
            this.mainMovie.cboTimeOut.setStyle("textAlign", "center");
            this.mainMovie.cboTimeOut.setStyle("color", 0);
            this.mainMovie.cboTimeOut.setStyle("fontWeight", "Bold");
            this.mainMovie.cboTimeOut.dropdown.setRendererStyle("textFormat", _loc_2);
            this.mainMovie.cboTimeOut.dropdown.setStyle("color", 77125);
            return;
        }// end function

        override public function set scaleY(param1:Number) : void
        {
            super.scaleY = param1;
            this.mainMovie.cboTimeOut.dropdown.rowHeight = 60 * this.scaleY;
            this.mainMovie.cboTimeOut.positionScale = this.scaleY;
            return;
        }// end function

        private function processClickEvent(event:MouseEvent) : void
        {
            var _loc_2:Array = null;
            this.gameLoader.playSoundClick();
            switch(event.target.name)
            {
                case "btnSetup":
                {
                    this.onSetupClick(null);
                    break;
                }
                case "btn_Close":
                {
                    this.onHide(null);
                    break;
                }
                case "clearBetcoin_btn":
                {
                    this.BetCoin = 0;
                    break;
                }
                case "phinh_min":
                {
                    this.BetCoin = this.MinBet;
                    break;
                }
                case "phinh_1":
                case "phinh_5":
                case "phinh_10":
                case "phinh_50":
                case "phinh_100":
                {
                    _loc_2 = String(event.target.name).split("_");
                    this.processPhinhClick(int(_loc_2[1]));
                    break;
                }
                default:
                {
                    break;
                }
            }
            return;
        }// end function

        private function processPhinhClick(param1:int) : void
        {
            this._BetCoin = this._BetCoin + param1 * this.currUnit;
            if (this._BetCoin > this.MaxBet)
            {
                this._BetCoin = this.MaxBet;
            }
            this.BetCoin = this._BetCoin;
            return;
        }// end function

        private function radioChangeStatus(event:Event) : void
        {
            this.gameLoader.playSoundClick();
            if (this.mainMovie.radioNghinGold.selected)
            {
                this.currUnit = NGHIN;
            }
            else
            {
                this.currUnit = TRIEU;
            }
            return;
        }// end function

        private function onDrop(event:MouseEvent) : void
        {
            this.stopDrag();
            return;
        }// end function

        private function onDrag(event:MouseEvent) : void
        {
            this.startDrag();
            return;
        }// end function

        private function onChangeInterface(event:MouseEvent) : void
        {
            return;
        }// end function

        private function onChangeCardStyle(event:MouseEvent) : void
        {
            return;
        }// end function

        protected function draw() : void
        {
            return;
        }// end function

        private function onHide(event:MouseEvent) : void
        {
            this.Hide();
            return;
        }// end function

        private function onMaskClick(event:MouseEvent) : void
        {
            this.BetCoin = this._MaxBet;
            return;
        }// end function

        private function onSetupClick(event:MouseEvent) : void
        {
            var _loc_5:int = 0;
            if (this._BetCoin < this._MinBet)
            {
                this.BetCoin = this._MinBet;
                this.mainMovie.settingResource.Error_txt.visible = true;
                this.mainMovie.settingResource.Error_txt.htmlText = "<b>Ti?n cu?c t nh?t l ;
                return;
            }
            if (this._BetCoin % 1000 > 0)
            {
                this.mainMovie.settingResource.Error_txt.visible = true;
                this.mainMovie.settingResource.Error_txt.htmlText = "<b>Ti?n cu?c ph?i l b?i s? c?a 1000 !</b>";
                this._BetCoin = Math.floor(this._BetCoin / 1000) * 1000;
                this.BetCoin = this._BetCoin;
                return;
            }
            this._BetTime = int(this.mainMovie.cboTimeOut.selectedItem.data);
            var _loc_2:String = "";
            if (this._compoLuatGame != null)
            {
                _loc_2 = this._compoLuatGame.Rule;
            }
            var _loc_3:Boolean = false;
            if (this._compoLuatGame)
            {
                _loc_3 = this._compoLuatGame.isSolo;
            }
            var _loc_4:* = this.mainMovie.chk_gopGa.selected;
            if (this.gameLoader.global.gameID == GlobalConstants.PokerGameId)
            {
                var _loc_6:* = this.gameLoader.global.maxPlayer;
                _loc_5 = this.gameLoader.global.maxPlayer;
                _loc_5 = _loc_6;
                if (!RoomInfo.fromRoom(this.gameLoader.global.MyInfo.joinedRoom).isDefault)
                {
                    _loc_5 = this.mainMovie.cboMaxPlayer.selectedItem.data;
                }
                dispatchEvent(new SettingEvent(SettingEvent.SETUP, {BetCoin:this._BetCoin, BetTime:this._BetTime, Rules:_loc_2, Status:this.Status, Password:this.BoardPassWord, maxPlayer:_loc_5, Solo:_loc_3, GopGa:_loc_4}, true));
            }
            else
            {
                dispatchEvent(new SettingEvent(SettingEvent.SETUP, {BetCoin:this._BetCoin, BetTime:this._BetTime, Rules:_loc_2, Status:this.Status, Password:this.BoardPassWord, Solo:_loc_3, GopGa:_loc_4}, true));
            }
            this.Hide();
            return;
        }// end function

        private function onChangeBetCoin(event:Event) : void
        {
            var _loc_2:* = Number(Format.removeDot(this.mainMovie.txtBetCoin.text));
            if (_loc_2 > this._MaxBet)
            {
                this.BetCoin = this._MaxBet;
            }
            else
            {
                this.BetCoin = _loc_2;
            }
            this.mainMovie.txtBetCoin.setSelection(this.mainMovie.txtBetCoin.text.length, this.mainMovie.txtBetCoin.text.length);
            return;
        }// end function

        public function get compoLuatGame() : ICompoLuat
        {
            return this._compoLuatGame;
        }// end function

        public function set compoLuatGame(param1:ICompoLuat) : void
        {
            this._compoLuatGame = param1;
            var _loc_2:* = this.mainMovie.getChildByName("compoLuatGame");
            if (_loc_2)
            {
                this.mainMovie.removeChild(_loc_2);
                _loc_2 = null;
            }
            if (this._compoLuatGame != null)
            {
                _loc_2 = this._compoLuatGame as DisplayObject;
                _loc_2.name = "compoLuatGame";
                this.mainMovie.addChild(_loc_2);
            }
            return;
        }// end function

        public function SetRule(param1:String) : void
        {
            if (this._compoLuatGame != null)
            {
                this._compoLuatGame.Rule = param1;
            }
            return;
        }// end function

        public function GetRules() : String
        {
            if (this._compoLuatGame != null)
            {
                return this._compoLuatGame.Rule;
            }
            return "";
        }// end function

        public function GetRuleString(param1:String) : String
        {
            if (this._compoLuatGame != null)
            {
                return this._compoLuatGame.getInviteString(param1);
            }
            return "";
        }// end function

        public function GetDefaultRule() : String
        {
            if (this._compoLuatGame != null)
            {
                return this._compoLuatGame.defaultRule();
            }
            return "";
        }// end function

        public function get TimeOut() : String
        {
            return this._TimeOut;
        }// end function

        public function set TimeOut(param1:String) : void
        {
            this._TimeOut = param1;
            this.BindDataCombo(this.mainMovie.cboTimeOut, this._TimeOut);
            return;
        }// end function

        public function get BetCoin() : Number
        {
            return this._BetCoin;
        }// end function

        public function set BetCoin(param1:Number) : void
        {
            this._BetCoin = param1;
            this.mainMovie.txtBetCoin.text = Format.Coin(this._BetCoin.toString());
            return;
        }// end function

        public function get BetTime() : int
        {
            return this._BetTime;
        }// end function

        public function set BetTime(param1:int) : void
        {
            var _loc_5:Array = null;
            this._BetTime = param1;
            var _loc_2:* = this._TimeOut.split(";");
            var _loc_3:* = _loc_2.length;
            var _loc_4:int = 0;
            while (_loc_4 < _loc_3)
            {
                
                _loc_5 = _loc_2[_loc_4].split(",");
                if (_loc_5[0] == param1.toString())
                {
                    this.mainMovie.cboTimeOut.selectedIndex = _loc_4;
                }
                _loc_4++;
            }
            return;
        }// end function

        public function get MaxBet() : Number
        {
            return this._MaxBet;
        }// end function

        public function set MaxBet(param1:Number) : void
        {
            param1 = param1 / 1000 * 1000;
            this._MaxBet = param1;
            return;
        }// end function

        public function get MinBet() : Number
        {
            return this._MinBet;
        }// end function

        public function set MinBet(param1:Number) : void
        {
            this._MinBet = param1;
            return;
        }// end function

        public function get Status() : String
        {
            return this._Status;
        }// end function

        public function set Status(param1:String) : void
        {
            this._Status = param1;
            return;
        }// end function

        private function BindDataCombo(param1:ComboBox, param2:String) : void
        {
            var _loc_5:Array = null;
            param1.removeAll();
            var _loc_3:* = param2.split(";");
            var _loc_4:int = 0;
            while (_loc_4 < _loc_3.length)
            {
                
                _loc_5 = _loc_3[_loc_4].split(",");
                param1.addItem({data:_loc_5[0], label:_loc_5[1]});
                _loc_4++;
            }
            this.GoValueCombo(param1, this._BetTime);
            return;
        }// end function

        private function GoValueCombo(param1:ComboBox, param2:int) : void
        {
            var _loc_3:int = 0;
            while (_loc_3 < param1.length)
            {
                
                if (int(param1.getItemAt(_loc_3).data) == param2)
                {
                    param1.selectedIndex = _loc_3;
                    break;
                }
                _loc_3++;
            }
            return;
        }// end function

        public function enableCheckBox(param1:Boolean) : void
        {
            return;
        }// end function

        public function enableBetCoin(param1:Boolean) : void
        {
            this.mainMovie.txtBetCoin.selectable = param1;
            var _loc_2:* = param1 ? (1) : (0.3);
            this.mainMovie.settingResource.phinh_min.mouseEnabled = param1;
            this.mainMovie.settingResource.phinh_1.mouseEnabled = param1;
            this.mainMovie.settingResource.phinh_5.mouseEnabled = param1;
            this.mainMovie.settingResource.phinh_10.mouseEnabled = param1;
            this.mainMovie.settingResource.phinh_50.mouseEnabled = param1;
            this.mainMovie.settingResource.phinh_100.mouseEnabled = param1;
            this.mainMovie.settingResource.clearBetcoin_btn.enabled = param1;
            this.mainMovie.radioNghinGold.enabled = param1;
            this.mainMovie.radioTrieuGold.enabled = param1;
            this.mainMovie.settingResource.phinh_min.alpha = _loc_2;
            this.mainMovie.settingResource.phinh_1.alpha = _loc_2;
            this.mainMovie.settingResource.phinh_5.alpha = _loc_2;
            this.mainMovie.settingResource.phinh_10.alpha = _loc_2;
            this.mainMovie.settingResource.phinh_50.alpha = _loc_2;
            this.mainMovie.settingResource.phinh_100.alpha = _loc_2;
            this.mainMovie.settingResource.clearBetcoin_btn.alpha = _loc_2;
            this.mainMovie.radioNghinGold.alpha = _loc_2;
            this.mainMovie.radioTrieuGold.alpha = _loc_2;
            return;
        }// end function

        public function enableButtons(param1:Boolean) : void
        {
            var _loc_2:Room = null;
            this.mainMovie.settingResource.btnSetup.visible = param1;
            this.mainMovie.txtBetCoin.selectable = param1;
            this.mainMovie.cboTimeOut.mouseEnabled = param1;
            this.mainMovie.cboTimeOut.mouseChildren = param1;
            this.mainMovie.txtBetCoin.alpha = param1 ? (1) : (0.6);
            this.mainMovie.cboTimeOut.alpha = param1 ? (1) : (0.6);
            if (this._compoLuatGame != null)
            {
                this.compoLuatGame.showEnable(param1);
            }
            if (param1)
            {
                _loc_2 = this.gameLoader.global.MyInfo.joinedRoom;
                this.updateCustomMaxPlayer(_loc_2.getPlayerList().length, RoomInfo.fromRoom(_loc_2).getCustomMaxPlayer());
            }
            if (this._compoLuatGame)
            {
                this._compoLuatGame.enableOptionSolo = param1;
            }
            this.mainMovie.chk_gopGa.enabled = param1;
            if ((this.gameLoader.global.isGameTLMN || this.gameLoader.global.isGameSam) && this.gameLoader.global.isB() == false)
            {
                this.mainMovie.chk_gopGa.visible = true;
                if (!this.mainMovie.chk_gopGa.selected && this.mainMovie.chk_gopGa.enabled)
                {
                    this.mainMovie.chk_gopGa.enabled = true;
                }
                else
                {
                    this.mainMovie.chk_gopGa.enabled = false;
                    this.enableBetCoin(false);
                    if (RoomInfo.fromRoom(this.gameLoader.global.MyInfo.joinedRoom).isSetupFirstTime)
                    {
                        if (this._compoLuatGame != null)
                        {
                            this.compoLuatGame.showEnable(false);
                        }
                    }
                }
            }
            else
            {
                this.mainMovie.chk_gopGa.visible = false;
            }
            return;
        }// end function

        public function Hide() : void
        {
            this.visible = false;
            this.stopDrag();
            if (this.mainMovie.cboTimeOut.selectedItem == null)
            {
                return;
            }
            if (int(this.mainMovie.cboTimeOut.selectedItem.data) != this._BetTime)
            {
                this.GoValueCombo(this.mainMovie.cboTimeOut, this._BetTime);
            }
            if (this.gameLoader.isLobby())
            {
                return;
            }
            if (this.gameLoader.global.gameID != GlobalConstants.PokerGameId && this.gameLoader.global.gameID != GlobalConstants.LiengId)
            {
                return;
            }
            return;
        }// end function

        private function IsNormalSize() : Boolean
        {
            return true;
        }// end function

        private function AdjustSize() : void
        {
            if (this.IsNormalSize())
            {
            }
            return;
        }// end function

        final public function removeCompoLuat() : void
        {
            var _loc_1:* = this.mainMovie.getChildByName("compoLuatGame");
            if (_loc_1)
            {
                this.mainMovie.removeChild(_loc_1);
            }
            return;
        }// end function

        public function HideAllExtendControl() : void
        {
            return;
        }// end function

        public function ShowForNextMatch(param1:Boolean = true) : void
        {
            this.visible = true;
            this.mainMovie.settingResource.btn_Close.visible = param1;
            this.ShowExtendSetting(null);
            if ((this.gameLoader.global.isGameTLMN || this.gameLoader.global.isGameSam) && this.gameLoader.global.isB() == false)
            {
                this.mainMovie.chk_gopGa.visible = true;
                if (!this.mainMovie.chk_gopGa.selected && this.mainMovie.chk_gopGa.enabled)
                {
                    this.mainMovie.chk_gopGa.enabled = true;
                }
                else
                {
                    this.mainMovie.chk_gopGa.enabled = false;
                    this.enableBetCoin(false);
                    if (RoomInfo.fromRoom(this.gameLoader.global.MyInfo.joinedRoom).isSetupFirstTime)
                    {
                        if (this._compoLuatGame != null)
                        {
                            this.compoLuatGame.showEnable(false);
                        }
                    }
                }
            }
            else
            {
                this.mainMovie.chk_gopGa.visible = false;
            }
            this.mainMovie.updateStateOfControl();
            return;
        }// end function

        public function Show(param1:Boolean = true) : void
        {
            this.visible = true;
            this.mainMovie.settingResource.Error_txt.text = "";
            this.mainMovie.settingResource.btn_Close.visible = param1;
            this.ShowExtendSetting(null);
            var _loc_2:* = this.gameLoader.global.MyInfo.joinedRoom;
            this.updateCustomMaxPlayer(_loc_2.getPlayerList().length, RoomInfo.fromRoom(_loc_2).getCustomMaxPlayer());
            var _loc_3:* = RoomInfo.fromRoom(_loc_2);
            if ((this.gameLoader.global.isGameTLMN || this.gameLoader.global.isGameSam) && this.gameLoader.global.isB() == false)
            {
                this.mainMovie.chk_gopGa.visible = true;
                this.mainMovie.chk_gopGa.x = 53;
                this.mainMovie.chk_gopGa.y = 266;
                if (this._compoLuatGame != null)
                {
                    this.mainMovie.chk_gopGa.y = (this._compoLuatGame as DisplayObject).y + (this._compoLuatGame as DisplayObject).height + 10;
                }
                if (!this.mainMovie.chk_gopGa.selected && this.mainMovie.chk_gopGa.enabled)
                {
                    this.mainMovie.chk_gopGa.enabled = true;
                }
                else
                {
                    this.mainMovie.chk_gopGa.enabled = false;
                    this.enableBetCoin(false);
                    if (RoomInfo.fromRoom(this.gameLoader.global.MyInfo.joinedRoom).isSetupFirstTime)
                    {
                        if (this._compoLuatGame != null)
                        {
                            this.compoLuatGame.showEnable(false);
                        }
                    }
                }
            }
            else
            {
                this.mainMovie.chk_gopGa.visible = false;
            }
            this.mainMovie.updateStateOfControl();
            return;
        }// end function

        final public function updateCustomMaxPlayer(param1:int, param2:int) : void
        {
            this.mainMovie.settingResource.maxPlayer_tf.visible = false;
            this.mainMovie.cboMaxPlayer.visible = false;
            if (this.gameLoader.isLobby())
            {
                return;
            }
            if (this.gameLoader.global.gameID != GlobalConstants.PokerGameId)
            {
                return;
            }
            var _loc_3:* = RoomInfo.fromRoom(this.gameLoader.global.MyInfo.joinedRoom);
            if (_loc_3.isDefault || this.gameLoader.global.MyInfo.isRoomOwner == false)
            {
                return;
            }
            this.mainMovie.cboMaxPlayer.visible = true;
            this.mainMovie.settingResource.maxPlayer_tf.visible = true;
            if (param1 < this.gameLoader.global.minPlayer)
            {
                param1 = this.gameLoader.global.minPlayer;
            }
            var _loc_4:Array = [];
            var _loc_5:int = 0;
            var _loc_6:int = 1;
            while (_loc_6 <= this.gameLoader.global.maxPlayer)
            {
                
                if (_loc_6 >= param1)
                {
                    _loc_4.push({data:_loc_6, label:_loc_6});
                    if (param2 == _loc_6)
                    {
                        _loc_5 = _loc_4.length - 1;
                    }
                }
                _loc_6++;
            }
            this.BindDataCombo(this.mainMovie.cboMaxPlayer, this.mainMovie.getMaxPlayerValue());
            this.GoValueCombo(this.mainMovie.cboMaxPlayer, param2);
            return;
        }// end function

        private function ShowExtendSetting(event:MouseEvent) : void
        {
            if (this._compoLuatGame != null && !this.mainMovie.contains(this._compoLuatGame as DisplayObject))
            {
                this.compoLuatGame = this._compoLuatGame;
            }
            switch(this.gameLoader.global.gameID)
            {
                case GlobalConstants.BinhGameId:
                {
                    this.AlignBinh();
                    break;
                }
                case GlobalConstants.TienlenMNGame41Id:
                case GlobalConstants.TienlenMNGameId:
                {
                    this.AlignTienlen();
                    break;
                }
                case GlobalConstants.U9LaGameId:
                {
                    this.AlignU();
                    break;
                }
                case GlobalConstants.XiToGameId:
                {
                    this.AlignXito();
                    break;
                }
                case GlobalConstants.PokerGameId:
                {
                    this.AlignPoker();
                    break;
                }
                case GlobalConstants.LiengId:
                {
                    this.AlignLieng();
                    break;
                }
                case GlobalConstants.SamId:
                {
                    this.AlignSam();
                    break;
                }
                case GlobalConstants.DanhChanBetaId:
                {
                    this.AlignDanhChanBeta();
                    break;
                }
                case GlobalConstants.DanhChanGameId:
                {
                    this.AlignDanhChan();
                    break;
                }
                case GlobalConstants.CoCaNguaId:
                {
                    this.AlignCoCaNgua();
                    break;
                }
                default:
                {
                    break;
                }
            }
            if (this._compoLuatGame != null)
            {
                if (this.gameLoader.currentScreen == GlobalConstants.LOBBY_SCREEN)
                {
                    this._compoLuatGame.showOptionSolo();
                }
                else if (this.gameLoader.global.isRoomDefault)
                {
                    this._compoLuatGame.hideOptionSolo();
                }
                else
                {
                    this._compoLuatGame.showOptionSolo();
                }
            }
            return;
        }// end function

        private function AlignSam() : void
        {
            return;
        }// end function

        private function AlignBinh() : void
        {
            return;
        }// end function

        private function AlignTienlen() : void
        {
            if (this._compoLuatGame != null)
            {
                (this._compoLuatGame as DisplayObject).visible = true;
            }
            return;
        }// end function

        private function AlignU() : void
        {
            if (this._compoLuatGame != null)
            {
                (this._compoLuatGame as DisplayObject).visible = true;
            }
            return;
        }// end function

        private function AlignXito() : void
        {
            var _loc_1:DisplayObject = null;
            if (this._compoLuatGame != null)
            {
                _loc_1 = this._compoLuatGame as DisplayObject;
                _loc_1.visible = true;
            }
            return;
        }// end function

        private function AlignPoker() : void
        {
            return;
        }// end function

        private function AlignLieng() : void
        {
            return;
        }// end function

        private function AlignDanhChan() : void
        {
            return;
        }// end function

        private function AlignDanhChanBeta() : void
        {
            return;
        }// end function

        final public function handleUIForTaiXiu(param1:Boolean = false) : void
        {
            return;
        }// end function

        private function AlignCoCaNgua() : void
        {
            return;
        }// end function

        final public function resetUI() : void
        {
            return;
        }// end function

    }
}
