package 
{
    import CompoTooltipChat.*;
    import flash.events.*;
    import flash.text.*;
    import flash.utils.*;
    import mgame.manager.*;

    public class CompoTooltipChat extends MGSprite
    {
        public var theTip:MGSprite;
        public var theText:TextField;
        private var messageChat:String = "";
        private var orient:int = 2;
        private var totalMessage:int = 0;
        private var timer:Timer = null;
        public var useTimer:Boolean = true;
        private var timeAppear:int = 1500;
        public static const TOP_RIGHT:int = 1;
        public static const TOP_LEFT:int = 2;
        public static const BOTTOM_LEFT:int = 3;
        public static const BOTTOM_RIGHT:int = 4;

        public function CompoTooltipChat()
        {
            this.theTip = new MGSprite();
            this.theTip.name = "theTip";
            this.theText = new TextField();
            this.theText.x = 3;
            this.theText.y = 1;
            this.theText.width = 300;
            this.theText.height = 20;
            this.theText.name = "theText";
            this.theText.autoSize = "center";
            this.theText.selectable = false;
            this.theText.wordWrap = true;
            var _loc_1:* = new TextFormat();
            _loc_1.font = "Arial";
            _loc_1.size = 28;
            _loc_1.align = "left";
            _loc_1.color = 0;
            _loc_1.bold = true;
            this.theText.defaultTextFormat = _loc_1;
            this.theTip.addChild(this.theText);
            this.theTip.visible = false;
            this.addChild(this.theTip);
            return;
        }// end function

        public function set MessageChat(param1:String) : void
        {
            this.messageChat = param1;
            return;
        }// end function

        public function set Orient(param1:int) : void
        {
            this.orient = param1;
            return;
        }// end function

        public function Show() : void
        {
            this.visible = true;
            return;
        }// end function

        public function Hide() : void
        {
            this.visible = false;
            return;
        }// end function

        private function WaitTimeOut(event:TimerEvent) : void
        {
            var _loc_2:String = this;
            var _loc_3:* = this.totalMessage - 1;
            _loc_2.totalMessage = _loc_3;
            switch(this.orient)
            {
                case TOP_RIGHT:
                case TOP_LEFT:
                {
                    if (this.messageChat.indexOf("\r") == -1)
                    {
                        this.messageChat = "";
                        if (this.theText)
                        {
                            this.theText.text = "";
                        }
                    }
                    else
                    {
                        this.messageChat = this.messageChat.substr((this.messageChat.indexOf("\r") + 1), this.messageChat.length);
                    }
                    break;
                }
                case BOTTOM_RIGHT:
                case BOTTOM_LEFT:
                {
                    if (this.messageChat.lastIndexOf("\r") == -1)
                    {
                        this.messageChat = "";
                        if (this.theText)
                        {
                            this.theText.text = "";
                        }
                    }
                    else
                    {
                        this.messageChat = this.messageChat.substr(0, this.messageChat.lastIndexOf("\r"));
                    }
                    break;
                }
                default:
                {
                    break;
                }
            }
            if (this.totalMessage == 0)
            {
                this.timer.stop();
                if (this.theText)
                {
                    this.theText.text = "";
                }
                this.messageChat = "";
                this.Hide();
            }
            else
            {
                this.Show();
            }
            this.drawTooltip();
            return;
        }// end function

        private function drawTooltip() : void
        {
            this.removeTip();
            if (this.totalMessage == 0)
            {
                this.Hide();
                return;
            }
            if (this.messageChat == "")
            {
                return;
            }
            if (this.useTimer)
            {
                if (this.totalMessage == 1 && this.timer == null)
                {
                    this.timer = new Timer(this.timeAppear);
                    this.timer.addEventListener(TimerEvent.TIMER, this.WaitTimeOut);
                    this.timer.start();
                }
                if (this.timer && this.timer.running == false && this.totalMessage > 0)
                {
                    this.timer.start();
                }
            }
            this.Show();
            this.showTip(this.messageChat, this.orient);
            switch(this.orient)
            {
                case TOP_RIGHT:
                {
                    this.theTip.x = 0;
                    break;
                }
                case TOP_LEFT:
                {
                    if (this.theText.textWidth >= 150)
                    {
                        this.theTip.x = 150 - this.theText.textWidth;
                    }
                    else
                    {
                        this.theTip.x = 10;
                    }
                    break;
                }
                case BOTTOM_LEFT:
                {
                    if (this.theText.textWidth >= 150)
                    {
                        this.theTip.x = 150 - this.theText.textWidth;
                    }
                    else
                    {
                        this.theTip.x = 10;
                    }
                    this.theTip.y = 75;
                    break;
                }
                case BOTTOM_RIGHT:
                {
                    this.theTip.x = 0;
                    this.theTip.y = 75;
                    break;
                }
                default:
                {
                    break;
                }
            }
            return;
        }// end function

        public function AppendText(param1:String, param2:int = 1500) : void
        {
            if (this.totalMessage == 4)
            {
                return;
            }
            var _loc_3:String = this;
            var _loc_4:* = this.totalMessage + 1;
            _loc_3.totalMessage = _loc_4;
            switch(this.orient)
            {
                case TOP_RIGHT:
                case TOP_LEFT:
                {
                    if (this.messageChat != "")
                    {
                        this.messageChat = this.messageChat + ("\r" + param1);
                    }
                    else
                    {
                        this.messageChat = this.messageChat + param1;
                    }
                    break;
                }
                case BOTTOM_RIGHT:
                case BOTTOM_LEFT:
                {
                    if (this.messageChat != "")
                    {
                        this.messageChat = param1 + "\r" + this.messageChat;
                    }
                    else
                    {
                        this.messageChat = this.messageChat + param1;
                    }
                    break;
                }
                default:
                {
                    break;
                }
            }
            this.timeAppear = param2;
            this.drawTooltip();
            return;
        }// end function

        private function draw_baloon(param1:Number, param2:Number, param3:Number, param4:Number, param5:Number, param6:Number) : void
        {
            var _loc_7:* = this.theText as TextField;
            var _loc_8:int = 10;
            if (_loc_7.textWidth >= 150)
            {
                _loc_8 = 150 - _loc_7.textWidth;
            }
            var _loc_9:Number = 3;
            var _loc_10:* = param3 / 2;
            this.theTip.graphics.clear();
            this.theTip.graphics.beginFill(15850335, 80);
            this.theTip.graphics.lineStyle(1, 15850335, 80);
            this.theTip.graphics.moveTo(_loc_9, 0);
            if (param5 == 1)
            {
                if (param6 == 4)
                {
                    this.theTip.graphics.lineTo(30, 0);
                    this.theTip.graphics.lineTo(32, param2 + 7);
                    this.theTip.graphics.lineTo(45, 0);
                }
                else if (param6 == 3)
                {
                    this.theTip.graphics.lineTo(30 - _loc_8, 0);
                    this.theTip.graphics.lineTo(40 - _loc_8, param2 + 7);
                    this.theTip.graphics.lineTo(42 - _loc_8, 0);
                }
            }
            this.theTip.graphics.lineTo(param3 - _loc_9, 0);
            this.theTip.graphics.curveTo(param3, 0, param3, _loc_9);
            this.theTip.graphics.lineTo(param3, param4 - _loc_9);
            this.theTip.graphics.curveTo(param3, param4, param3 - _loc_9, param4);
            if (param5 != 1)
            {
                if (param6 == 2)
                {
                    this.theTip.graphics.lineTo(33 - _loc_8, param4);
                    this.theTip.graphics.lineTo(45 - _loc_8, param2 - 7);
                    this.theTip.graphics.lineTo(46 - _loc_8, param4);
                }
                else if (param6 == 1)
                {
                    this.theTip.graphics.lineTo(55, param4);
                    this.theTip.graphics.lineTo(35, param2 - 7);
                    this.theTip.graphics.lineTo(39, param4);
                }
            }
            this.theTip.graphics.lineTo(_loc_9, param4);
            this.theTip.graphics.curveTo(0, param4, 0, param4 - _loc_9);
            this.theTip.graphics.lineTo(0, _loc_9);
            this.theTip.graphics.curveTo(0, 0, _loc_9, 0);
            this.theTip.graphics.endFill();
            return;
        }// end function

        private function showTip(param1:String, param2:Number, param3:Number = 0, param4:Number = 0, param5:Number = 0) : void
        {
            var _loc_10:Number = NaN;
            var _loc_11:Number = NaN;
            var _loc_12:Number = NaN;
            var _loc_6:* = this.theText;
            _loc_6.text = param1;
            var _loc_7:* = _loc_6.textWidth + 12;
            var _loc_8:* = _loc_6.textHeight + 6;
            switch(param2)
            {
                case 1:
                case 2:
                {
                    param5 = 0;
                    break;
                }
                case 3:
                case 4:
                {
                    param5 = 1;
                    break;
                }
                default:
                {
                    break;
                }
            }
            if (_loc_7 < 150)
            {
                _loc_7 = 150;
            }
            if (_loc_7 > 335)
            {
                _loc_7 = 335;
            }
            if (_loc_8 < 10)
            {
                _loc_8 = 10;
            }
            var _loc_9:Number = 20;
            if (param4 + _loc_7 < _loc_7 + 32)
            {
                _loc_10 = 8;
            }
            else
            {
                _loc_10 = param3 - 26;
            }
            this.theTip.x = _loc_10;
            if (param5 == 1)
            {
                _loc_11 = param4 + _loc_9;
            }
            else
            {
                _loc_11 = param4 - (_loc_9 + _loc_8);
            }
            this.theTip.y = _loc_11;
            this.draw_baloon(param3 - _loc_10, param4 - _loc_11, _loc_7, _loc_8, param5, param2);
            this.theTip.visible = true;
            return;
        }// end function

        private function removeTip() : void
        {
            if (this.theTip)
            {
                this.theTip.visible = false;
            }
            return;
        }// end function

        override public function dispose() : void
        {
            super.dispose();
            this.theTip = null;
            this.theText = null;
            return;
        }// end function

    }
}
