package 
{
    import GameLoader.*;
    import MGameEvents.*;
    import __AS3__.vec.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.media.*;
    import flash.net.*;
    import flash.system.*;
    import flash.text.*;
    import flash.ui.*;
    import flash.utils.*;
    import net.king.*;
    import net.king.client.*;
    import net.mgame.*;
    import net.mgame.controllers.*;
    import net.mgame.keys.*;
    import net.mgame.ui.*;

    public class GameLoader extends Sprite implements IGameLoader
    {
        public var isDebug:Boolean = false;
        public var preloader:Object;
        public var global:Global;
        public var lobbyScreen:LobbyScreen;
        public var gameScreen:GameScreen;
        public var globalComponents:GlobalComponents;
        public var controller:GameLoaderController;
        public var globalListeners:GlobalListeners;
        private var _currentScreen:int = 0;
        private var lobbyMusicOfTaiXiu:SoundChannel;
        public var listDefaultBoardMaxTay:Array;
        public var appScaleSize:Number = 1;
        public var appRealWidth:Number = 1280;
        public var appRealHeight:Number = 720;
        public var headerHeight:Number = 80;
        private var headerTextFormat:TextFormat;
        private static var instance:GameLoader = null;

        public function GameLoader() : void
        {
            this.listDefaultBoardMaxTay = [];
            if (instance == null)
            {
                if (stage)
                {
                    this.init();
                }
                else
                {
                    addEventListener(Event.ADDED_TO_STAGE, this.init);
                }
                instance = this;
            }
            else
            {
                return;
            }
            return;
        }// end function

        public function get currentScreen() : int
        {
            return this._currentScreen;
        }// end function

        private function init(event:Event = null) : void
        {
            this.appScaleSize = stage.stageWidth / this.appRealWidth;
            this.headerHeight = this.getScaleHorizontal(80);
            KF.socket = KingClient.getInstance();
            KF.stage = stage;
            KF.stage.focus = stage;
            KF.stage.stageFocusRect = false;
            KF.stage.align = StageAlign.TOP_LEFT;
            removeEventListener(Event.ADDED_TO_STAGE, this.init);
            this.tabChildren = false;
            this.tabEnabled = false;
            this.preloader = this.parent;
            if (this.global == null)
            {
                this.global = new Global();
            }
            if (this.globalComponents == null)
            {
                this.globalComponents = new GlobalComponents(this);
            }
            if (this.lobbyScreen == null)
            {
                this.lobbyScreen = new LobbyScreen(this);
            }
            if (this.gameScreen == null)
            {
                this.gameScreen = new GameScreen(this);
            }
            if (this.controller == null)
            {
                this.controller = new GameLoaderController(this);
            }
            if (this.globalListeners == null)
            {
                this.globalListeners = new GlobalListeners(this);
            }
            var _loc_2:* = new TextFormat("Aria", 12, 16777215, true);
            var _loc_3:* = new Label();
            _loc_3.setStyle("textFormat", _loc_2);
            _loc_3.text = "Disconnect";
            _loc_3.name = "DisconnectTest";
            _loc_3.autoSize = TextFieldAutoSize.CENTER;
            _loc_3.width = 60 * this.appScaleSize;
            _loc_3.height = 17 * this.appScaleSize;
            _loc_3.buttonMode = true;
            _loc_3.mouseChildren = false;
            _loc_3.graphics.beginFill(0, 0.75);
            _loc_3.graphics.drawRect(0, 0, _loc_3.width, _loc_3.height);
            _loc_3.graphics.endFill();
            _loc_3.x = 0;
            _loc_3.y = this.getScaleVertical(100);
            _loc_3.addEventListener(MouseEvent.CLICK, this.onlblDisconnectClicked);
            return;
        }// end function

        private function onlblDisconnectClicked(event:MouseEvent) : void
        {
            this.controller.pingTimer.reset();
            setTimeout(this.disconnect, 6000);
            return;
        }// end function

        private function disconnect() : void
        {
            KF.socket.disconnectToReconnect(this.global.socketKey, this.global.timeToDelayReconnect);
            return;
        }// end function

        final public function setToCenterPoint(param1:DisplayObject) : void
        {
            if (stage)
            {
                param1.x = this.stage.fullScreenWidth - param1.width >> 1;
                param1.y = this.stage.fullScreenHeight - param1.height >> 1;
            }
            return;
        }// end function

        final public function goToLobbyScreen() : void
        {
            var _loc_1:String = null;
            this.lobbyScreen.compoListGame.active();
            if (this.isLobby())
            {
                return;
            }
            this.global.inviteBetCoin = 0;
            if (this.global.isGameTaiXiu)
            {
                _loc_1 = this.preloader.urlGamePath.getBackgroundMusic(this.global.gameID);
                this.preloader.backgroundMusic = new Sound(new URLRequest(_loc_1));
                this.preloader.backgroundMusic.addEventListener(Event.COMPLETE, this.onLoadSoundComplete);
            }
            if (this.global.isGameSam || this.global.isGameTLMN)
            {
                this.gameScreen.jackPot.hide();
            }
            KF.stage.focus = this;
            this.hideComponentNotUsed();
            this._currentScreen = GlobalConstants.LOBBY_SCREEN;
            this.lobbyScreen.visible = true;
            this.addChildAt(this.lobbyScreen, 0);
            this.lobbyScreen.compoBottomBarInGame.visible = true;
            if (this.contains(this.gameScreen))
            {
                try
                {
                }
                catch (e:Error)
                {
                }
                this.removeChild(this.gameScreen);
            }
            if (this.globalComponents._compoSetting)
            {
                this.globalComponents.compoSetting.Hide();
            }
            this.gameScreen.clearUI();
            this.global.stopTimerToUpdateTimePlay();
            this.globalComponents.compoChat.Hide();
            this.globalComponents.compoChat.clearContent();
            this.googleTrack(true);
            this.preloader.showLog("-------->goToLobbyScreen");
            return;
        }// end function

        private function onLoadSoundComplete(event:Event) : void
        {
            if (this.preloader.backgroundMusic == null)
            {
                return;
            }
            this.preloader.backgroundMusicChannel = this.preloader.backgroundMusic.play();
            return;
        }// end function

        final public function goToGameScreen() : void
        {
            if (this.isGame())
            {
                return;
            }
            if (this.global.isGameTaiXiu)
            {
                if (this.preloader.backgroundMusicChannel)
                {
                    this.preloader.backgroundMusicChannel.stop();
                }
            }
            this.hideComponentNotUsed();
            this._currentScreen = GlobalConstants.GAME_SCREEN;
            this.gameScreen.visible = true;
            this.addChildAt(this.gameScreen, 0);
            this.lobbyScreen.destroy();
            if (this.contains(this.lobbyScreen))
            {
                this.removeChild(this.lobbyScreen);
            }
            this.gameScreen.refreshUI();
            this.globalComponents.compoChat.Hide();
            this.globalComponents.compoChat.clearContent();
            this.googleTrack(false);
            return;
        }// end function

        public function createResources(param1:Object, param2:Object, param3:Object) : void
        {
            this.global.updateConfig(param2);
            this.refreshComponentsForNewGame();
            this.gameScreen.setGame(param1, param3);
            this.goToLobbyScreen();
            this.lobbyScreen.listBoard.showLoading();
            return;
        }// end function

        public function connect() : void
        {
            KF.socket.defaultSocket = this.global.socketKey;
            if (!KF.socket.isConnected(this.global.socketKey))
            {
                KF.socket.connectSocket(this.global.socketKey, this.global.timeToDelayReconnect, this.global.numRepeatReconnect, 30000);
            }
            else
            {
                this.lobbyScreen.listBoard.endLoad();
            }
            return;
        }// end function

        final public function setWebConfig(param1:Object) : void
        {
            this.global.updateWebConfig(param1);
            this.lobbyScreen.headerLobbyInfo.GameName = this.global.GetGameName(this.global.gameID);
            if (this.global.isJoinAnotherGameInLobby)
            {
                this.connect();
            }
            else
            {
                setTimeout(this.connect, 500);
            }
            this.global.isJoinAnotherGameInLobby = false;
            return;
        }// end function

        final public function isLobby() : Boolean
        {
            return this.currentScreen == GlobalConstants.LOBBY_SCREEN;
        }// end function

        final public function isGame() : Boolean
        {
            return this.currentScreen == GlobalConstants.GAME_SCREEN;
        }// end function

        public function hideComponentNotUsed() : void
        {
            var _loc_2:DisplayObject = null;
            var _loc_1:String = "";
            var _loc_3:* = this.numChildren - 1;
            while (_loc_3 >= 0)
            {
                
                _loc_2 = this.getChildAt(_loc_3);
                _loc_1 = _loc_2.name;
                _loc_2.visible = false;
                _loc_2 = null;
                _loc_3 = _loc_3 - 1;
            }
            return;
        }// end function

        private function initContextMenu(param1:Object) : void
        {
            var _loc_2:* = new ContextMenu();
            this.contextMenu = _loc_2;
            var _loc_3:* = param1.GameLoaderVersion;
            var _loc_4:* = this.getGameVersion(param1.GameVersion, this.global.gameID);
            var _loc_5:* = new ContextMenuItem("Loader version: " + _loc_3);
            var _loc_6:* = new ContextMenuItem("Game version: " + _loc_4);
            _loc_2.customItems.push(_loc_5, _loc_6);
            _loc_2 = null;
            _loc_5 = null;
            _loc_3 = null;
            _loc_4 = null;
            _loc_6 = null;
            param1 = null;
            return;
        }// end function

        private function getGameVersion(param1:Object, param2:int) : String
        {
            var _loc_3:Object = null;
            var _loc_4:String = "";
            var _loc_5:int = 0;
            while (_loc_5 < param1.length)
            {
                
                _loc_3 = param1[_loc_5];
                if (_loc_3.ID == param2)
                {
                    _loc_4 = _loc_3.Value;
                    break;
                }
                _loc_3 = null;
                _loc_5++;
            }
            _loc_3 = null;
            return _loc_4;
        }// end function

        public function get soundOn() : Boolean
        {
            if (this.preloader)
            {
                return this.preloader.soundOn;
            }
            return false;
        }// end function

        public function set soundOn(param1:Boolean) : void
        {
            if (this.preloader)
            {
                this.preloader.soundOn = param1;
            }
            return;
        }// end function

        public function get shakeOn() : Boolean
        {
            if (this.preloader)
            {
                return this.preloader.shakeOn;
            }
            return false;
        }// end function

        public function set shakeOn(param1:Boolean) : void
        {
            if (this.preloader)
            {
                this.preloader.shakeOn = param1;
            }
            return;
        }// end function

        public function getScaleHorizontal(param1:Number) : Number
        {
            if (this.stage != null)
            {
                return param1 / this.appRealWidth * this.stage.stageWidth;
            }
            return param1 / this.appRealWidth * this.preloader.stage.stageWidth;
        }// end function

        public function getScaleVertical(param1:Number) : Number
        {
            if (this.stage != null)
            {
                return param1 / this.appRealHeight * this.stage.stageHeight;
            }
            return param1 / this.appRealHeight * this.preloader.stage.stageHeight;
        }// end function

        public function createHeader(param1:String, param2:Number, param3:Number = 0.2) : Sprite
        {
            var _loc_4:* = new Sprite();
            if (param3 != 0)
            {
                _loc_4.graphics.beginFill(0, param3);
                _loc_4.graphics.drawRect(0, 0, this.stage.stageWidth, param2);
                _loc_4.graphics.endFill();
            }
            _loc_4.mouseEnabled = false;
            if (this.headerTextFormat == null)
            {
                this.headerTextFormat = new TextFormat("Arial", 45, 16777215, true);
                this.headerTextFormat.align = TextFormatAlign.CENTER;
            }
            var _loc_5:* = new TextField();
            _loc_5.name = "title";
            _loc_5.selectable = false;
            _loc_5.defaultTextFormat = this.headerTextFormat;
            _loc_5.width = 500;
            _loc_5.height = 55;
            _loc_5.text = param1;
            _loc_5.mouseEnabled = false;
            _loc_5.mouseWheelEnabled = false;
            _loc_5.scaleX = this.appScaleSize;
            _loc_5.scaleY = this.appScaleSize;
            _loc_5.y = param2 - _loc_5.height >> 1;
            _loc_5.x = (this.stage.stageWidth - _loc_5.width) * 0.5;
            _loc_5.cacheAsBitmap = true;
            _loc_4.addChild(_loc_5);
            return _loc_4;
        }// end function

        public function onBack() : void
        {
            if (this.isLobby())
            {
                this.lobbyScreen.onBack();
            }
            else if (this.isGame())
            {
                this.dispatchEvent(new HeaderEvent(HeaderEvent.GO_BACK_TO_PHONGCHO, null));
            }
            return;
        }// end function

        public function refreshComponentsForNewGame() : void
        {
            this.globalComponents.refreshComponents();
            return;
        }// end function

        public function playSoundClick() : void
        {
            this.preloader.playSoundClick();
            return;
        }// end function

        private function googleTrack(param1:Boolean) : void
        {
            var _loc_2:* = this.global.GetGameName(this.global.gameID);
            if (param1)
            {
                this.preloader.viewBuild("Looby-" + _loc_2);
            }
            else
            {
                this.preloader.viewBuild("PlayGame-" + _loc_2);
            }
            return;
        }// end function

        public function onOpenChat() : void
        {
            if (this.globalComponents.compoChat.visible == false)
            {
                this.globalComponents.compoChat.Show();
            }
            else
            {
                this.globalComponents.compoChat.Hide();
            }
            return;
        }// end function

        public function get isIOS() : Boolean
        {
            return Capabilities.manufacturer.indexOf("iOS") > -1;
        }// end function

        final public function updateCoinUser() : void
        {
            this.controller.sendRequestUpdateMyCoin();
            return;
        }// end function

        public function drawTextureOfAtlas(param1:String, param2:Object, param3:int, param4:String, param5:int = 0, param6:int = 0, param7:int = 0) : void
        {
            this.preloader.drawTextureOfAtlas(param1, param2, param3, param4, param5, param6, param7);
            return;
        }// end function

        public function drawBitmap(param1:String, param2:Object, param3:int, param4:int = 0, param5:int = 0) : void
        {
            this.preloader.drawBitmap(param1, param2, param3, param4, param5);
            return;
        }// end function

        public function getBitmapDataTextureOfAtlas(param1:String, param2:int, param3:String) : BitmapData
        {
            return this.preloader.getBitmapDataTextureOfAtlas(param1, param2, param3);
        }// end function

        public function getNamesOfAtlas(param1:String, param2:String, param3:int) : Vector.<String>
        {
            return this.preloader.getNamesOfAtlas(param1, param2, param3);
        }// end function

        public function getRegionOfAtlas(param1:String, param2:String, param3:int) : Rectangle
        {
            return this.preloader.getRegionOfAtlas(param1, param2, param3);
        }// end function

        public function getBitmapDataOfAtlas(param1:String, param2:int) : BitmapData
        {
            return this.preloader.getBitmapDataOfAtlas(param1, param2);
        }// end function

        public static function getInstance() : GameLoader
        {
            return instance;
        }// end function

        public static function get isAndroid() : Boolean
        {
            return Capabilities.manufacturer.indexOf("Android") > -1;
        }// end function

    }
}
