package HeaderLobbyInfo.as$352
{
    import MGameEvents.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    import net.mgame.lobby.*;

    class roomDetail extends MovieClip
    {
        public var roomId:int;
        public var roomName:String;
        public var quantity:int;
        public var serverAndPort:String;
        public var maxConnection:int;
        public var minJoinRoom:Number;
        public var rangeOfBet:String;
        public var roomType:int;
        public var mmax:Array = null;
        public var MinCoin:Number;
        public var MaxCoin:Number;
        private var gameLoader:GameLoader;
        public var roomName_txt:TextField;
        public var selection_mc:RoomBtn;
        private var selectRoomFunction:Function;

        function roomDetail(param1:Array, param2:Function) : void
        {
            this.gameLoader = GameLoader.getInstance();
            this.selectRoomFunction = param2;
            this.roomId = param1[0];
            this.roomName = param1[1];
            this.quantity = param1[2];
            this.serverAndPort = param1[3];
            this.maxConnection = param1[4];
            this.minJoinRoom = param1[5];
            this.rangeOfBet = param1[6];
            this.roomType = param1[7];
            this.mmax = this.rangeOfBet.split(":");
            this.MinCoin = Number(this.mmax[0]);
            this.MaxCoin = Number(this.mmax[1]);
            this.selection_mc = new RoomBtn();
            this.selection_mc.y = 8;
            this.selection_mc.lblRoomName.text = this.roomName;
            this.selection_mc.lblRoomNameActive.text = this.roomName;
            this.addChild(this.selection_mc);
            this.addEventListener(MouseEvent.CLICK, this.onRoomClick, true);
            return;
        }// end function

        private function onRoomClick(event:MouseEvent) : void
        {
            if (this.selection_mc.currentFrame == 2)
            {
                return;
            }
            if (!this.IsJoinable())
            {
                this.dispatchEvent(new LoadNewRoomEvent(LoadNewRoomEvent.LOAD, {Error:true, RoomName:this.roomName, MinJoinRoom:this.minJoinRoom}, true));
                return;
            }
            this.dispatchEvent(new LoadNewRoomEvent(LoadNewRoomEvent.LOAD, {MinCoin:this.MinCoin, MaxCoin:this.MaxCoin, RoomId:this.roomId, RoomName:this.roomName, RoomType:this.roomType, ServerIP:this.serverAndPort, Error:false}, true));
            this.selectRoomFunction(this.roomId);
            this.gameLoader.playSoundClick();
            return;
        }// end function

        private function IsJoinable() : Boolean
        {
            var _loc_1:Number = NaN;
            if (this.gameLoader)
            {
                if (this.gameLoader.global.MyInfo.isAdmin())
                {
                    return true;
                }
                _loc_1 = this.gameLoader.global.MyInfo.coin;
                if (this.gameLoader.global.isTourRoom)
                {
                    _loc_1 = this.gameLoader.global.MyInfo.realCoin;
                }
                if (this.minJoinRoom >= 0)
                {
                    return _loc_1 >= this.minJoinRoom;
                }
                return _loc_1 < Math.abs(this.minJoinRoom);
            }
            return false;
        }// end function

    }
}
