package net.mgame.components
{
    import MGameEvents.*;
    import flash.display.*;
    import flash.events.*;
    import mgame.manager.*;

    public class CompoBottomBarInGame extends MGSprite
    {
        private var panel:BottomBarMC;
        public var gameLoader:Object;
        private var bgEffect:MovieClip;
        private var isInLobby:Boolean = true;
        private var isNapGold:Boolean = false;

        public function CompoBottomBarInGame(param1:Boolean = true)
        {
            this.isInLobby = param1;
            addEventListener(Event.ADDED_TO_STAGE, this.init);
            return;
        }// end function

        private function init(event:Event = null) : void
        {
            removeEventListener(Event.ADDED_TO_STAGE, this.init);
            this.panel = new BottomBarMC();
            this.initCompo();
            addChild(this.panel);
            this.bgEffect = this.panel.getChildByName("bgSlideMC") as MovieClip;
            this.bgEffect.addFrameScript(14, this.onShowMenuAfterPlayEffectOpen);
            this.bgEffect.addFrameScript(29, this.onHideMenuAfterPlayEffectHide);
            return;
        }// end function

        public function reset() : void
        {
            this.showBottombar(1);
            return;
        }// end function

        private function initCompo() : void
        {
            this.panel.gotoAndStop(1);
            this.panel.btnExpand.addEventListener(MouseEvent.CLICK, this.onExpand, false, 0, true);
            return;
        }// end function

        private function onContactClick(event:MouseEvent) : void
        {
            this.playSound();
            this.dispatchEvent(new CustomEvent(CustomEvent.HOTLINE, null, true));
            return;
        }// end function

        private function onBuzzlick(event:MouseEvent) : void
        {
            this.playSound();
            var _loc_2:* = this.gameLoader.gameScreen;
            _loc_2.this.gameLoader.gameScreen["onBuzz"](null);
            return;
        }// end function

        private function onHide(event:MouseEvent) : void
        {
            this.playSound();
            this.showBottombar();
            return;
        }// end function

        private function onAddCoinClick(event:MouseEvent) : void
        {
            this.playSound();
            this.dispatchEvent(new CustomEvent(CustomEvent.OPEN_POPUP_NAP_GOLD, null, true));
            return;
        }// end function

        private function onSoundClick(event:MouseEvent) : void
        {
            if (this.gameLoader["soundOn"])
            {
                this.panel.panelExpand.btnSound.gotoAndStop(2);
                this.gameLoader["soundOn"] = false;
            }
            else
            {
                this.panel.panelExpand.btnSound.gotoAndStop(1);
                this.gameLoader["soundOn"] = true;
            }
            return;
        }// end function

        private function onSettingClick(event:MouseEvent) : void
        {
            this.playSound();
            this.dispatchEvent(new HeaderEvent(HeaderEvent.SETTING, null, true));
            return;
        }// end function

        private function onChatClick(event:MouseEvent) : void
        {
            this.playSound();
            this.dispatchEvent(new Event("CHAT"));
            return;
        }// end function

        private function onExpand(event:MouseEvent) : void
        {
            this.playSound();
            this.showBottombar(2);
            return;
        }// end function

        private function showEffectSlide(param1:Boolean) : void
        {
            if (this.bgEffect == null)
            {
                return;
            }
            if (param1)
            {
                this.bgEffect.gotoAndPlay(2);
            }
            else
            {
                this.panel.gotoAndStop(1);
                this.bgEffect.gotoAndPlay(16);
            }
            return;
        }// end function

        private function showBottombar(param1:int = 1) : void
        {
            if (this.panel == null)
            {
                return;
            }
            if (param1 == 1)
            {
                this.showEffectSlide(false);
            }
            else
            {
                this.showEffectSlide(true);
            }
            return;
        }// end function

        private function onHideMenuAfterPlayEffectHide() : void
        {
            if (!this.panel.btnExpand.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.btnExpand.addEventListener(MouseEvent.CLICK, this.onExpand, false, 0, true);
            }
            return;
        }// end function

        private function onShowMenuAfterPlayEffectOpen() : void
        {
            this.bgEffect.stop();
            this.panel.gotoAndStop(2);
            if (this.gameLoader["soundOn"])
            {
                this.panel.panelExpand.btnSound.gotoAndStop(1);
            }
            else
            {
                this.panel.panelExpand.btnSound.gotoAndStop(2);
            }
            if (!this.panel.panelExpand.btnHide.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnHide.addEventListener(MouseEvent.CLICK, this.onHide, false, 0, true);
            }
            if (!this.panel.panelExpand.btnChat.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnChat.addEventListener(MouseEvent.CLICK, this.onChatClick, false, 0, true);
            }
            if (this.isNapGold == true)
            {
                this.panel.panelExpand.btnAddCoin.alpha = 1;
                if (!this.panel.panelExpand.btnAddCoin.hasEventListener(MouseEvent.CLICK))
                {
                    this.panel.panelExpand.btnAddCoin.addEventListener(MouseEvent.CLICK, this.onAddCoinClick, false, 0, true);
                }
            }
            else
            {
                this.panel.panelExpand.btnAddCoin.alpha = 0.5;
                if (!this.panel.panelExpand.btnAddCoin.hasEventListener(MouseEvent.CLICK))
                {
                    this.panel.panelExpand.btnAddCoin.removeEventListener(MouseEvent.CLICK, this.onAddCoinClick);
                }
            }
            if (!this.panel.panelExpand.btnSound.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnSound.addEventListener(MouseEvent.CLICK, this.onSoundClick, false, 0, true);
            }
            if (!this.panel.panelExpand.btnSetting.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnSetting.addEventListener(MouseEvent.CLICK, this.onSettingClick, false, 0, true);
            }
            if (!this.panel.panelExpand.btnContact.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnContact.addEventListener(MouseEvent.CLICK, this.onContactClick, false, 0, true);
            }
            if (!this.panel.panelExpand.btnBuzz.hasEventListener(MouseEvent.CLICK))
            {
                this.panel.panelExpand.btnBuzz.addEventListener(MouseEvent.CLICK, this.onBuzzlick, false, 0, true);
            }
            if (this.isInLobby)
            {
                this.panel.panelExpand.btnBuzz.visible = false;
                this.panel.panelExpand.btnSetting.visible = false;
                this.panel.panelExpand.btnContact.visible = true;
                this.panel.panelExpand.btnAddCoin.visible = true;
            }
            else
            {
                this.panel.panelExpand.btnBuzz.visible = false;
                this.panel.panelExpand.btnSetting.visible = true;
                this.panel.panelExpand.btnContact.visible = false;
                this.panel.panelExpand.btnAddCoin.visible = true;
            }
            return;
        }// end function

        private function playSound() : void
        {
            var _loc_1:* = this.gameLoader;
            _loc_1.this.gameLoader["playSoundClick"]();
            return;
        }// end function

        public function ShowNapGoldButton(param1:Boolean) : void
        {
            this.isNapGold = param1;
            return;
        }// end function

    }
}
