package net.mgame.components
{
    import MGameEvents.*;
    import com.greensock.*;
    import flash.display.*;
    import flash.events.*;
    import mgame.manager.*;
    import net.mgame.*;

    public class CompoHeaderBarInGame extends MGSprite
    {
        private var resource:HeaderBar_Resource;
        public var playSoundCLick:Function;
        private var boardid:String = "";
        private var matchid:String = "";
        private var tween:TweenLite;
        public static const SET_SOUND_VIBRATION:String = "SET_SOUND_VIBRATION";

        public function CompoHeaderBarInGame()
        {
            this.resource = new HeaderBar_Resource();
            this.addChild(this.resource);
            this.resource.mcMoRong.mouseChildren = false;
            return;
        }// end function

        private function onSetting2Click(event:MouseEvent) : void
        {
            this.dispatchEvent(new CustomEvent(SET_SOUND_VIBRATION, null, true));
            return;
        }// end function

        private function onSetting1Click(event:MouseEvent) : void
        {
            this.dispatchEvent(new HeaderEvent(HeaderEvent.SETTING, null, true));
            return;
        }// end function

        final public function SetBetCoin(param1:String) : void
        {
            this.resource.container.txtBetCoin.text = param1;
            return;
        }// end function

        final public function SetBoardID(param1:String) : void
        {
            this.boardid = param1;
            if (this.matchid != "")
            {
                this.resource.container.txtBoardID.text = "Bn " + this.boardid + " (" + this.matchid + ")";
            }
            else
            {
                this.resource.container.txtBoardID.text = "Bn " + this.boardid;
            }
            return;
        }// end function

        final public function SetMatchID(param1:String) : void
        {
            this.matchid = param1;
            if (this.matchid != "")
            {
                this.resource.container.txtBoardID.text = "Bn " + this.boardid + " (" + this.matchid + ")";
            }
            else
            {
                this.resource.container.txtBoardID.text = "Bn " + this.boardid;
            }
            return;
        }// end function

        final public function ClearAll() : void
        {
            this.resource.container.txtBetCoin.text = "";
            this.resource.container.txtBoardID.text = "";
            this.resource.removeEventListener(MouseEvent.CLICK, this.onClick);
            return;
        }// end function

        private function drawText() : void
        {
            return;
        }// end function

        final public function ShowAll() : void
        {
            if (this.resource.hasEventListener(MouseEvent.CLICK) == false)
            {
                this.resource.addEventListener(MouseEvent.CLICK, this.onClick);
            }
            return;
        }// end function

        private function onClick(event:MouseEvent) : void
        {
            this.playSoundCLick();
            var _loc_2:* = event.target as DisplayObject;
            if (_loc_2)
            {
                switch(_loc_2.name)
                {
                    case "mcMoRong":
                    {
                        this.onMoRong();
                        break;
                    }
                    default:
                    {
                        break;
                    }
                }
            }
            return;
        }// end function

        private function onMoRong() : void
        {
            if (this.tween != null)
            {
                this.tween.progress(1);
                this.tween.kill();
            }
            if (this.resource.mcMoRong.currentFrame == 1)
            {
                this.tween = new TweenLite(this.resource.container, 0.5, {x:this.resource.container.width, onComplete:this.onFinishTween, onCompleteParams:[2]});
            }
            else
            {
                this.tween = new TweenLite(this.resource.container, 0.5, {x:0, onComplete:this.onFinishTween, onCompleteParams:[1]});
            }
            this.tween.play();
            return;
        }// end function

        private function onFinishTween(param1:int) : void
        {
            this.resource.mcMoRong.gotoAndStop(param1);
            TweenLite.killTweensOf(this.resource.container, true);
            return;
        }// end function

        public function ShowNapGoldButton(param1:Boolean) : void
        {
            this.resource.container.btnNapGold.visible = param1;
            return;
        }// end function

    }
}
