package net.mgame.controllers
{
    import ICompoLuat.*;
    import MGameUtilities.*;
    import flash.display.*;
    import flash.events.*;
    import flash.utils.*;
    import net.king.*;
    import net.king.entities.*;
    import net.king.events.*;
    import net.king.models.*;
    import net.king.utils.*;
    import net.mgame.controllers.features.*;
    import net.mgame.controllers.features.gopga.*;
    import net.mgame.controllers.features.jackpot.*;
    import net.mgame.controllers.features.star.*;
    import net.mgame.controllers.features.tournament.*;
    import net.mgame.keys.*;
    import net.mgame.models.*;
    import net.mgame.ui.*;
    import net.mgame.utils.*;

    public class GameLoaderController extends Object
    {
        private var gameLoader:GameLoader;
        private var loginBox:LoginBox = null;
        private var pingDelay:int = 1000;
        public var pingTimer:Timer;
        private var listClasses:HashMap;
        private var _listInstancedClasses:HashMap;
        private var timerDelayToShowMessageDisconnect:Timer;
        private static var isInstanced:Boolean = false;

        public function GameLoaderController(param1:GameLoader)
        {
            if (isInstanced)
            {
                throw new Error("Cannot instance more than once");
            }
            isInstanced = true;
            this.gameLoader = param1;
            this.initEventListeners();
            return;
        }// end function

        public function get listInstancedClasses() : HashMap
        {
            return this._listInstancedClasses;
        }// end function

        private function onTimeOutCheckLogin(event:TimerEvent) : void
        {
            return;
        }// end function

        final private function initEventListeners() : void
        {
            KF.socket.addEventListener(KingServerEvent.CONNECTED, this.onConnect);
            KF.socket.addEventListener(KingServerEvent.CONNECTION_CLOSE, this.onCloseConnect);
            KF.socket.addEventListener(KingServerEvent.CONNECTION_ERROR, this.onConnectErrorHandler);
            KF.socket.addEventListener(KingServerEvent.SECURITY_ERROR, this.onConnectErrorHandler);
            KF.socket.addEventListener(KingServerEvent.LOGIN_OK, this.onLoginOK);
            KF.socket.addEventListener(KingServerEvent.LOGIN_FAILED, this.onLoginFailed);
            KF.socket.addEventListener(KingServerEvent.RECONNECT, this.onReconnect);
            KF.socket.addEventListener(KingServerEvent.CREATE_ROOM, this.onCreateRoom);
            KF.socket.addEventListener(KingServerEvent.JOIN_ROOM, this.onJoinRoom);
            KF.socket.addEventListener(KingServerEvent.ROOM_LOST, this.onRemoveRoom);
            KF.socket.addEventListener(KingServerEvent.SUBSCRIBE_LOBBY, this.onSubscribeLobby);
            KF.socket.addEventListener(KingServerEvent.USER_ENTER_ROOM, this.onEnterRoom);
            KF.socket.addEventListener(KingServerEvent.USER_EXIT_ROOM, this.onExitRoom);
            KF.socket.addEventListener(KingServerEvent.USER_LOST, this.onUserLost);
            KF.socket.addEventListener(KingServerEvent.SPECTATOR_TO_PLAYER, this.onViewerBecomePlayer);
            KF.socket.addEventListener(KingServerEvent.PLAYER_TO_SPECTATOR, this.onPlayerBecomeViewer);
            KF.socket.addEventListener(KingServerEvent.SET_ROOM_VARIABLES, this.onSetRoomVariables);
            KF.socket.addEventListener(KingServerEvent.SET_USER_VARIABLES, this.onSetUserVariables);
            KF.socket.addEventListener(KingServerEvent.ROOM_CHANGE_OWNER, this.onRoomChangeOwner);
            KF.socket.addEventListener(KingServerEvent.RECEIVE_EXTENSION_DATA, this.onReceiveExtensionData);
            if (this.gameLoader.isDebug)
            {
                KF.isShowLog = true;
                KF.setShowLogSize(0, 400, 250, 150, false);
            }
            return;
        }// end function

        final private function onTrace(event:KingServerEvent) : void
        {
            KF.showLog(event.data.toString());
            return;
        }// end function

        private function onRoomChangeOwner(event:KingServerEvent) : void
        {
            var _loc_5:int = 0;
            var _loc_6:Number = NaN;
            var _loc_7:String = null;
            var _loc_8:Boolean = false;
            var _loc_2:* = Number(event.data.roomId);
            var _loc_3:* = Number(event.data.previousOwnerId);
            var _loc_4:* = Number(event.data.newOwnerId);
            this.gameLoader.gameScreen.updateBoardOwner(_loc_3, _loc_4);
            if (this.gameLoader.global.MyInfo.userId == _loc_4)
            {
                _loc_5 = this.gameLoader.global.getRoomBetTime();
                _loc_6 = this.gameLoader.global.getRoomBetCoin();
                _loc_7 = this.gameLoader.global.getRoomRules();
                _loc_8 = this.gameLoader.global.isDifferenceSetting(_loc_6, _loc_5, _loc_7);
                if (this.gameLoader.global.MyInfo.isPlaying == false && this.gameLoader.global.isPlaying == false)
                {
                    if (_loc_8 == false || this.gameLoader.global.betCoin == 0)
                    {
                        this.gameLoader.global.ShowCompoSettingForRoomowner();
                        this.gameLoader.globalComponents.compoSetting.isOpenSettingAfterMatch = false;
                    }
                }
                else
                {
                    this.gameLoader.globalComponents.compoSetting.isOpenSettingAfterMatch = true;
                }
            }
            this.getLockBoard();
            return;
        }// end function

        private function onReconnect(event:KingServerEvent) : void
        {
            var _loc_2:Boolean = false;
            if (!this.gameLoader.global.isLoginOtherSession && this.gameLoader.global.enableReconnect)
            {
                this.gameLoader.globalComponents.hideEffectWaitingReconnect();
                _loc_2 = event.data.result;
                if (_loc_2)
                {
                    KF.showLog("reconnect OK");
                    if (this.pingTimer == null)
                    {
                        this.pingTimer = new Timer(this.pingDelay);
                        this.pingTimer.addEventListener(TimerEvent.TIMER, this.onPing);
                    }
                    this.pingTimer.start();
                }
                else
                {
                    KF.showLog("reconnect failed");
                    this.onConnect(new KingServerEvent(KingServerEvent.CONNECTED, {isReconnected:false}));
                }
            }
            return;
        }// end function

        private function onSetRoomVariables(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.roomId;
            var _loc_3:* = event.data.listVariables;
            var _loc_4:Number = 0;
            if (this.gameLoader.isLobby())
            {
                if (this.gameLoader.global.gameID == GlobalConstants.TaiXiuId)
                {
                    _loc_4 = _loc_3[VariableKeys.MAX_BET];
                    if (isNaN(_loc_4))
                    {
                        return;
                    }
                }
            }
            else if (this.gameLoader.global.gameID == GlobalConstants.TaiXiuId)
            {
                _loc_4 = _loc_3[VariableKeys.MAX_BET];
                if (isNaN(_loc_4))
                {
                    return;
                }
                this.gameLoader.global.taiXiuMaxBet = _loc_4;
            }
            return;
        }// end function

        private function onSetUserVariables(event:KingServerEvent) : void
        {
            var _loc_6:Number = NaN;
            if (this.gameLoader.global.gameID == GlobalConstants.CoCaNguaId || this.gameLoader.global.gameID == GlobalConstants.BarGameId || this.gameLoader.global.gameID == GlobalConstants.KenoGameId || this.gameLoader.global.gameID == GlobalConstants.QuaySoGameId)
            {
                return;
            }
            var _loc_2:* = event.data.roomId;
            var _loc_3:* = event.data.userId;
            var _loc_4:* = event.data.listVariables;
            var _loc_5:* = this.gameLoader.global.getUser(_loc_3);
            if (_loc_5)
            {
                _loc_6 = _loc_4[VariableKeys.COIN];
                if (isNaN(_loc_6))
                {
                    return;
                }
                if (this.gameLoader.global.gameID == GlobalConstants.BinhGameId || this.gameLoader.global.gameID == GlobalConstants.PokerGameId || this.gameLoader.global.isGameLieng)
                {
                    if (this.gameLoader.global.isPlaying == false)
                    {
                        if (this.gameLoader.global.MyInfo.userId == _loc_3)
                        {
                            this.gameLoader.global.refreshMyInfo();
                        }
                        if (this.gameLoader.isGame())
                        {
                            this.gameLoader.gameScreen.updateCompoUserInfoPlay(_loc_5.getId());
                        }
                    }
                }
                else if (this.gameLoader.global.gameID == GlobalConstants.TaiXiuId)
                {
                    this.gameLoader.gameScreen.handleUnknownObject(RequestKeys.REFRESH_USER_IN_BOARD, {userId:_loc_3, coin:_loc_6});
                }
                else
                {
                    if (this.gameLoader.global.MyInfo.userId == _loc_3)
                    {
                        this.gameLoader.global.refreshMyInfo();
                    }
                    if (this.gameLoader.isGame())
                    {
                        this.gameLoader.gameScreen.updateCompoUserInfoPlay(_loc_5.getId());
                    }
                }
                _loc_5 = null;
            }
            return;
        }// end function

        private function onPlayerBecomeViewer(event:KingServerEvent) : void
        {
            var _loc_2:* = Number(event.data.userId);
            var _loc_3:* = Number(event.data.roomId);
            var _loc_4:* = int(event.data.previousPlayerId);
            this.gameLoader.gameScreen.userLeaveGame(_loc_2, _loc_4);
            var _loc_5:Boolean = false;
            if (_loc_2 == this.gameLoader.global.Me.getId())
            {
                _loc_5 = true;
            }
            var _loc_6:* = KF.socket.getRoomManager().getRoomById(_loc_3);
            if (_loc_5)
            {
                this.gameLoader.gameScreen.updatePosition(_loc_6, true);
                this.gameLoader.globalComponents.compoNotify.Hide();
                this.gameLoader.global.stopTimerToUpdateTimePlay();
            }
            if (_loc_6.getUserList.length > 0 && this.gameLoader.global.MyInfo.isRoomOwner)
            {
                this.getItemBetPath();
                this.getLockBoard();
            }
            return;
        }// end function

        private function onViewerBecomePlayer(event:KingServerEvent) : void
        {
            var _loc_6:RoomInfo = null;
            var _loc_7:User = null;
            var _loc_8:UserInfo = null;
            var _loc_2:* = Number(event.data.userId);
            var _loc_3:* = Number(event.data.roomId);
            var _loc_4:Boolean = false;
            if (_loc_2 == this.gameLoader.global.Me.getId())
            {
                _loc_4 = true;
            }
            var _loc_5:* = KF.socket.getRoomManager().getRoomById(_loc_3);
            if (_loc_4)
            {
                this.gameLoader.gameScreen.updatePosition(_loc_5, true);
                _loc_6 = RoomInfo.fromRoom(_loc_5);
                this.handleDisplayMessageWhenNewUserJoinBoard(_loc_6);
            }
            else
            {
                this.gameLoader.gameScreen.addUserSit(_loc_2);
                _loc_7 = this.gameLoader.global.getUser(_loc_2);
                if (_loc_7)
                {
                    _loc_8 = UserInfo.fromUser(_loc_7);
                    if (_loc_8.isAdmin() == false)
                    {
                        this.gameLoader.global.noticeUserEnterBoard(_loc_8.nickName);
                    }
                }
            }
            if (_loc_5.getUserList.length > 0 && this.gameLoader.global.MyInfo.isRoomOwner)
            {
                this.getItemBetPath();
                this.getLockBoard();
            }
            return;
        }// end function

        private function handleDisplayMessageWhenNewUserJoinBoard(param1:RoomInfo) : void
        {
            var _loc_2:String = null;
            if (this.gameLoader.global.isGameBinh)
            {
                this.gameLoader.globalComponents.compoSetting.BetTime = param1.timeOut;
                this.gameLoader.globalComponents.compoSetting.TimeOut = this.gameLoader.global.timeOutTextBinh;
            }
            if (this.gameLoader.global.isGameTaiXiu || this.gameLoader.global.isGameBar || this.gameLoader.global.isGameKeno || this.gameLoader.global.isGameQuaySo)
            {
                return;
            }
            if (this.gameLoader.global.MyInfo.isPlayer)
            {
                _loc_2 = StringUtils.formatString("Bn choi dang du?c thi?t l?p<br/>Th?i gian di: <b>{0}</b><br/>Ti?n cu?c: <b>{1}</b><br/>Lu?t choi: <b>{2}</b>", this.gameLoader.global.timeOutToText(param1.timeOut), Format.Coin(param1.betCoin.toString()), this.gameLoader.global.getRuleForNewUser(param1.rules, this.gameLoader.global.gameID) + this.gameLoader.global.getRuleSetupOnBoard(param1));
                this.gameLoader.globalComponents.compoNotify.ShowWithAgreeAndCustomTitle(_loc_2, null, this.getGameNameForPopupTitle(param1.rules));
            }
            return;
        }// end function

        private function getGameNameForPopupTitle(param1:String) : String
        {
            var _loc_3:Array = null;
            var _loc_4:int = 0;
            var _loc_2:String = "";
            switch(this.gameLoader.global.gameID)
            {
                case GlobalConstants.TienlenMNGameId:
                {
                    _loc_3 = param1.split(",");
                    _loc_4 = 0;
                    while (_loc_4 < _loc_3.length)
                    {
                        
                        if (_loc_3[_loc_4] != "")
                        {
                            if (_loc_3[_loc_4] == GlobalConstants.LUAT_MIEN_NAM)
                            {
                                _loc_2 = "Mi?n Nam";
                            }
                            if (_loc_3[_loc_4] == GlobalConstants.LUAT_DEM_LA)
                            {
                                _loc_2 = "?m L;
                            }
                        }
                        _loc_4++;
                    }
                    break;
                }
                case GlobalConstants.U9LaGameId:
                {
                    _loc_2 = " 9 l;
                    break;
                }
                case GlobalConstants.XiToGameId:
                {
                    _loc_2 = "X t?";
                    break;
                }
                case GlobalConstants.BinhGameId:
                {
                    _loc_2 = " Binh tnh chi";
                    break;
                }
                case GlobalConstants.SamId:
                {
                    _loc_2 = "Sm L?c";
                    break;
                }
                case GlobalConstants.LiengId:
                {
                    _loc_2 = "Ling";
                    break;
                }
                case GlobalConstants.DanhChanGameId:
                {
                    _loc_2 = "nh Ch?n";
                    break;
                }
                default:
                {
                    break;
                }
            }
            return _loc_2;
        }// end function

        private function onRemoveRoom(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.roomId;
            var _loc_3:* = event.data.roomName;
            this.gameLoader.lobbyScreen.removeBoard(_loc_2.toString());
            return;
        }// end function

        final public function onReceiveExtensionData(event:KingServerEvent) : void
        {
            var _loc_3:IHandlerMessage = null;
            var _loc_2:* = event.data as RequestCommand;
            if (_loc_2 && _loc_2.command != "cws")
            {
                _loc_3 = this.getClass(_loc_2.command);
                if (_loc_3)
                {
                    _loc_3.handleMessage(_loc_2.content);
                    _loc_3 = null;
                }
                _loc_2 = null;
            }
            return;
        }// end function

        final public function getClass(param1:String) : IHandlerMessage
        {
            var _loc_3:Class = null;
            var _loc_2:* = this._listInstancedClasses.getValue(param1);
            if (_loc_2 == null)
            {
                _loc_3 = this.listClasses.getValue(param1) as Class;
                if (_loc_3)
                {
                    _loc_2 = new _loc_3;
                    this._listInstancedClasses.put(param1, _loc_2);
                    _loc_3 = null;
                }
            }
            return _loc_2;
        }// end function

        final public function onUserLost(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.user;
            var _loc_3:* = _loc_2.getJoinedRoom();
            if (_loc_3.IsGame())
            {
                this.gameLoader.gameScreen.userLeaveGame(_loc_2.getId(), UserInfo.fromUser(_loc_2).position);
                if (_loc_3.getUserList.length > 0 && this.gameLoader.global.MyInfo.isRoomOwner)
                {
                    this.getItemBetPath();
                    this.getLockBoard();
                }
            }
            else
            {
                this.gameLoader.lobbyScreen.removeUser(_loc_2);
            }
            return;
        }// end function

        final public function onExitRoom(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.room;
            var _loc_3:* = event.data.user;
            if (_loc_2.IsGame())
            {
                this.gameLoader.gameScreen.userLeaveGame(_loc_3.getId(), UserInfo.fromUser(_loc_3).position);
                if (_loc_2.getUserList.length > 0 && this.gameLoader.global.MyInfo.isRoomOwner)
                {
                    this.getItemBetPath();
                    this.getLockBoard();
                }
            }
            else
            {
                this.gameLoader.lobbyScreen.removeUser(_loc_3);
            }
            return;
        }// end function

        final public function onEnterRoom(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.room;
            var _loc_3:* = event.data.user;
            if (_loc_2.IsGame())
            {
                if (_loc_3.getId() == this.gameLoader.global.Me.getId())
                {
                    this.gameLoader.gameScreen.updatePosition(_loc_2, false);
                }
                else
                {
                    this.gameLoader.gameScreen.addUserSit(_loc_3.getId());
                }
            }
            else
            {
                this.gameLoader.lobbyScreen.appendUser(_loc_3);
            }
            if (this.gameLoader.global.gameID != GlobalConstants.TaiXiuId)
            {
                this.gameLoader.global.refreshMyInfo();
            }
            return;
        }// end function

        final public function onSubscribeLobby(event:KingServerEvent) : void
        {
            this.gameLoader.lobbyScreen.activeFocusListGame(true);
            this.gameLoader.lobbyScreen.loadDataForCompoListBoard();
            if (this.gameLoader.global.isJoinNewServerAndJoinRoomGame)
            {
                this.gameLoader.global.isJoinNewServerAndJoinRoomGame = false;
                if (this.gameLoader.global.inviteUserId == -1)
                {
                    return;
                }
                this.confirmInvite(true, this.gameLoader.global.inviteUserId, this.gameLoader.global.betCoin, this.gameLoader.global.betTime, this.gameLoader.global.position, this.gameLoader.global.rules);
            }
            return;
        }// end function

        final public function onRoomCountChange(event:KingServerEvent) : void
        {
            return;
        }// end function

        final public function onJoinRoom(event:KingServerEvent) : void
        {
            var _loc_3:RoomInfo = null;
            var _loc_4:String = null;
            var _loc_5:String = null;
            var _loc_2:* = event.data.room as Room;
            if (_loc_2.IsGame())
            {
                _loc_3 = RoomInfo.fromRoom(_loc_2);
                this.gameLoader.goToGameScreen();
                if (_loc_3.isDefault)
                {
                    this.gameLoader.gameScreen.setLockBoard(false);
                    this.gameLoader.gameScreen.OKhoa.visible = false;
                }
                this.gameLoader.global.betTime = _loc_3.timeOut;
                this.gameLoader.global.betCoin = _loc_3.betCoin;
                this.gameLoader.global.rules = _loc_3.rules;
                this.gameLoader.global.isSolo = _loc_3.isSolo;
                this.gameLoader.global.isGopGa = _loc_3.isGopGa;
                if (this.gameLoader.globalComponents.compoSetting.compoLuatGame)
                {
                    this.gameLoader.globalComponents.compoSetting.compoLuatGame.isSolo = _loc_3.isSolo;
                }
                this.gameLoader.globalComponents.compoSetting.isGopGa = _loc_3.isGopGa;
                this.gameLoader.globalComponents.compoSetting.Status = _loc_3.boardStatus;
                this.gameLoader.globalComponents.compoSetting.SetRule(this.gameLoader.global.rules);
                this.gameLoader.global.ServerTime = _loc_3.serverTime;
                if (_loc_3.boardTypeID != null)
                {
                    this.gameLoader.global.IdBg = _loc_3.boardTypeID.split("$")[0];
                    this.gameLoader.global.IdBoard = _loc_3.boardTypeID.split("$")[1];
                }
                this.gameLoader.gameScreen.InitBg();
                this.gameLoader.gameScreen.updatePosition(_loc_2, false);
                this.getItemBetPath();
                this.getLockBoard();
                this.gameLoader.gameScreen.handleUnknownObject("typeboard", this.gameLoader.global.IdBoard);
                if (this.gameLoader.global.MyInfo.isPlayer)
                {
                    this.handleDisplayMessageWhenNewUserJoinBoard(_loc_3);
                    if (this.gameLoader.global.inviteBetCoin > 0 && this.gameLoader.global.inviteBetCoin != this.gameLoader.global.betCoin)
                    {
                        _loc_5 = "";
                        if (this.gameLoader.global.rules == null || this.gameLoader.global.rules == "")
                        {
                            _loc_4 = this.gameLoader.global.confirmStartMatchMessage;
                            if (this.gameLoader.global.isSolo)
                            {
                                _loc_5 = _loc_5 + "\n Bn Solo";
                            }
                            if (this.gameLoader.global.isGopGa)
                            {
                                _loc_5 = _loc_5 + "\n Bn G";
                            }
                            _loc_4 = StringUtils.formatString(_loc_4, this.gameLoader.global.timeOutToText(this.gameLoader.global.betTime), Format.Coin(this.gameLoader.global.betCoin.toString()) + _loc_5);
                        }
                        else
                        {
                            _loc_5 = this.gameLoader.global.getRuleString(this.gameLoader.global.rules, this.gameLoader.global.gameID);
                            _loc_5 = _loc_5.substr(9);
                            if (this.gameLoader.global.isSolo)
                            {
                                _loc_5 = _loc_5 + "\n Bn Solo";
                            }
                            if (this.gameLoader.global.isGopGa)
                            {
                                _loc_5 = _loc_5 + "\n Bn G";
                            }
                            _loc_4 = this.gameLoader.global.confirmStartMatchMessageWithRules;
                            _loc_4 = StringUtils.formatString(_loc_4, this.gameLoader.global.timeOutToText(this.gameLoader.global.betTime), Format.Coin(this.gameLoader.global.betCoin.toString()), _loc_5);
                        }
                        this.gameLoader.globalComponents.compoNotify.ShowWithArgreeAndNoAgree(_loc_4, this.onAgree, this.onStandUp);
                    }
                }
                this.gameLoader.gameScreen.updateMatchId(_loc_2.getName(), _loc_3.matchId, _loc_3.isDefault);
                if (this.pingTimer == null)
                {
                    this.pingTimer = new Timer(this.pingDelay);
                    this.pingTimer.addEventListener(TimerEvent.TIMER, this.onPing);
                }
                this.pingTimer.start();
            }
            else
            {
                this.sendUpdateMaxBet();
                this.gameLoader.goToLobbyScreen();
                this.gameLoader.lobbyScreen.updateCompoPUB(_loc_2);
                this.gameLoader.lobbyScreen.updateCompMenuListRoom(_loc_2);
                this.gameLoader.lobbyScreen.updateHeaderLobbyInfoListRoom(_loc_2);
                this.gameLoader.lobbyScreen.updateListGame();
                if (this.pingTimer)
                {
                    this.pingTimer.reset();
                }
            }
            _loc_2 = null;
            this.gameLoader.global.refreshMyInfo();
            this.gameLoader.lobbyScreen.compoBottomControlBar.NickName = this.gameLoader.global.MyInfo.nickName;
            this.gameLoader.lobbyScreen.compoBottomControlBar.Coin = this.gameLoader.global.MyInfo.coin;
            this.gameLoader.lobbyScreen.compoBottomControlBar.currency = this.gameLoader.global.currency;
            this.gameLoader.lobbyScreen.compoBottomControlBar.Avatar = this.gameLoader.global.avatarPath + this.gameLoader.global.MyInfo.emotionPath;
            if (GameScreen.isMobile)
            {
                this.gameLoader.lobbyScreen.compoBottomControlBar.ShowNapGoldButton(false);
                this.gameLoader.gameScreen.compoBottomBarInGame.ShowNapGoldButton(this.gameLoader.preloader.IsEnableNapGold);
                this.gameLoader.lobbyScreen.compoBottomBarInGame.ShowNapGoldButton(this.gameLoader.preloader.IsEnableNapGold);
            }
            this.gameLoader.global.clearListUserInvite();
            return;
        }// end function

        private function onStandUp() : void
        {
            this.gameLoader.global.inviteBetCoin = 0;
            this.sendStandUp(this.gameLoader.global.MyInfo.userId, true);
            return;
        }// end function

        private function onAgree() : void
        {
            this.gameLoader.global.inviteBetCoin = this.gameLoader.global.betCoin;
            return;
        }// end function

        private function onPing(event:TimerEvent) : void
        {
            this.sendPing();
            return;
        }// end function

        final public function onCreateRoom(event:KingServerEvent) : void
        {
            var _loc_2:* = event.data.room as Room;
            if (_loc_2)
            {
                this.gameLoader.lobbyScreen.addRoomToCompoListBoard(_loc_2);
            }
            return;
        }// end function

        final public function onLoginOK(event:KingServerEvent) : void
        {
            if (this.listClasses == null)
            {
                this.initClasses();
            }
            this.gameLoader.globalComponents.hideEffectWaitingReconnect();
            return;
        }// end function

        private function onLoginFailed(event:KingServerEvent) : void
        {
            this.gameLoader.lobbyScreen.onBack(null, this.gameLoader.global.loginFailedMessage);
            return;
        }// end function

        private function initClasses() : void
        {
            this._listInstancedClasses = new HashMap();
            this.listClasses = new HashMap();
            this.listClasses.put(RequestKeys.ITEM_BAR, ItemBarHandler);
            this.listClasses.put(RequestKeys.INVITE_JOIN_BOARD, InviteJoinBoardHandler);
            this.listClasses.put(RequestKeys.CONFIRM_INVITE_JOIN_BOARD, ConfirmInviteJoinBoardHandler);
            this.listClasses.put(RequestKeys.UPDATE_ROOM_DATA, UpdateRoomDataHandler);
            this.listClasses.put(RequestKeys.RESPONSE_START_GAME, ResponseStartGameHandler);
            this.listClasses.put(RequestKeys.PLAY_MOVE, PlayMoveHandler);
            this.listClasses.put(RequestKeys.GAME_DATA, GetGameDataHandler);
            this.listClasses.put(RequestKeys.SEND_CHAT, ChatMessageHandler);
            this.listClasses.put(RequestKeys.SEND_BUZZ, BuzzMessageHandler);
            this.listClasses.put(RequestKeys.FRIEND_INFO, FriendInfoHandler);
            this.listClasses.put(RequestKeys.ASSOCIATION_USER, AssociationUserHandler);
            this.listClasses.put(RequestKeys.LOBBY_USER, LobbyUsersHandler);
            this.listClasses.put(RequestKeys.GET_ITEM_BAR, SpecificItemBarHandler);
            this.listClasses.put(RequestKeys.ITEM_BAR_CATEGORY_ID, ItemBarHandler);
            this.listClasses.put(RequestKeys.GET_PERSONAL_INFO, PersonalInfoHandler);
            this.listClasses.put(RequestKeys.USER_USE_ASSET, UserUseAssestHandler);
            this.listClasses.put(RequestKeys.ASSETS_LIST, AssetsListHandler);
            this.listClasses.put(RequestKeys.BUY_ASSET, BuyAssetsHandler);
            this.listClasses.put(RequestKeys.END_MATCH, EndMatchHandler);
            this.listClasses.put(RequestKeys.UPDATE_MAX_BET, MaxBetHandler);
            this.listClasses.put(RequestKeys.CHANGE_STATUS_BOARD, StatusBoardHandler);
            this.listClasses.put(RequestKeys.GET_PERSONAL_ASSET_LIST, PersonalAssetsHandler);
            this.listClasses.put(RequestKeys.AUTO_JOIN, UnAutoJoinHandler);
            this.listClasses.put(RequestKeys.UPDATE_COIN_USER, UpdateCoinUserHandler);
            this.listClasses.put(RequestKeys.DEALER_USER, DealerUserHandler);
            this.listClasses.put(RequestKeys.LOCK_BOARD, LockBoardHandler);
            this.listClasses.put(RequestKeys.SEND_MAKE_FRIEND, MakeFriendHandler);
            this.listClasses.put(RequestKeys.CONFIRM_MAKE_FRIEND, ConfirmMakeFriendHandler);
            this.listClasses.put(RequestKeys.PLAY_EMOTION, PlayEmotionHandler);
            this.listClasses.put(RequestKeys.UPDATE_BETCOIN_TIMEOUT, UpdateBetCoinAndTimeOutHandler);
            this.listClasses.put(RequestKeys.CAPTURE_PHOTO, CapturePhotoHandler);
            this.listClasses.put(RequestKeys.ERRROR, ErrorHandler);
            this.listClasses.put(RequestKeys.MENU_LIST_ROOM, LoadMenuListRoomHandler);
            this.listClasses.put(RequestKeys.UPDATE_MATCHID, UpdateMatchIdHandler);
            this.listClasses.put(RequestKeys.GET_EXPANDCOIN_FOR_ASS, UpdateCoinAndExpForAssociationHandler);
            this.listClasses.put(RequestKeys.RECEIVE_ANNOUNCEMENT, ReceiveAnnouncement);
            this.listClasses.put(RequestKeys.USER_ONLINE_STATUS, NoticeUserOnlineHandler);
            this.listClasses.put(RequestKeys.ADMIN_ACTION, AdminActionHandler);
            this.listClasses.put(RequestKeys.RECEIVE_ITEM_BET, ReceiveItemBetHandler);
            this.listClasses.put(RequestKeys.RECEIVE_LIST_FRIEND_ID, ReceiveListFriendIDHandler);
            this.listClasses.put(RequestKeys.SYSTEM_NOTICE, NoticeSystemHandler);
            this.listClasses.put(RequestKeys.GET_LOCK_BOARD, GetLockBoardHandler);
            this.listClasses.put(RequestKeys.INVITE_JOIN_ASSOCIATION, InviteJoinBangHandler);
            this.listClasses.put(RequestKeys.CHECK_CONNECTION_STRENGTH, ResponseCheckConnectionStrengthHandler);
            this.listClasses.put(RequestKeys.MAINTAIN_MES, MaintainServerHandler);
            this.listClasses.put(RequestKeys.UPDATE_MAX_PLAYER, UpdateMaxPlayerHandler);
            this.listClasses.put(RequestKeys.USER_LEVEL_TABLE, GetUserLevelTableHandler);
            this.listClasses.put(RequestKeys.AVATAR_COMMAND, UploadAvatarHandler);
            this.listClasses.put(RequestKeys.BOARD_BLACKLIST, BoardBlackListHandler);
            this.listClasses.put(RequestKeys.USER_BLACKLIST, UserBlackListHandler);
            this.listClasses.put(RequestKeys.CHANGE_BOARD_PASSWORD_STATUS, PasswordBoardHandler);
            this.listClasses.put(RequestKeys.UPDATE_TOTAL_USER_IN_A_GROUP, UpdateTotalUserInAGroupHandler);
            this.listClasses.put(RequestKeys.MOVE_NEW_SERVER, MoveServerHandler);
            this.listClasses.put(RequestKeys.NOTICE_CHAT, NoticeChatHandler);
            this.listClasses.put(RequestKeys.DEFAULTBOARD_MAX_TAY, GetDefaultBoardMaxTay);
            this.listClasses.put(RequestKeys.GET_TOP_CAO_THU, GetListTopCaoThuHandler);
            this.listClasses.put(RequestKeys.GET_ALL_INFO_USER, GetAllInfoUserHandler);
            this.listClasses.put(RequestKeys.CUSTOM_MAX_PLAYER, UpdateCustomMaxPlayerHandler);
            this.listClasses.put(RequestKeys.OPEN_SETTINGS, OpenSettingsHandler);
            this.listClasses.put(RequestKeys.RECONNECT, ReconnectHandler);
            this.listClasses.put(RequestKeys.LOGIN_OTHER_SESSION, UserLoginOtherSession);
            this.listClasses.put(RequestKeys.TOURNAMENT_BLOCKED_FUNCTION, TournamentBlockFunctionHandler);
            this.listClasses.put(RequestKeys.TOURNAMENT_INFO, TournamentInfoHandler);
            this.listClasses.put(RequestKeys.RESET_TIME_LOBBY, ResetTimeInLobbyHandler);
            this.listClasses.put(RequestKeys.TOURNAMENT_NUMTIMEOUT_USERLEAVE, WarningUserLeaveOrTimeOut);
            this.listClasses.put(RequestKeys.JACK_POT, JackpotHandler);
            this.listClasses.put(RequestKeys.JACKPOT_ACTIVE, JackpotRequestApplyRule);
            this.listClasses.put(RequestKeys.JACKPOT_RATE, JackpotHandler);
            this.listClasses.put(RequestKeys.STAR_HANDLER, StarHandler);
            this.listClasses.put(RequestKeys.CALL_WS, CallWSHandler);
            this.listClasses.put(RequestKeys.GOPGA_INFO, GopGaHandler);
            return;
        }// end function

        final public function onCloseConnect(event:KingServerEvent) : void
        {
            if (KF.socket.defaultSocket == event.data.hostName + ":" + event.data.port)
            {
                this.onConnectErrorHandler();
            }
            return;
        }// end function

        final public function onConnectErrorHandler(event:KingServerEvent = null) : void
        {
            if (this.pingTimer)
            {
                this.pingTimer.reset();
            }
            if (!this.gameLoader.global.isLoginOtherSession)
            {
                if (!this.gameLoader.global.isBackingToMenuGame)
                {
                    if (this.timerDelayToShowMessageDisconnect == null)
                    {
                        this.timerDelayToShowMessageDisconnect = new Timer(1000, 1);
                        this.timerDelayToShowMessageDisconnect.addEventListener(TimerEvent.TIMER_COMPLETE, this.onCompleteDelayToShowMessageDisconnect);
                    }
                    this.timerDelayToShowMessageDisconnect.reset();
                    this.timerDelayToShowMessageDisconnect.start();
                }
                else
                {
                    this.gameLoader.global.isBackingToMenuGame = false;
                }
            }
            return;
        }// end function

        private function onCompleteDelayToShowMessageDisconnect(event:TimerEvent) : void
        {
            if (KF.socket.isConnected(this.gameLoader.global.socketKey))
            {
                return;
            }
            if (this.gameLoader.global.enableReconnect)
            {
                this.gameLoader.globalComponents.showEffectWaitingReconnect();
            }
            else
            {
                this.gameLoader.globalComponents.compoNotify.Show(this.gameLoader.global.cannotConnectMessage, true, false);
                this.gameLoader.preloader.endLoad();
            }
            return;
        }// end function

        final public function onConnect(event:KingServerEvent) : void
        {
            var _loc_2:Boolean = false;
            if (KF.socket.defaultSocket == event.data.hostName + ":" + event.data.port)
            {
                _loc_2 = event.data.isReconnected;
                if (_loc_2)
                {
                    KF.showLog("Reconnect succusses");
                    this.gameLoader.globalComponents.hideEffectWaitingReconnect();
                    return;
                }
                this.login();
            }
            return;
        }// end function

        final public function createRoom(param1:Number, param2:int, param3:String, param4:int, param5:Boolean = false, param6:Boolean = false) : void
        {
            if (this.gameLoader.global.isGameTaiXiu)
            {
                return;
            }
            var _loc_7:Object = {};
            _loc_7[JSONKeys.TIME_OUT] = param2;
            _loc_7[JSONKeys.BET_COIN] = param1;
            _loc_7[JSONKeys.RULES] = param3;
            _loc_7[JSONKeys.CUSTOM_MAX_PLAYER] = param4;
            _loc_7[JSONKeys.IS_SOLO] = param5;
            _loc_7[JSONKeys.IS_GOPGA] = param6;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CREATE_ROOM, _loc_7));
            _loc_7 = null;
            return;
        }// end function

        final public function joinRoom(param1:Number, param2:int = -1) : void
        {
            if (this.gameLoader.global.isAdmin())
            {
                param2 = -1;
            }
            var _loc_3:Object = {};
            _loc_3[JSONKeys.ROOM_ID] = param1;
            _loc_3[JSONKeys.POSITION] = param2;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.JOIN_ROOM, _loc_3));
            _loc_3 = null;
            return;
        }// end function

        final public function joinRoomWithPassword(param1:Number, param2:int, param3:String) : void
        {
            var _loc_4:Object = {};
            _loc_4[JSONKeys.SUB_COMMAND] = RequestKeys.JOIN_ROOM_WITH_PASSWORD;
            _loc_4[JSONKeys.ROOM_ID] = param1;
            _loc_4[JSONKeys.POSITION] = param2;
            _loc_4[JSONKeys.PASSWORD] = param3;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.PASSWORD_BOARD, _loc_4));
            _loc_4 = null;
            return;
        }// end function

        final public function inviteJoinBoard(param1:Number, param2:int, param3:Number, param4:int, param5:String, param6:String, param7:int, param8:int = 0, param9:Boolean = false, param10:Boolean = false) : void
        {
            if (param8 == 0)
            {
                param8 = this.gameLoader.global.maxPlayer;
            }
            if (this.gameLoader.global.gameID == GlobalConstants.TaiXiuId)
            {
                if (this.gameLoader.isLobby())
                {
                    if (this.gameLoader.global.MyInfo.coin < 10000)
                    {
                        this.gameLoader.globalComponents.compoNotify.Show("? lm ci b?n c?n ph?i c");
                        return;
                    }
                }
            }
            var _loc_11:Object = {};
            _loc_11[JSONKeys.USER_ID] = param1;
            _loc_11[JSONKeys.POSITION] = param2;
            _loc_11[JSONKeys.BET_COIN] = param3;
            _loc_11[JSONKeys.TIME_OUT] = param4;
            _loc_11[JSONKeys.RULES] = param5;
            _loc_11[JSONKeys.EMOTION_NAME] = param6;
            _loc_11[JSONKeys.LEVEL_NO] = param7;
            _loc_11[JSONKeys.CUSTOM_MAX_PLAYER] = param8;
            _loc_11[JSONKeys.IS_SOLO] = param9;
            _loc_11[JSONKeys.IS_GOPGA] = param10;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.INVITE_JOIN_BOARD, _loc_11));
            _loc_11 = null;
            return;
        }// end function

        final public function joinLobby() : void
        {
            this.gameLoader.goToLobbyScreen();
            KF.socket.joinLobby();
            return;
        }// end function

        final public function joinGroup(param1:String) : void
        {
            KF.socket.joinGroup(param1);
            return;
        }// end function

        final public function loginForDebug(param1:String, param2:String, param3:String, param4:Object) : void
        {
            KF.socket.login(param1, param2, param3, param4);
            return;
        }// end function

        final public function login() : void
        {
            var _loc_1:Object = {};
            _loc_1[JSONKeys.USER_ID] = this.gameLoader.global.myUserId;
            _loc_1[JSONKeys.EMAIL] = this.gameLoader.global.myEmail;
            _loc_1[JSONKeys.PASSWORD] = this.gameLoader.global.myPassword;
            _loc_1[JSONKeys.GAME_ID] = this.gameLoader.global.gameID;
            _loc_1[JSONKeys.ROOM_INFO] = this.gameLoader.global.roomToJoinInfo;
            _loc_1[JSONKeys.IS_CLIENT_MOBILE] = true;
            _loc_1[JSONKeys.MOBILE_DEVICE_INFO] = this.gameLoader.preloader.api.getOSAndVersionInfo();
            _loc_1[JSONKeys.USER_IMEI] = this.gameLoader.preloader.getUniqueId();
            var _loc_2:* = this.gameLoader.getChildByName("maskForDisconnect") as Sprite;
            if (_loc_2 != null)
            {
                this.gameLoader.removeChild(_loc_2);
            }
            this.gameLoader.globalComponents.compoNotify.Hide();
            KF.socket.login(this.gameLoader.global.myUserId.toString(), this.gameLoader.global.myPassword, this.gameLoader.global.zoneName, _loc_1, this.gameLoader.global.socketKey);
            return;
        }// end function

        final public function confirmInvite(param1:Boolean, param2:Number, param3:Number, param4:int, param5:int, param6:String = "", param7:Boolean = false, param8:Boolean = false) : void
        {
            var _loc_9:Object = {};
            _loc_9[JSONKeys.USER_ID] = param2;
            _loc_9[JSONKeys.POSITION] = param5;
            _loc_9[JSONKeys.BET_COIN] = param3;
            _loc_9[JSONKeys.TIME_OUT] = param4;
            _loc_9[JSONKeys.CONFIRM_STATUS] = param1;
            _loc_9[JSONKeys.RULES] = param6;
            _loc_9[JSONKeys.IS_SOLO] = param7;
            _loc_9[JSONKeys.IS_GOPGA] = param8;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CONFIRM_INVITE_JOIN_BOARD, _loc_9));
            _loc_9 = null;
            return;
        }// end function

        final public function requestStartGame(param1:Object) : void
        {
            var _loc_2:* = new RequestCommand(RequestKeys.REQUEST_START_GAME, param1);
            KF.socket.sendRequest(_loc_2);
            _loc_2 = null;
            return;
        }// end function

        public function responseStartGame(param1:Boolean) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.CONFIRM_ACCEPT_START_MATCH] = param1;
            var _loc_3:* = new RequestCommand(RequestKeys.RESPONSE_START_GAME, _loc_2);
            if (!this.gameLoader.globalComponents.compoSetting.mainMovie.settingResource.btn_Close.visible)
            {
                this.gameLoader.globalComponents.compoSetting.Hide();
            }
            KF.socket.sendRequest(_loc_3);
            _loc_3 = null;
            return;
        }// end function

        public function sendStandUp(param1:Number, param2:Boolean) : void
        {
            if (param2)
            {
                KF.socket.playerToSpectator(param1);
                this.gameLoader.global.isStandUpAfterPlaying = false;
            }
            else
            {
                this.gameLoader.global.isStandUpAfterPlaying = true;
            }
            return;
        }// end function

        public function sendSitDown(param1:Number, param2:int) : void
        {
            KF.socket.spectatorToPlayer(param1, param2);
            return;
        }// end function

        public function sendStandUpByRoomOwner(param1:Array) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.LIST_USER_ID] = param1;
            _loc_2[JSONKeys.SUB_COMMAND] = JSONKeys.KICK_BY_OWNER;
            var _loc_3:* = new RequestCommand(RequestKeys.KICK_USER_AFTER_MATCH, _loc_2);
            KF.socket.sendRequest(_loc_3);
            _loc_3 = null;
            return;
        }// end function

        public function sendKickBlackList() : void
        {
            var _loc_1:Object = {};
            _loc_1[JSONKeys.SUB_COMMAND] = JSONKeys.KICK_BLACKLIST;
            var _loc_2:* = new RequestCommand(RequestKeys.KICK_USER_AFTER_MATCH, _loc_1);
            KF.socket.sendRequest(_loc_2);
            _loc_2 = null;
            return;
        }// end function

        public function sendExtCommandRequest() : void
        {
            var _loc_1:Object = {};
            var _loc_2:* = new RequestCommand(RequestKeys.GET_EXT_COMMAND_REQUEST, _loc_1);
            KF.socket.sendRequest(_loc_2);
            _loc_2 = null;
            return;
        }// end function

        public function sendInviteJoinBang(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.INVITE_JOIN_ASSOCIATION, param1));
            return;
        }// end function

        public function onSendRequestMakeFriend(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USERID_RECIEVER] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.SEND_MAKE_FRIEND, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendGetBangChuName(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_BANG_CHU_NAME, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendTextChat(param1:String, param2:String, param3:String) : void
        {
            var _loc_4:Object = {};
            _loc_4[JSONKeys.USER_ID] = param1;
            _loc_4[JSONKeys.NICK_NAME] = param2;
            _loc_4[JSONKeys.MESSAGE] = param3;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CHAT, _loc_4));
            _loc_4 = null;
            return;
        }// end function

        public function sendBuzzRequest(param1:String, param2:String, param3:String) : void
        {
            var _loc_4:Object = {};
            _loc_4[JSONKeys.USER_ID] = param1;
            _loc_4[JSONKeys.NICK_NAME] = param2;
            _loc_4[JSONKeys.MESSAGE] = param3;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.BUZZ, _loc_4));
            _loc_4 = null;
            return;
        }// end function

        public function sendGetFriendsInfo() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.FRIENDINFO, _loc_1));
            return;
        }// end function

        public function sendGetLobbyUsers() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.LOBBYUSER, _loc_1));
            return;
        }// end function

        public function sendGetBangHoiUsers() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ASSUSERS, _loc_1));
            return;
        }// end function

        public function sendGetSpecificItemBar(param1:int) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.ITEM_BAR_CATEGORY_ID] = param1;
            _loc_2[JSONKeys.KIND] = JSONKeys.GET_ITEM_BAR;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ITEM_BAR, _loc_2));
            return;
        }// end function

        public function sendBuyItem(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ITEM_BAR, param1));
            return;
        }// end function

        public function sendGetItemBarAllCategory(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.KIND] = JSONKeys.GET_ITEM_BAR_CATEGOGY;
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ITEM_BAR, _loc_2));
            return;
        }// end function

        public function sendGetPersonalInfo() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_PERSONAL_INFO, _loc_1));
            return;
        }// end function

        public function SendGetPersonalAssets(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_PERSONAL_ASSET_LIST, _loc_2));
            return;
        }// end function

        public function sendUserUseAssets(param1:String) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = this.gameLoader.global.MyInfo.userId;
            _loc_2[JSONKeys.IMAGE_PATH] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.USER_USE_ASSET, _loc_2));
            return;
        }// end function

        public function SendGetAssetsList() : void
        {
            return;
        }// end function

        public function sendBuyAssets(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.BUY_ASSET, param1));
            return;
        }// end function

        public function sendUpdateMaxBet() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.UPDATE_MAX_BET, _loc_1));
            return;
        }// end function

        public function sendChangeStatusBoard(param1:Number, param2:String) : void
        {
            var _loc_3:Object = {};
            _loc_3[JSONKeys.ROOM_ID] = param1;
            _loc_3[JSONKeys.BOARD_STATUS] = param2;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CHANGE_STATUS_BOARD, _loc_3));
            return;
        }// end function

        public function sendAutoJoin(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.AUTO_JOIN, param1));
            return;
        }// end function

        public function sendCapturePhoto() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CAPTURE_PHOTO, _loc_1));
            return;
        }// end function

        public function sendGetNextItem() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_NEXT_ITEM, _loc_1));
            return;
        }// end function

        public function sendLockBoard(param1:Boolean) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.LOCK_BOARD] = param1 ? (1) : (0);
            KF.socket.sendRequest(new RequestCommand(RequestKeys.LOCK_BOARD, _loc_2));
            return;
        }// end function

        public function sendConfirmMakeFriend(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CONFIRM_MAKE_FRIEND, param1));
            return;
        }// end function

        public function sendPlayEmotion(param1:String) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.EMOTION_NAME] = param1;
            _loc_2[JSONKeys.USER_ID] = this.gameLoader.global.MyInfo.userId;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.PLAY_EMOTION, _loc_2));
            return;
        }// end function

        public function sendComplain(param1:String) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.MESSAGE] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.SEND_COMPLAIN, _loc_2));
            return;
        }// end function

        final public function sendGetCoinAndExpForAssociation() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_EXPANDCOIN_FOR_ASS, _loc_1));
            return;
        }// end function

        public function kickBoard(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.ADMIN_ACTION_TYPE] = RequestKeys.ADMIN_KICK_BOARD;
            _loc_2[JSONKeys.ROOM_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ADMIN_ACTION, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function adminKickUser(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.ADMIN_ACTION_TYPE] = RequestKeys.ADMIN_KICK_USER;
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.ADMIN_ACTION, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function getItemBetPath() : void
        {
            var _loc_1:Object = null;
            if (this.gameLoader.global.isVongGiauMat())
            {
                _loc_1 = {};
            }
            KF.socket.sendRequest(new RequestCommand(RequestKeys.RECEIVE_ITEM_BET, _loc_1));
            _loc_1 = null;
            return;
        }// end function

        public function getLockBoard() : void
        {
            if (this.gameLoader.global.isRoomDefault)
            {
                return;
            }
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_LOCK_BOARD, _loc_1));
            _loc_1 = null;
            return;
        }// end function

        public function sendNoticeForUserKickedAfterEndMatch(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = param1;
            _loc_2[JSONKeys.NOTICE_TYPE] = GlobalConstants.KICK_OUT;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.SYSTEM_NOTICE, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendConfirmJoinBang(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.INVITE_JOIN_ASSOCIATION, param1));
            return;
        }// end function

        public function sendUpdatePlayTime(param1:int) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.MINUTE_TO_UPDATE] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.UPDATE_TIME_PLAY, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendCheckConnectionStrength() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CHECK_CONNECTION_STRENGTH, _loc_1));
            _loc_1 = null;
            return;
        }// end function

        public function sendGetAllAvatar(param1:Boolean = false) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.SUB_COMMAND] = RequestKeys.GET_ALL_AVATAR;
            _loc_2[JSONKeys.USER_ID] = this.gameLoader.global.MyInfo.userId;
            _loc_2[JSONKeys.AVATAR_TYPE] = "USER_AVATAR";
            _loc_2[JSONKeys.IS_UPLOAD] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.AVATAR_COMMAND, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendActiveAvatar(param1:Number, param2:String, param3:String) : void
        {
            var _loc_4:Object = {};
            _loc_4[JSONKeys.SUB_COMMAND] = RequestKeys.ACTIVE_AVATAR;
            _loc_4[JSONKeys.USER_ID] = param1;
            _loc_4[JSONKeys.AVATAR_PATH] = param3;
            _loc_4[JSONKeys.AVATAR_ID] = param2;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.AVATAR_COMMAND, _loc_4));
            _loc_4 = null;
            return;
        }// end function

        public function sendUploadAvatar(param1:String, param2:String, param3:String, param4:String, param5:String, param6:String) : void
        {
            var _loc_7:Object = {};
            _loc_7[JSONKeys.SUB_COMMAND] = RequestKeys.UPLOAD_AVATAR;
            _loc_7[JSONKeys.USER_ID] = this.gameLoader.global.MyInfo.userId;
            _loc_7[JSONKeys.AVATAR_TYPE] = param1;
            _loc_7[JSONKeys.AVATAR_PATH] = param2;
            _loc_7[JSONKeys.PRICE] = param3;
            _loc_7[JSONKeys.ROOT_PRICE] = param4;
            _loc_7[JSONKeys.DESCRIPTION] = param5;
            _loc_7[JSONKeys.QUANTITY] = param6;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.AVATAR_COMMAND, _loc_7));
            _loc_7 = null;
            return;
        }// end function

        public function sendGetBoardBlackList() : void
        {
            var _loc_1:Object = {};
            _loc_1[JSONKeys.SUB_COMMAND] = RequestKeys.GET_AVATAR_BOARD_BLACKLIST;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.BOARD_BLACKLIST, _loc_1));
            _loc_1 = null;
            return;
        }// end function

        public function sendAddIntoBoardBlackList(param1:String, param2:String, param3:Boolean) : void
        {
            var _loc_4:Object = {};
            _loc_4[JSONKeys.SUB_COMMAND] = RequestKeys.ADD_BOARD_BLACKLIST;
            _loc_4[JSONKeys.USER_ID] = param1;
            _loc_4[JSONKeys.USER_NAME] = param2;
            _loc_4[JSONKeys.BOARD_STATE] = param3;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.BOARD_BLACKLIST, _loc_4));
            _loc_4 = null;
            return;
        }// end function

        public function sendRemoveOutBoardBlackList(param1:String) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.SUB_COMMAND] = RequestKeys.REMOVE_BOARD_BLACKLIST;
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.BOARD_BLACKLIST, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendAddIntoBlackListUser(param1:int) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.SUB_COMMAND] = RequestKeys.ADD_TO_USER_BLACKLIST;
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.USER_BLACKLIST, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendGetUsersInBlackList() : void
        {
            var _loc_1:Object = {};
            _loc_1[JSONKeys.SUB_COMMAND] = RequestKeys.GET_ALL_FROM_USER_BLACKLIST;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.USER_BLACKLIST, _loc_1));
            _loc_1 = null;
            return;
        }// end function

        public function sendRemoveUserOutBlackList(param1:int) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.SUB_COMMAND] = RequestKeys.REMOVE_FROM_USER_BLACKLIST;
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.USER_BLACKLIST, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendSetPasswordBoard(param1:String) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.SUB_COMMAND] = RequestKeys.SET_PASS;
            _loc_2[JSONKeys.PASSWORD] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.PASSWORD_BOARD, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        public function sendMoveToNewServer(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.MOVE_NEW_SERVER, _loc_2));
            _loc_2 = null;
            return;
        }// end function

        final public function sendApplySettingsForNextMatch(param1:Number, param2:Number, param3:String, param4:int, param5:Boolean = false, param6:Boolean = false) : void
        {
            var _loc_7:Object = {};
            _loc_7[JSONKeys.BET_COIN] = param1;
            _loc_7[JSONKeys.TIME_OUT] = param2;
            _loc_7[JSONKeys.RULES] = param3;
            _loc_7[JSONKeys.IS_SOLO] = param5;
            _loc_7[JSONKeys.IS_GOPGA] = param6;
            if (this.gameLoader.global.gameID == GlobalConstants.PokerGameId || this.gameLoader.global.gameID == GlobalConstants.LiengId)
            {
                _loc_7[JSONKeys.CUSTOM_MAX_PLAYER] = param4;
            }
            KF.socket.sendRequest(new RequestCommand(RequestKeys.APPLY_SETTINGS_FOR_NEW_MATCH, _loc_7));
            _loc_7 = null;
            return;
        }// end function

        public function sendGetListCaoThu() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_TOP_CAO_THU, _loc_1));
            return;
        }// end function

        public function sendGetAllInfoUser(param1:int) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.GET_ALL_INFO_USER, _loc_2));
            return;
        }// end function

        public function sendSetTaiXiuMaxBet(param1:Number) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.COMMAND] = JSONKeys.SET_MAX_BET;
            _loc_2[JSONKeys.TAIXIU_MAX_BET] = param1;
            var _loc_3:* = new RequestCommand(JSONKeys.GAME, _loc_2);
            KF.socket.sendRequest(_loc_3);
            _loc_3 = null;
            return;
        }// end function

        public function sendUpdateCustomMaxPlayer(param1:int) : void
        {
            if (param1 < 2)
            {
                return;
            }
            var _loc_2:Object = {};
            _loc_2[JSONKeys.CUSTOM_MAX_PLAYER] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.CUSTOM_MAX_PLAYER, _loc_2));
            return;
        }// end function

        public function leaveRoomByUser() : void
        {
            if (this.gameLoader.global.MyInfo.isPlayer == false)
            {
                return;
            }
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.LEAVE_ROOM_BY_USER, _loc_1));
            return;
        }// end function

        public function sendGetHistoryJackpot() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.JACK_POT, _loc_1));
            return;
        }// end function

        public function sendGetRateJackpot() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.JACKPOT_RATE, _loc_1));
            return;
        }// end function

        public function sendRequestUpdateMyCoin() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.UPDATE_COIN_USER, _loc_1));
            return;
        }// end function

        public function sendUpdateActiveJackpot(param1:Boolean) : void
        {
            var _loc_2:Object = {};
            _loc_2[JackpotRequestApplyRule.isActiveKey] = param1;
            KF.socket.sendRequest(new RequestCommand(RequestKeys.JACKPOT_ACTIVE, _loc_2));
            return;
        }// end function

        public function sendPing() : void
        {
            var _loc_1:Object = {};
            KF.socket.sendRequest(new RequestCommand(RequestKeys.PING, _loc_1));
            return;
        }// end function

        public function sendActiveStar(param1:Object) : void
        {
            KF.socket.sendRequest(new RequestCommand(RequestKeys.STAR_HANDLER, param1));
            return;
        }// end function

    }
}
