package net.mgame.controllers.features
{
    import MGameUtilities.*;
    import net.mgame.controllers.features.*;
    import net.mgame.defaultcomponents.*;
    import net.mgame.keys.*;

    public class InviteJoinBangHandler extends Object implements IHandlerMessage
    {
        private var gameLoader:GameLoader;
        private var inviterID:int;
        private var associationID:int;

        public function InviteJoinBangHandler()
        {
            this.gameLoader = GameLoader.getInstance();
            return;
        }// end function

        public function handleMessage(param1:Object) : void
        {
            var _loc_2:String = null;
            var _loc_3:String = null;
            if (param1[JSONKeys.TYPE_OF_REQUEST] == GlobalConstants.CONFIRM)
            {
                this.ReceiveConfirmJoinBang(param1);
                return;
            }
            if (param1[JSONKeys.STATUS_OF_REQUEST] == 1)
            {
                this.inviterID = int(param1[JSONKeys.USER_ID]);
                this.associationID = param1[JSONKeys.ASSOCIATION_ID];
                _loc_2 = "";
                if (this.gameLoader.global.MyInfo.userId == param1[JSONKeys.USERID_RECIEVER])
                {
                    if (this.gameLoader.global.listUserInviteMeJoinBang.indexOf(this.inviterID) > -1)
                    {
                        return;
                    }
                    this.gameLoader.global.listUserInviteMeJoinBang.push(this.inviterID);
                    _loc_3 = param1[JSONKeys.ASSSOCIATION_NAME];
                    _loc_2 = this.gameLoader.global.MessageInviteJoinAssociation;
                    _loc_2 = _loc_2.replace("[Inviter]", param1[JSONKeys.OWNER_ASSOCIATION_NAME]);
                    _loc_2 = _loc_2.replace("[AssociationName]", _loc_3);
                    this.gameLoader.globalComponents.compoNotify.ShowWithArgreeAndNoAgree(_loc_2, this.AgreeJoinBang, this.NotAgreeJoinBang);
                }
                else
                {
                    _loc_2 = this.gameLoader.global.MessageNoticeInviteJoinAssociation;
                    _loc_2 = _loc_2.replace("[nick]", param1[JSONKeys.NICK_NAME]);
                    this.gameLoader.globalComponents.compoNotify.Show(_loc_2);
                }
            }
            else
            {
                switch(param1[JSONKeys.STATUS_OF_REQUEST])
                {
                    case 0:
                    {
                        _loc_2 = this.gameLoader.global.MessageSystemBusy;
                        break;
                    }
                    case 2:
                    {
                        _loc_2 = this.gameLoader.global.MessageOnlyOwnerCanInvite;
                        break;
                    }
                    case 3:
                    {
                        _loc_2 = this.gameLoader.global.MessageUserHavedAssociation;
                        break;
                    }
                    case 4:
                    {
                        _loc_2 = this.gameLoader.global.MessageUserNotEnoughtGold;
                    }
                    default:
                    {
                        break;
                    }
                }
                this.gameLoader.globalComponents.compoNotify.Show(_loc_2);
            }
            return;
        }// end function

        private function ReceiveConfirmJoinBang(param1:Object) : void
        {
            var _loc_2:* = param1[JSONKeys.USER_ID_SEND];
            var _loc_3:* = param1[JSONKeys.NICK_NAME];
            var _loc_4:* = param1[JSONKeys.AGRREE];
            var _loc_5:* = this.gameLoader.global.MessageNotiveJoinAssociation;
            _loc_5 = _loc_5.replace("[nick]", _loc_3);
            var _loc_6:* = this.gameLoader.globalComponents.compoNotify;
            if (_loc_4)
            {
                _loc_5 = _loc_5.replace("[Answer]", this.gameLoader.global.No_AnswerYes);
                this.gameLoader.global.ListAssociationId = this.gameLoader.global.ListAssociationId + (";" + _loc_2);
            }
            else
            {
                _loc_5 = _loc_5.replace("[Answer]", this.gameLoader.global.No_AnswerNo);
            }
            this.gameLoader.globalComponents.compoNotify.Show(_loc_5);
            return;
        }// end function

        private function AgreeJoinBang() : void
        {
            this.SendConfirmJoinBang(true);
            return;
        }// end function

        private function NotAgreeJoinBang() : void
        {
            this.SendConfirmJoinBang(false);
            return;
        }// end function

        private function SendConfirmJoinBang(param1:Boolean) : void
        {
            var _loc_2:Object = {};
            _loc_2[JSONKeys.USER_ID] = this.inviterID;
            _loc_2[JSONKeys.AGRREE] = StringFormat.B2S(param1);
            _loc_2[JSONKeys.TYPE_OF_REQUEST] = GlobalConstants.CONFIRM;
            _loc_2[JSONKeys.ASSOCIATION_ID] = this.associationID;
            this.gameLoader.controller.sendConfirmJoinBang(_loc_2);
            return;
        }// end function

    }
}
