package net.mgame.controllers.features
{
    import MGameUtilities.*;
    import flash.events.*;
    import flash.utils.*;
    import net.mgame.controllers.features.*;
    import net.mgame.keys.*;
    import net.mgame.utils.*;

    public class InviteJoinBoardHandler extends Object implements IHandlerMessage
    {
        private var gameLoader:GameLoader;
        private var betCoin:Number;
        private var timeOut:int;
        private var position:int;
        private var userId:Number;
        private var rules:String;
        private var timerWaitingForAmInvitation:Timer;
        private var coin:Number;
        private var isSolo:Boolean;
        private var isGopGa:Boolean;

        public function InviteJoinBoardHandler()
        {
            this.gameLoader = GameLoader.getInstance();
            return;
        }// end function

        public function handleMessage(param1:Object) : void
        {
            if (this.gameLoader.isGame())
            {
                return;
            }
            if (this.gameLoader.global.MyInfo.userKind == GlobalConstants.ADMIN_USERTYPE || this.gameLoader.global.MyInfo.userKind == GlobalConstants.MOD_USERTYPE)
            {
                return;
            }
            this.betCoin = param1[JSONKeys.BET_COIN];
            this.timeOut = param1[JSONKeys.TIME_OUT];
            this.position = param1[JSONKeys.POSITION];
            this.userId = param1[JSONKeys.USER_ID];
            this.rules = param1[JSONKeys.RULES];
            this.isGopGa = param1[JSONKeys.IS_GOPGA];
            var _loc_2:* = param1[JSONKeys.TOTAL_PLAYER];
            var _loc_3:* = param1[JSONKeys.EMOTION_NAME];
            var _loc_4:* = param1[JSONKeys.LEVEL_NO];
            var _loc_5:* = param1[JSONKeys.NICK_NAME];
            this.coin = param1[JSONKeys.COIN];
            this.isSolo = param1[JSONKeys.IS_SOLO];
            var _loc_6:* = this.gameLoader.globalComponents.compoSetting.GetRuleString(this.rules);
            var _loc_7:String = "";
            if (_loc_2 > 0)
            {
                _loc_7 = StringUtils.formatString(this.gameLoader.global.inviteToPlayInPlayBoardMessage, this.gameLoader.global.currency, Format.Coin(this.betCoin.toString()), this.gameLoader.global.timeOutToText(this.timeOut), _loc_2, _loc_6);
            }
            else
            {
                _loc_7 = StringUtils.formatString(this.gameLoader.global.inviteToPlayMessage, this.gameLoader.global.currency, Format.Coin(this.betCoin.toString()), this.gameLoader.global.timeOutToText(this.timeOut), _loc_6);
            }
            this.gameLoader.globalComponents.compoReceiveInviteJoinBoard.timeOut = 10000;
            var _loc_8:* = _loc_5 + "|" + _loc_4 + "|" + this.coin + "|" + _loc_3 + "|" + _loc_7 + "|" + this.isSolo + "|" + this.isGopGa;
            this.gameLoader.globalComponents.compoReceiveInviteJoinBoard.Show(_loc_8, this.confirmYES, this.confirmNO);
            if (this.timerWaitingForAmInvitation == null)
            {
                this.timerWaitingForAmInvitation = new Timer(10000, 1);
                this.timerWaitingForAmInvitation.addEventListener(TimerEvent.TIMER_COMPLETE, this.onTimerWaitingForAnInvitationComplete, false, 0, true);
            }
            this.timerWaitingForAmInvitation.start();
            return;
        }// end function

        private function onTimerWaitingForAnInvitationComplete(event:TimerEvent) : void
        {
            this.gameLoader.controller.confirmInvite(false, this.userId, this.betCoin, this.timeOut, this.position);
            this.gameLoader.globalComponents.compoNotify.Hide();
            this.timerWaitingForAmInvitation.reset();
            return;
        }// end function

        private function confirmNO() : void
        {
            this.gameLoader.controller.confirmInvite(false, this.userId, this.betCoin, this.timeOut, this.position);
            this.timerWaitingForAmInvitation.reset();
            return;
        }// end function

        private function confirmYES() : void
        {
            this.gameLoader.global.betTime = this.timeOut;
            this.gameLoader.global.betCoin = this.betCoin;
            this.gameLoader.global.rules = this.rules;
            this.gameLoader.global.inviteBetCoin = this.betCoin;
            this.gameLoader.controller.confirmInvite(true, this.userId, this.betCoin, this.timeOut, this.position, this.rules, this.isSolo, this.isGopGa);
            this.timerWaitingForAmInvitation.reset();
            return;
        }// end function

    }
}
