package net.mgame.controllers.features
{
    import MGameUtilities.*;
    import net.king.entities.*;
    import net.mgame.controllers.features.*;
    import net.mgame.keys.*;
    import net.mgame.models.*;
    import net.mgame.utils.*;

    public class NoticeSystemHandler extends Object implements IHandlerMessage
    {
        private var gameLoader:GameLoader;
        private var NOTICE_KICKOUT:int = 0;
        private var NOTICE_LEVELUP:int = 1;
        private var NOTICE_AWARDCOINFORNEWUSER:int = 2;

        public function NoticeSystemHandler()
        {
            this.gameLoader = GameLoader.getInstance();
            return;
        }// end function

        public function handleMessage(param1:Object) : void
        {
            var _loc_3:Number = NaN;
            var _loc_4:String = null;
            var _loc_2:* = int(param1[JSONKeys.NOTICE_TYPE]);
            switch(_loc_2)
            {
                case this.NOTICE_KICKOUT:
                {
                    _loc_3 = Number(param1[JSONKeys.USER_ID]);
                    _loc_4 = String(param1[JSONKeys.NICK_NAME]);
                    if (_loc_4 == null || _loc_4.length == 0)
                    {
                        return;
                    }
                    this.ShowNoticeKickOut(_loc_3, _loc_4);
                    break;
                }
                case this.NOTICE_LEVELUP:
                {
                    this.ShowNoticeUpLevel(param1);
                    break;
                }
                case this.NOTICE_AWARDCOINFORNEWUSER:
                {
                    this.showNoticeAwardCoinForNewUser(param1);
                    break;
                }
                default:
                {
                    break;
                }
            }
            return;
        }// end function

        private function showNoticeAwardCoinForNewUser(param1:Object) : void
        {
            var _loc_2:* = Format.Coin(param1[JSONKeys.COIN]);
            var _loc_3:* = GlobalConstants.NOTICE_RECEIVE_AWARDCOIN_FOR_NEWUSER;
            this.gameLoader.lobbyScreen.compoBottomControlBar.Coin = this.gameLoader.global.MyInfo.coin;
            this.gameLoader.globalComponents.compoNotify.Show(StringUtils.formatString(_loc_3, _loc_2, this.gameLoader.global.currency));
            return;
        }// end function

        private function ShowNoticeKickOut(param1:Number, param2:String) : void
        {
            var _loc_3:User = null;
            var _loc_4:UserInfo = null;
            var _loc_5:String = null;
            var _loc_6:String = null;
            if (this.gameLoader.global.isPlaying)
            {
                _loc_5 = this.gameLoader.global.getMessageKickedOut;
                if (this.gameLoader.global.MyInfo.userId != param1)
                {
                    _loc_5 = _loc_5.replace("B?n", param2);
                }
                _loc_6 = "<font color=\'#FFFF99\'><b>" + _loc_5 + "</b></font>";
                this.gameLoader.gameScreen.Notice = _loc_5;
            }
            else
            {
                _loc_5 = this.gameLoader.global.MessageNoticeOwnerKickOut;
                if (this.gameLoader.global.MyInfo.userId != param1)
                {
                    _loc_5 = _loc_5.replace("B?n", param2);
                    _loc_6 = "<font color=\'#FFFF99\'><b>" + _loc_5 + "</b></font>";
                    this.gameLoader.gameScreen.Notice = _loc_5;
                }
                else
                {
                    this.gameLoader.globalComponents.compoNotify.Show(_loc_5);
                }
            }
            return;
        }// end function

        private function ShowNoticeUpLevel(param1:Object) : void
        {
            var _loc_2:* = int(param1[JSONKeys.LEVEL_NO]);
            var _loc_3:* = Format.Coin(param1[JSONKeys.COIN]);
            var _loc_4:* = this.gameLoader.global.getMessageLevelUp;
            this.gameLoader.globalComponents.compoNotify.Show(StringUtils.formatString(_loc_4, _loc_2, _loc_3, this.gameLoader.global.currency));
            return;
        }// end function

    }
}
