package net.mgame.controllers.features
{
    import ICompoLuat.*;
    import MGameUtilities.*;
    import net.mgame.controllers.features.*;
    import net.mgame.keys.*;
    import net.mgame.utils.*;

    public class ResponseStartGameHandler extends Object implements IHandlerMessage
    {
        private var gameLoader:GameLoader;
        private var newBetCoin:Number;
        private var newTimeOut:int;
        private var newRules:String;
        private var newIsSolo:Boolean;
        private var newIsGopGa:Boolean;

        public function ResponseStartGameHandler()
        {
            this.gameLoader = GameLoader.getInstance();
            return;
        }// end function

        public function handleMessage(param1:Object) : void
        {
            var _loc_8:String = null;
            var _loc_2:* = Number(param1[JSONKeys.ROOM_ID]);
            var _loc_3:* = param1[JSONKeys.RULES];
            var _loc_4:* = int(param1[JSONKeys.TIME_OUT]);
            var _loc_5:* = Number(param1[JSONKeys.BET_COIN]);
            var _loc_6:* = Boolean(param1[JSONKeys.IS_SOLO]);
            var _loc_7:* = Boolean(param1[JSONKeys.IS_GOPGA]);
            var _loc_9:String = "";
            if (_loc_3 == null || _loc_3 == "")
            {
                _loc_8 = this.gameLoader.global.confirmStartMatchMessage;
                if (_loc_6)
                {
                    _loc_9 = _loc_9 + "\n Bn Solo";
                }
                if (_loc_7)
                {
                    _loc_9 = _loc_9 + "\n Bn G";
                }
                _loc_8 = StringUtils.formatString(_loc_8, this.gameLoader.global.timeOutToText(_loc_4), Format.Coin(_loc_5.toString()) + _loc_9);
            }
            else
            {
                _loc_9 = this.gameLoader.global.getRuleString(_loc_3, this.gameLoader.global.gameID);
                _loc_9 = _loc_9.substr(9);
                if (_loc_6)
                {
                    _loc_9 = _loc_9 + "\n Bn Solo";
                }
                if (_loc_7)
                {
                    _loc_9 = _loc_9 + "\n Bn G";
                }
                _loc_8 = this.gameLoader.global.confirmStartMatchMessageWithRules;
                _loc_8 = StringUtils.formatString(_loc_8, this.gameLoader.global.timeOutToText(_loc_4), Format.Coin(_loc_5.toString()), _loc_9);
            }
            if (this.gameLoader.global.MyInfo.isRoomOwner)
            {
                this.gameLoader.global.betCoin = _loc_5;
                this.gameLoader.global.betTime = _loc_4;
                this.gameLoader.global.rules = _loc_3;
                this.gameLoader.global.isSolo = _loc_6;
                this.gameLoader.global.isGopGa = _loc_7;
                if (this.gameLoader.globalComponents.compoBETDialog.compoLuatGame)
                {
                    this.gameLoader.globalComponents.compoBETDialog.compoLuatGame.isSolo = _loc_6;
                }
                this.gameLoader.globalComponents.compoSetting.isGopGa = _loc_7;
            }
            if (this.gameLoader.global.isDifferenceSetting(_loc_5, _loc_4, _loc_3, _loc_6, _loc_7) || this.gameLoader.global.inviteBetCoin > 0 && this.gameLoader.global.inviteBetCoin != this.gameLoader.global.betCoin)
            {
                this.newBetCoin = _loc_5;
                this.newTimeOut = _loc_4;
                this.newRules = _loc_3;
                this.newIsSolo = _loc_6;
                this.newIsGopGa = _loc_7;
                this.gameLoader.globalComponents.compoNotify.ShowWithArgreeAndNoAgree(_loc_8, this.onResponseToPlay, this.onRejectToPlay);
                this.gameLoader.globalComponents.compoNotify.y = this.gameLoader.globalComponents.compoNotify.y - this.gameLoader.getScaleVertical(30);
            }
            else
            {
                this.gameLoader.global.betCoin = _loc_5;
                this.gameLoader.global.betTime = _loc_4;
                this.gameLoader.global.rules = _loc_3;
                this.gameLoader.global.isSolo = _loc_6;
                this.gameLoader.global.isGopGa = _loc_7;
                if (this.gameLoader.globalComponents.compoSetting.compoLuatGame)
                {
                    this.gameLoader.globalComponents.compoSetting.compoLuatGame.isSolo = _loc_6;
                }
                this.gameLoader.globalComponents.compoSetting.isGopGa = _loc_7;
                this.gameLoader.controller.responseStartGame(true);
            }
            return;
        }// end function

        private function onRejectToPlay() : void
        {
            this.gameLoader.globalComponents.compoNotify.y = this.gameLoader.globalComponents.compoNotify.y + this.gameLoader.getScaleVertical(30);
            this.gameLoader.controller.responseStartGame(false);
            this.gameLoader.global.inviteBetCoin = 0;
            return;
        }// end function

        private function onResponseToPlay() : void
        {
            this.gameLoader.globalComponents.compoNotify.y = this.gameLoader.globalComponents.compoNotify.y + this.gameLoader.getScaleVertical(30);
            this.gameLoader.global.betCoin = this.newBetCoin;
            this.gameLoader.global.betTime = this.newTimeOut;
            this.gameLoader.global.rules = this.newRules;
            this.gameLoader.global.isGopGa = this.newIsGopGa;
            if (this.gameLoader.globalComponents.compoSetting.compoLuatGame)
            {
                this.gameLoader.globalComponents.compoSetting.compoLuatGame.isSolo = this.newIsSolo;
            }
            this.gameLoader.globalComponents.compoSetting.isGopGa = this.newIsGopGa;
            this.gameLoader.globalComponents.compoSetting.SetRule(this.newRules);
            this.gameLoader.global.inviteBetCoin = 0;
            this.gameLoader.controller.responseStartGame(true);
            return;
        }// end function

    }
}
