package net.mgame.controllers.features.jackpot
{
    import MGameUtilities.*;
    import com.greensock.*;
    import net.mgame.controllers.features.*;
    import net.mgame.keys.*;
    import net.mgame.utils.*;

    public class JackpotHandler extends Object implements IHandlerMessage
    {
        private var gameLoader:GameLoader;
        private var NOTICE_TYPE:String = "nt";
        private var NOTICE_INFO:int = 1;
        private var NOTICE_HISTORY:int = 2;
        private var NOTICE_USER_WIN:int = 3;
        private var NOTICE_USER_CONTRIBUTE_COIN:int = 4;
        private var NOTICE_JACKPOT_RATE:int = 5;
        private var HANDLE_REFESH_JACKPOT_STATUS:int = 6;

        public function JackpotHandler()
        {
            this.gameLoader = GameLoader.getInstance();
            return;
        }// end function

        public function handleMessage(param1:Object) : void
        {
            this.gameLoader.gameScreen.jackPot.show();
            var _loc_2:* = int(param1[this.NOTICE_TYPE]);
            switch(_loc_2)
            {
                case this.NOTICE_INFO:
                {
                    this.handleInfo(param1);
                    break;
                }
                case this.NOTICE_HISTORY:
                {
                    this.handleHistory(param1);
                    break;
                }
                case this.NOTICE_USER_WIN:
                {
                    this.handleUserWin(param1);
                    break;
                }
                case this.NOTICE_USER_CONTRIBUTE_COIN:
                {
                    this.handleUserContributeCoin(param1);
                    break;
                }
                case this.NOTICE_JACKPOT_RATE:
                {
                    this.handleRateJackpot(param1);
                    break;
                }
                case this.HANDLE_REFESH_JACKPOT_STATUS:
                {
                    this.handleRefeshJackpotStatus(param1);
                    break;
                }
                default:
                {
                    break;
                }
            }
            return;
        }// end function

        private function handleRefeshJackpotStatus(param1:Object) : void
        {
            this.gameLoader.gameScreen.jackPot.processActiveJackpot();
            return;
        }// end function

        private function handleUserContributeCoin(param1:Object) : void
        {
            this.gameLoader.global.refreshMyInfo();
            var _loc_2:* = Number(param1[JSONKeys.COIN]) * -1;
            var _loc_3:* = this.gameLoader.gameScreen.getChildObjectbyName("compoUserInfoPlay_" + this.gameLoader.global.MyInfo.position) as CompoUserInfoPlay;
            if (_loc_3 == null)
            {
                return;
            }
            _loc_3.showEffectCoin(_loc_2, " Cu?c Jackpot");
            var _loc_4:* = new CoinFly_mc();
            _loc_4.x = _loc_3.x;
            _loc_4.y = _loc_3.y;
            this.gameLoader.gameScreen.addChild(_loc_4);
            TweenLite.to(_loc_4, 0.8, {x:this.gameLoader.gameScreen.jackPot.x + this.gameLoader.gameScreen.jackPot.jackpotCoin_txt.x + this.gameLoader.gameScreen.jackPot.jackpotCoin_txt.width * 0.5, y:this.gameLoader.gameScreen.jackPot.y + this.gameLoader.gameScreen.jackPot.jackpotCoin_txt.y, scaleX:0, scaleY:0, onComplete:this.onCompleteEffectGiveCoinToJackpot, onCompleteParams:[_loc_4]});
            return;
        }// end function

        private function onCompleteEffectGiveCoinToJackpot(param1:CoinFly_mc) : void
        {
            if (param1 == null)
            {
                return;
            }
            if (this.gameLoader.gameScreen.contains(param1))
            {
                this.gameLoader.gameScreen.removeChild(param1);
            }
            param1 = null;
            return;
        }// end function

        private function handleInfo(param1:Object) : void
        {
            var _loc_2:* = param1[JSONKeys.COIN];
            this.gameLoader.gameScreen.jackPot.coin = _loc_2;
            return;
        }// end function

        private function handleHistory(param1:Object) : void
        {
            this.gameLoader.gameScreen.jackPot.listHistoryJackpot = param1[JSONKeys.ARR_NICK];
            this.gameLoader.gameScreen.jackPot.showHistoryJackpot();
            return;
        }// end function

        private function handleRateJackpot(param1:Object) : void
        {
            this.gameLoader.gameScreen.jackPot.listRateJackpot = param1[JSONKeys.RATE_ID];
            this.gameLoader.gameScreen.jackPot.show();
            return;
        }// end function

        private function handleUserWin(param1:Object) : void
        {
            var _loc_2:* = param1[JSONKeys.ARR_NICK];
            var _loc_3:* = int(_loc_2[JSONKeys.USER_ID]);
            var _loc_4:* = _loc_2[JSONKeys.NICK_NAME];
            var _loc_5:* = _loc_2[JSONKeys.MATCH_ID];
            var _loc_6:* = _loc_2[JSONKeys.LIST_CARD];
            var _loc_7:* = _loc_2[JSONKeys.COIN];
            var _loc_8:String = "";
            if (this.gameLoader.global.isVongGiauMat() == false)
            {
                _loc_8 = StringUtils.formatString("{0} th?ng Jackpot {1}", _loc_4, Format.Coin(_loc_7.toString()));
                this.gameLoader.gameScreen.jackPot.showMessage(_loc_8);
            }
            else
            {
                _loc_8 = StringUtils.formatString("{0} th?ng Jackpot {1}", "C", Format.Coin(_loc_7.toString()));
                this.gameLoader.gameScreen.jackPot.showMessage(_loc_8);
                if (this.gameLoader.global.MyInfo.userId != _loc_3)
                {
                    return;
                }
            }
            var _loc_9:Object = {};
            _loc_9[JSONKeys.USER_ID] = _loc_3;
            _loc_9[JSONKeys.COIN] = _loc_7;
            this.gameLoader.gameScreen.handleUnknownObject("UserWinJackpot", _loc_9);
            if (this.gameLoader.gameScreen.jackPot.listHistoryJackpot.length == 0)
            {
                return;
            }
            this.gameLoader.gameScreen.jackPot.listHistoryJackpot.push(_loc_2);
            return;
        }// end function

    }
}
