package net.mgame.defaultcomponents
{
    import MGameEvents.*;
    import MGameUtilities.*;
    import flash.display.*;
    import flash.events.*;
    import mgame.loader.*;
    import mgame.manager.*;

    public class CompoBottomControlBar extends MGSprite
    {
        public var preLoader:Object = null;
        private var panel:CompoBottomControlBarMC;
        public var userInfoMc:UserInfoMC = null;
        private var _currency:String = "G";
        private var coin:Number = 0;
        private var nickName:String = "";
        private var avatar:String = "";

        public function CompoBottomControlBar()
        {
            this.panel = new CompoBottomControlBarMC();
            addChild(this.panel);
            this.panel.btnQuickPlay.addEventListener(MouseEvent.CLICK, this.onQuickPlay, false, 0, true);
            this.panel.btnCreateBoard.addEventListener(MouseEvent.CLICK, this.onCreateBoard, false, 0, true);
            this.panel.napGoldBtn.addEventListener(MouseEvent.CLICK, this.onNapGold, false, 0, true);
            this.panel.btnRoom.addEventListener(MouseEvent.CLICK, this.onInviteFriend, false, 0, true);
            this.userInfoMc = new UserInfoMC();
            this.userInfoMc.buttonMode = true;
            this.userInfoMc.mouseChildren = false;
            this.userInfoMc.addEventListener(MouseEvent.CLICK, this.onOpenUserInfo, false, 0, true);
            this.addChild(this.userInfoMc);
            this.setChildIndex(this.userInfoMc, (this.numChildren - 1));
            return;
        }// end function

        private function onOpenUserInfo(event:MouseEvent) : void
        {
            dispatchEvent(new CustomEvent(CustomEvent.OPEN_POPUP_USERINFO, {}, true));
            return;
        }// end function

        private function onHotLine(event:MouseEvent) : void
        {
            dispatchEvent(new CustomEvent(CustomEvent.HOTLINE, {}, true));
            return;
        }// end function

        private function onNapGold(event:MouseEvent) : void
        {
            dispatchEvent(new CustomEvent(CustomEvent.OPEN_POPUP_NAP_GOLD, {}, true));
            return;
        }// end function

        private function onCreateBoard(event:MouseEvent) : void
        {
            dispatchEvent(new HeaderEvent(HeaderEvent.TAO_BAN_RIENG, {}, true));
            return;
        }// end function

        private function onInviteFriend(event:MouseEvent) : void
        {
            dispatchEvent(new HeaderEvent(HeaderEvent.FRIENDS, {}, true));
            return;
        }// end function

        private function onQuickPlay(event:MouseEvent) : void
        {
            dispatchEvent(new HeaderEvent(HeaderEvent.CHOI_NGAY, {}, true));
            return;
        }// end function

        private function onChangeServer(event:MouseEvent) : void
        {
            dispatchEvent(new HeaderEvent(HeaderEvent.SELECT_SERVER, {}, true));
            return;
        }// end function

        public function set currency(param1:String) : void
        {
            this._currency = param1;
            this.Coin = this.coin;
            return;
        }// end function

        public function set Coin(param1:Number) : void
        {
            this.coin = param1;
            this.userInfoMc.txtCoin.htmlText = this._currency + " " + Format.MobileCoinFormat(this.coin);
            return;
        }// end function

        public function set NickName(param1:String) : void
        {
            this.nickName = param1;
            if (this.nickName.length > 8)
            {
                this.userInfoMc.txtNickName.text = this.nickName.substr(0, 8) + "...";
            }
            else
            {
                this.userInfoMc.txtNickName.text = this.nickName;
            }
            return;
        }// end function

        public function set Avatar(param1:String) : void
        {
            if (param1 != this.avatar)
            {
                this.avatar = param1;
                this.ShowAvatar(this.avatar);
            }
            return;
        }// end function

        private function ShowAvatar(param1:String) : void
        {
            this.ClearOldAvatar();
            if (this.preLoader.loginInfo.hashKeyMainAvatar.length != 0)
            {
                ImageLoader.getInstance().loadImageByHashKey(this.preLoader.loginInfo.hashKeyMainAvatar, {container:this.userInfoMc.avatarLoader, autoPlay:true, x:5, y:5, width:95, height:95});
            }
            else if (this.preLoader.loginInfo.hashKeySubAvatar.length != 0)
            {
                ImageLoader.getInstance().loadImageByHashKey(this.preLoader.loginInfo.hashKeySubAvatar, {container:this.userInfoMc.avatarLoader, autoPlay:true, x:5, y:5, width:95, height:95});
            }
            return;
        }// end function

        private function ClearOldAvatar() : void
        {
            var _loc_1:DisplayObject = null;
            while (this.userInfoMc.avatarLoader.numChildren > 0)
            {
                
                _loc_1 = this.userInfoMc.avatarLoader.getChildAt(0);
                this.userInfoMc.avatarLoader.removeChild(_loc_1);
                _loc_1 = null;
            }
            this.userInfoMc.avatarLoader.unload();
            return;
        }// end function

        public function ShowNapGoldButton(param1:Boolean) : void
        {
            this.panel.napGoldBtn.visible = param1;
            return;
        }// end function

        public function ShowBtnTaoBan(param1:Boolean) : void
        {
            this.panel.btnCreateBoard.visible = param1;
            return;
        }// end function

        public static function getExtension(param1:String) : String
        {
            return "";
        }// end function

    }
}
