package net.mgame.defaultcomponents
{
    import MGameEvents.*;
    import flash.display.*;
    import flash.events.*;

    public class CompoInputPassword extends Sprite
    {
        private var panel:CompoInputPassMC;
        private var roomID:int = 0;
        private var roomName:String = "";
        private var position:int;
        private var boardName:String = "";

        public function CompoInputPassword()
        {
            addEventListener(Event.ADDED_TO_STAGE, this.init);
            return;
        }// end function

        private function init(event:Event = null) : void
        {
            removeEventListener(Event.ADDED_TO_STAGE, this.init);
            this.panel = new CompoInputPassMC();
            addChild(this.panel);
            this.x = stage.stageWidth - this.width >> 1;
            this.y = 0;
            this.panel.txtPass.displayAsPassword = true;
            this.panel.btnClose.addEventListener(MouseEvent.CLICK, this.onClose, false, 0, true);
            this.panel.btnOk.addEventListener(MouseEvent.CLICK, this.onJoinRoom, false, 0, true);
            this.showInfo();
            return;
        }// end function

        private function showInfo() : void
        {
            if (this.panel)
            {
                if (this.roomName.length > 6)
                {
                    this.roomName = this.roomName.substring(0, 6) + "...";
                }
                this.panel.lbRoomName.text = this.roomName;
                this.panel.lbRoomID.text = this.boardName;
                this.panel.txtPass.text = "";
            }
            return;
        }// end function

        public function show(param1:int, param2:int, param3:String = "", param4:String = "") : void
        {
            this.visible = true;
            this.panel.lbWrong.visible = false;
            this.roomID = param1;
            this.position = param2;
            this.roomName = param3;
            this.boardName = param4;
            this.showInfo();
            return;
        }// end function

        public function showWrongPassword() : void
        {
            this.visible = true;
            this.panel.txtPass.text = "";
            this.panel.lbWrong.visible = true;
            return;
        }// end function

        private function onClose(event:MouseEvent) : void
        {
            this.hide();
            return;
        }// end function

        private function onJoinRoom(event:MouseEvent) : void
        {
            var _loc_3:Object = null;
            var _loc_2:* = this.panel.txtPass.text;
            if (_loc_2.length > 0)
            {
                _loc_3 = {roomId:this.roomID, position:this.position, password:_loc_2};
                dispatchEvent(new EnterPasswordEvent(EnterPasswordEvent.ENTER_PASSWORD, _loc_3, true));
                this.hide();
            }
            return;
        }// end function

        public function hide() : void
        {
            this.visible = false;
            return;
        }// end function

    }
}
