package net.mgame.defaultcomponents
{
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    import flash.utils.*;
    import net.mgame.*;

    public class CompoReceiveInviteJoinBoard extends Sprite
    {
        public var MainMovie:InviteMovie = null;
        private var _agreeHandler:Function = null;
        private var _disagreeHandler:Function = null;
        private var _confirmHandler:Function = null;
        private var _timeOut:int = 5000;
        private var timer1:Timer = null;
        private var timer2:Timer = null;
        public var AvatarPath:String = "";
        private var preLoader:Object;
        private var widthAfterScaleX:Number = 1;
        private var heightAfterScaleY:Number = 1;
        private var bg:Bitmap;
        private var btnClose:ButtonClose_Orgrange;
        private var title_txt:TextField;
        public var isIOS:Boolean = false;
        public var playSoundClick:Function;

        public function CompoReceiveInviteJoinBoard() : void
        {
            addEventListener(Event.ADDED_TO_STAGE, this.init);
            return;
        }// end function

        private function init(event:Event = null) : void
        {
            removeEventListener(Event.ADDED_TO_STAGE, this.init);
            this.preLoader = this.parent.parent;
            this.widthAfterScaleX = stage.fullScreenWidth + (1 - this.preLoader.appScaleSize) * this.preLoader.appRealWidth;
            this.heightAfterScaleY = stage.fullScreenHeight / this.scaleY;
            this.bg = new Bitmap(this.preLoader.backgroundInCompoBMD);
            this.bg.width = this.widthAfterScaleX;
            this.bg.height = this.heightAfterScaleY;
            this.addChildAt(this.bg, 0);
            this.btnClose = new ButtonClose_Orgrange();
            this.btnClose.visible = true;
            this.btnClose.buttonMode = true;
            this.btnClose.mouseChildren = false;
            this.btnClose.x = 1170;
            this.btnClose.y = 20;
            this.btnClose.addEventListener(MouseEvent.CLICK, this.onClose);
            this.addChild(this.btnClose);
            this.drawTitlePopUp();
            this.MainMovie = new InviteMovie();
            this.MainMovie.y = 120;
            this.MainMovie.x = 1280 - this.MainMovie.width >> 1;
            addChild(this.MainMovie);
            this.visible = false;
            this.MainMovie.loiMoiTxt.text = "M?i b?n tham gia bn choi";
            this.timer1 = new Timer(this.timeOut);
            this.timer2 = new Timer(15);
            this.MainMovie.loiMoiTxt.mouseEnabled = false;
            this.MainMovie.NicKNameTxt.mouseEnabled = false;
            this.MainMovie.txt_Notify.mouseEnabled = false;
            this.MainMovie.txt_Notify.autoSize = "left";
            return;
        }// end function

        private function drawTitlePopUp() : void
        {
            var _loc_1:* = new TextFormat("Arial", 55, 16777215, true);
            _loc_1.align = TextFormatAlign.CENTER;
            this.title_txt = new TextField();
            this.title_txt.name = "title";
            this.title_txt.selectable = false;
            this.title_txt.defaultTextFormat = _loc_1;
            this.title_txt.width = 630;
            this.title_txt.height = 55;
            this.title_txt.text = "M?I CHOI";
            this.title_txt.mouseEnabled = false;
            this.title_txt.mouseWheelEnabled = false;
            this.title_txt.y = 120 - this.title_txt.height >> 1;
            this.title_txt.x = 1280 - this.title_txt.width >> 1;
            this.title_txt.visible = true;
            this.addChild(this.title_txt);
            return;
        }// end function

        public function set setHiText(param1:String) : void
        {
            this.MainMovie.loiMoiTxt.text = param1;
            return;
        }// end function

        private function onClose(event:MouseEvent) : void
        {
            this.playSoundClick();
            this.Hide();
            this.timer1.stop();
            this.timer2.stop();
            if (this._disagreeHandler != null)
            {
                this._disagreeHandler();
            }
            return;
        }// end function

        public function Hide() : void
        {
            this.visible = false;
            this.MainMovie.btnAgree.removeEventListener(MouseEvent.CLICK, this.onAgree);
            this.MainMovie.btnTuChoi.removeEventListener(MouseEvent.CLICK, this.onClose);
            this.timer1.removeEventListener(TimerEvent.TIMER, this.onTimer1);
            this.timer2.removeEventListener(TimerEvent.TIMER, this.onTimer2);
            return;
        }// end function

        public function Show(param1:String, param2:Function, param3:Function = null) : void
        {
            var _loc_4:* = param1.split("|");
            this.MainMovie.NicKNameTxt.text = _loc_4[0];
            var _loc_5:* = _loc_4[4];
            var _loc_6:* = _loc_4[5];
            if (_loc_6 == "true")
            {
                _loc_5 = _loc_5 + "<br>Bn Solo";
            }
            var _loc_7:* = _loc_4[6];
            if (_loc_7 == "true")
            {
                _loc_5 = _loc_5 + "<br>Bn G";
            }
            this.RefreshWindow(_loc_5);
            this.timer1.reset();
            this.timer1.start();
            this.MainMovie.btnTuChoi.addEventListener(MouseEvent.CLICK, this.onClose, false, 0, false);
            this.MainMovie.btnAgree.addEventListener(MouseEvent.CLICK, this.onAgree);
            this.timer1.addEventListener(TimerEvent.TIMER, this.onTimer1, false, 0, true);
            this.timer2.addEventListener(TimerEvent.TIMER, this.onTimer2, false, 0, true);
            this._agreeHandler = param2;
            this._disagreeHandler = param3;
            param2 = null;
            param3 = null;
            this.visible = true;
            return;
        }// end function

        private function onAgree(event:MouseEvent) : void
        {
            this.playSoundClick();
            if (this._agreeHandler != null)
            {
                this.MainMovie.btnAgree.removeEventListener(MouseEvent.CLICK, this.onAgree);
                this._agreeHandler();
            }
            this.Hide();
            return;
        }// end function

        private function RefreshWindow(param1:String) : void
        {
            this.timer1.stop();
            this.timer2.stop();
            this.MainMovie.txt_Notify.htmlText = param1;
            this.alpha = 1;
            this.visible = true;
            return;
        }// end function

        private function onTimer1(event:TimerEvent) : void
        {
            this.timer1.stop();
            this.timer2.reset();
            this.timer2.start();
            return;
        }// end function

        private function onTimer2(event:TimerEvent) : void
        {
            if (this.alpha <= 0)
            {
                this.timer2.stop();
                this.Hide();
            }
            else
            {
                this.alpha = this.alpha - 0.07;
            }
            return;
        }// end function

        public function get timeOut() : int
        {
            return this._timeOut;
        }// end function

        public function set timeOut(param1:int) : void
        {
            this._timeOut = param1;
            this.timer1.delay = this._timeOut;
            return;
        }// end function

    }
}
