package net.mgame.defaultcomponents
{
    import MGameUtilities.*;
    import com.greensock.loading.*;
    import flash.display.*;
    import flash.events.*;

    public class MarketMC extends Sprite
    {
        private var coorY:Array;
        private var tabIdList:Array;
        private var currentTabIndex:int = 0;
        public var MenuHandler:Function;
        public var MarketItemHandle:Function;
        public var tabLeft:TabMarket;
        private var container:Sprite;
        public var AssetsIconPath:String = "";

        public function MarketMC()
        {
            this.coorY = [39, 135, 232, 328, 423];
            this.tabIdList = [5, 1, 2, 3, 4];
            this.tabLeft = new TabMarket();
            this.container = new Sprite();
            this.container.x = this.tabLeft.width;
            this.addChild(this.tabLeft);
            this.addChild(this.container);
            this.tabLeft.btnGame.buttonMode = true;
            this.tabLeft.btnFood.buttonMode = true;
            this.tabLeft.btnWaiter.buttonMode = true;
            this.tabLeft.btnCigaret.buttonMode = true;
            this.tabLeft.btnWaiter.buttonMode = true;
            this.tabLeft.btnGame.addEventListener(MouseEvent.CLICK, this.onTabItemClick, false, 0, true);
            this.tabLeft.btnFood.addEventListener(MouseEvent.CLICK, this.onTabItemClick, false, 0, true);
            this.tabLeft.btnWater.addEventListener(MouseEvent.CLICK, this.onTabItemClick, false, 0, true);
            this.tabLeft.btnCigaret.addEventListener(MouseEvent.CLICK, this.onTabItemClick, false, 0, true);
            this.tabLeft.btnWaiter.addEventListener(MouseEvent.CLICK, this.onTabItemClick, false, 0, true);
            return;
        }// end function

        private function onTabItemClick(event:MouseEvent) : void
        {
            var _loc_2:* = event.target.name;
            switch(_loc_2)
            {
                case "btnGame":
                {
                    this.gotoTab(0);
                    break;
                }
                case "btnFood":
                {
                    this.gotoTab(1);
                    break;
                }
                case "btnWater":
                {
                    this.gotoTab(2);
                    break;
                }
                case "btnCigaret":
                {
                    this.gotoTab(3);
                    break;
                }
                case "btnWaiter":
                {
                    this.gotoTab(4);
                    break;
                }
                default:
                {
                    break;
                }
            }
            return;
        }// end function

        private function gotoTab(param1:int) : void
        {
            if (param1 != this.currentTabIndex)
            {
                this.currentTabIndex = param1;
                this.tabLeft.arrow.y = this.coorY[param1];
                this.MenuHandler.apply(null, [this.tabIdList[param1]]);
            }
            return;
        }// end function

        private function clearUI() : void
        {
            if (this.container != null)
            {
                while (this.container.numChildren != 0)
                {
                    
                    this.container.removeChildAt(0);
                }
            }
            return;
        }// end function

        public function applyDataSource(param1:String) : void
        {
            var _loc_6:MarketItem = null;
            var _loc_11:Array = null;
            var _loc_12:ImageLoader = null;
            if (param1.length == 0)
            {
                return;
            }
            this.clearUI();
            var _loc_2:* = param1.split(";");
            var _loc_3:Number = -1;
            var _loc_4:Number = -1;
            var _loc_5:* = _loc_2.length;
            var _loc_7:int = 15;
            var _loc_8:int = 0;
            var _loc_9:int = 0;
            var _loc_10:int = 0;
            var _loc_13:int = 0;
            while (_loc_13 < _loc_5)
            {
                
                _loc_11 = _loc_2[_loc_13].split("|");
                _loc_6 = new MarketItem();
                _loc_6.buttonMode = true;
                _loc_6.mouseChildren = false;
                _loc_6.ItemID = int(_loc_11[0]);
                _loc_6.ItemName = _loc_11[1] == null ? ("") : (_loc_11[1]);
                _loc_6.ImagePath = this.AssetsIconPath + _loc_11[2];
                _loc_6.Price = Number(_loc_11[3]);
                _loc_6.txtName.text = "G " + Format.Coin(_loc_6.Price);
                _loc_6.Phase = int(_loc_11[4]);
                _loc_6.TimeEachPhase = _loc_11[5];
                _loc_6.IsSubMovie = _loc_11[6] == "True" ? (1) : (0);
                _loc_6.Direction = int(_loc_11[7]);
                if (_loc_11.length > 8)
                {
                    _loc_10 = int(_loc_11[8]);
                }
                if (_loc_10 > 0)
                {
                    _loc_6.txtExpiredDate.text = "S? d?ng " + _loc_10 + " gi?";
                }
                else
                {
                    _loc_6.txtExpiredDate.text = "";
                }
                _loc_12 = new ImageLoader(_loc_6.ImagePath, {container:_loc_6, width:70, height:70, x:5, y:5, scaleMode:"proportionalInside"});
                _loc_12.load();
                _loc_6.addEventListener(MouseEvent.CLICK, this.onItemClick);
                _loc_6.x = _loc_7;
                _loc_6.y = _loc_8;
                _loc_9++;
                if (_loc_9 == 5)
                {
                    _loc_8 = _loc_8 + 135;
                    _loc_7 = 15;
                    _loc_9 = 0;
                }
                else
                {
                    _loc_7 = _loc_7 + 122;
                }
                this.container.addChild(_loc_6);
                _loc_13++;
            }
            return;
        }// end function

        private function onItemClick(event:MouseEvent) : void
        {
            this.MarketItemHandle.apply(null, [event.currentTarget]);
            return;
        }// end function

    }
}
