package net.mgame.models
{
    import net.king.data.*;
    import net.king.entities.*;
    import net.mgame.keys.*;

    public class RoomInfo extends Object
    {
        private var room:Room;
        private var _maxBet:Number = 1000;

        public function RoomInfo(param1:Room) : void
        {
            this.room = param1;
            return;
        }// end function

        public function get roomId() : Number
        {
            return this.room.getVariable(VariableKeys.ROOM_ID);
        }// end function

        public function get numView() : int
        {
            return this.room.getVariable(VariableKeys.NUM_VIEW);
        }// end function

        public function get timeOut() : Number
        {
            return this.room.getVariable(VariableKeys.TIME_OUT);
        }// end function

        public function get betCoin() : Number
        {
            return this.room.getVariable(VariableKeys.BET_COIN);
        }// end function

        public function get rules() : String
        {
            return this.room.getVariable(VariableKeys.RULES) != null ? (this.room.getVariable(VariableKeys.RULES)) : ("");
        }// end function

        public function get roomName() : String
        {
            return this.room.getVariable(VariableKeys.ROOM_NAME);
        }// end function

        public function get roomType() : int
        {
            return this.room.getVariable(VariableKeys.ROOM_TYPE);
        }// end function

        public function get arrNick() : Array
        {
            return getArrNick(this.room.getVariable(VariableKeys.ARR_NICK));
        }// end function

        public function get boardType() : int
        {
            return this.room.getVariable(VariableKeys.BOARD_TYPE);
        }// end function

        public function get boardState() : int
        {
            return this.room.getVariable(VariableKeys.BOARD_STATE);
        }// end function

        public function get boardStatus() : String
        {
            return this.room.getVariable(VariableKeys.BOARD_STATUS);
        }// end function

        public function get ownerCoin() : Number
        {
            return this.room.getVariable(VariableKeys.OWNER_COIN);
        }// end function

        public function get maxBet() : Number
        {
            return this._maxBet;
        }// end function

        public function get matchId() : Number
        {
            var _loc_1:* = Number(this.room.getVariable(VariableKeys.MATCH_ID));
            return isNaN(_loc_1) ? (0) : (_loc_1);
        }// end function

        public function get isDefault() : Boolean
        {
            return this.room.getName().toLowerCase().indexOf(GlobalConstants.ROOM_DEFAULT) > -1;
        }// end function

        public function get serverTime() : String
        {
            var _loc_1:* = this.room.getVariable(VariableKeys.SERVER_TIME);
            if (_loc_1 == null)
            {
                return "";
            }
            return _loc_1;
        }// end function

        public function get oKhoa() : int
        {
            if (this.room.getVariable(VariableKeys.IS_LOCKED) == null)
            {
                return -2;
            }
            return int(this.room.getVariable(VariableKeys.IS_LOCKED));
        }// end function

        public function get hasPassword() : int
        {
            return int(this.room.getVariable(VariableKeys.HAS_PASSWORD));
        }// end function

        public function getTaiXiuMaxBet() : Number
        {
            return Number(this.room.getVariable(VariableKeys.MAX_BET));
        }// end function

        public function getCustomMaxPlayer() : int
        {
            return int(this.room.getVariable(VariableKeys.CUSTOM_MAX_PLAYER));
        }// end function

        public function getTotalPlayer() : int
        {
            return int(this.room.getVariable(VariableKeys.TOTAL_PLAYER));
        }// end function

        public function isB() : Boolean
        {
            return this.roomType == 1;
        }// end function

        public function get ownerId() : int
        {
            return int(this.room.getVariable(VariableKeys.OWNER_ID));
        }// end function

        public function get boardTypeID() : String
        {
            var _loc_1:String = "1$1";
            try
            {
                _loc_1 = this.room.getVariable(VariableKeys.BOARD_TYPE_ID);
            }
            catch (Ex:Error)
            {
            }
            return _loc_1;
        }// end function

        public function get isSolo() : Boolean
        {
            return Boolean(this.room.getVariable(VariableKeys.IS_SOLO));
        }// end function

        public function get isGopGa() : Boolean
        {
            return Boolean(this.room.getVariable(VariableKeys.IS_GOPGA));
        }// end function

        public function get isSetupFirstTime() : Boolean
        {
            return Boolean(this.room.getVariable(VariableKeys.IS_SETUP_FIRSTTIME));
        }// end function

        public static function fromRoom(param1:Room) : RoomInfo
        {
            var _loc_2:* = new RoomInfo(param1);
            return _loc_2;
        }// end function

        public static function getArrNick(param1) : Array
        {
            var _loc_2:Object = null;
            var _loc_3:Array = null;
            var _loc_4:int = 0;
            var _loc_5:int = 0;
            if (param1 == null)
            {
                return [];
            }
            if (param1.length > 0)
            {
                _loc_2 = KingJson.parse(param1);
                _loc_3 = new Array();
                _loc_4 = _loc_2.length;
                _loc_5 = 0;
                while (_loc_5 < _loc_4)
                {
                    
                    _loc_3.push(UserInBoard.fromJSON(_loc_2[_loc_5]));
                    _loc_5++;
                }
                return _loc_3;
            }
            else
            {
                return null;
            }
        }// end function

    }
}
