package net.mgame.models
{
    import net.king.data.*;
    import net.king.entities.*;
    import net.mgame.*;
    import net.mgame.keys.*;
    import net.mgame.utils.*;

    public class UserInfo extends Object
    {
        private var user:User;

        public function UserInfo(param1:User) : void
        {
            this.user = param1;
            return;
        }// end function

        public function isSet() : Boolean
        {
            return this.user != null;
        }// end function

        public function getItemBar() : String
        {
            var _loc_2:String = null;
            var _loc_1:* = KingJson.parse(this.itemBarInfo);
            if (_loc_1.length > 0)
            {
                _loc_2 = _loc_1[(_loc_1.length - 1)];
                while (_loc_2.indexOf(",") > -1)
                {
                    
                    _loc_2 = _loc_2.replace(",", "|");
                }
                return _loc_2;
            }
            return "";
        }// end function

        public function getString() : String
        {
            return StringUtils.formatString("{0},{1},{2},{3},{4},{5},{6},{7},{8},{9},{10},{11},{12},{13},{14},{15},{16},{17},{18},{19};", this.user.getId(), this.nickName, this.emotionPath, this.coin, this.levelUser, this.gender, this.userKind, "01/01/0001", this.pubId, 1, this.associationID, this.assName, this.isAssOwner, this.levelName, this.levelAss, this.tranferNo, this.categoryUser, 0, this.freeBet, this.expScore);
        }// end function

        public function isAdmin() : Boolean
        {
            return this.userKind == GlobalConstants.ADMIN_USERTYPE || this.userKind == GlobalConstants.MOD_USERTYPE;
        }// end function

        public function get userKind() : int
        {
            return this.user.getVariable(VariableKeys.USER_TYPE);
        }// end function

        public function get timePlay() : int
        {
            return this.user.getVariable(VariableKeys.TIME_PLAY);
        }// end function

        public function get nickName() : String
        {
            return this.user.getVariable(VariableKeys.NICK_NAME);
        }// end function

        public function get emotionPath() : String
        {
            var _loc_1:* = this.user.getVariable(VariableKeys.EMOTION_PATH);
            return _loc_1 == null ? ("") : (_loc_1);
        }// end function

        public function get betCondition() : int
        {
            return this.user.getVariable(VariableKeys.BET_CONDITION);
        }// end function

        public function get userId() : Number
        {
            return this.user.getId();
        }// end function

        public function get categoryUser() : String
        {
            return Global.getIconIdBy(int(this.user.getVariable(VariableKeys.CATEGORY_USER))).toString();
        }// end function

        public function get awardedThresholdTime() : String
        {
            return this.user.getVariable(VariableKeys.AWARDED_THRESHOLD_TIME);
        }// end function

        public function get pubId() : Number
        {
            return this.user.getVariable(VariableKeys.PUB_ID);
        }// end function

        public function get fullName() : String
        {
            return this.user.getVariable(VariableKeys.FULL_NAME);
        }// end function

        public function get gender() : int
        {
            return this.user.getVariable(VariableKeys.GENDER);
        }// end function

        public function get genderString() : String
        {
            return this.gender == 1 ? ("Nam") : ("N?");
        }// end function

        public function get levelUser() : int
        {
            return this.user.getVariable(VariableKeys.LEVEL);
        }// end function

        public function get expScore() : Number
        {
            return this.user.getVariable(VariableKeys.EXP_SCORE);
        }// end function

        public function get coin() : Number
        {
            return this.user.getVariable(VariableKeys.COIN);
        }// end function

        public function get realCoin() : Number
        {
            if (this.user.getVariable(VariableKeys.REAL_COIN))
            {
                return Number(this.user.getVariable(VariableKeys.REAL_COIN));
            }
            return -1;
        }// end function

        public function get awardedCoinTime() : String
        {
            return this.user.getVariable(VariableKeys.AWARDED_COIN_TIME);
        }// end function

        public function get freeBet() : int
        {
            return this.user.getVariable(VariableKeys.FREE_BET);
        }// end function

        public function get ownerNickName() : String
        {
            return this.user.getVariable(VariableKeys.OWNER_NICK_NAME);
        }// end function

        public function get assName() : String
        {
            return this.user.getVariable(VariableKeys.ASSOCIATION_NAME);
        }// end function

        public function get isAssOwner() : int
        {
            return this.user.getVariable(VariableKeys.IS_ASS_OWNER) == true ? (1) : (0);
        }// end function

        public function get isSubOwner() : Boolean
        {
            return this.user.getVariable(VariableKeys.IS_SUB_ASS_OWNER);
        }// end function

        public function get levelAss() : int
        {
            return this.user.getVariable(VariableKeys.ASSOCIATION_LEVEL);
        }// end function

        public function get associationID() : int
        {
            return this.user.getVariable(VariableKeys.ASSOCIATION_ID);
        }// end function

        public function get levelName() : String
        {
            return this.user.getVariable(VariableKeys.ASSOCIATION_LEVEL_NAME);
        }// end function

        public function get tranferNo() : String
        {
            return this.user.getVariable(VariableKeys.TRANSFER_NO);
        }// end function

        public function get isPlayer() : Boolean
        {
            return this.position > 0 && this.user.isPlayer();
        }// end function

        public function get isPlaying() : Boolean
        {
            var _loc_1:* = this.user.getJoinedRoom();
            if (_loc_1.IsGame())
            {
                return this.position > 0 && this.user.isPlayer && GameLoader.getInstance().gameScreen.isPlaying(this.user.getId());
            }
            return false;
        }// end function

        public function get isRoomOwner() : Boolean
        {
            var _loc_1:* = this.user.getJoinedRoom();
            if (_loc_1 == null)
            {
                return false;
            }
            return _loc_1.getOwnerId() == this.user.getId();
        }// end function

        public function get position() : int
        {
            var _loc_1:* = this.user.getPlayerId();
            if (_loc_1 <= 0)
            {
                return -1;
            }
            return _loc_1;
        }// end function

        public function get joinedRoom() : Room
        {
            return this.user.getJoinedRoom();
        }// end function

        public function get itemBarInfo() : String
        {
            return this.user.getVariable(VariableKeys.ITEM_BAR_INFO);
        }// end function

        public function get toolKind() : int
        {
            return this.user.getVariable(VariableKeys.USER_TOOL_KIND);
        }// end function

        public function get nextExpScore() : int
        {
            return this.user.getVariable(VariableKeys.NEXT_LEVEL_EXP_SCORE);
        }// end function

        public function get isActiveJackPot() : Boolean
        {
            var _loc_1:Boolean = false;
            if (this.user)
            {
                _loc_1 = this.user.getVariable(VariableKeys.IS_ACTIVE_JACKPOT);
            }
            return _loc_1;
        }// end function

        public function get getUserData() : User
        {
            return this.user;
        }// end function

        public static function fromUser(param1:User) : UserInfo
        {
            var _loc_2:* = new UserInfo(param1);
            return _loc_2;
        }// end function

    }
}
