package net.mgame.ui
{
    import IGame.*;
    import MGameEvents.*;
    import MGameUtilities.*;
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.system.*;
    import flash.text.*;
    import flash.utils.*;
    import net.king.entities.*;
    import net.mgame.*;
    import net.mgame.components.*;
    import net.mgame.keys.*;
    import net.mgame.ui.jackpot.*;
    import net.mgame.ui.star.*;

    public class GameScreen extends Sprite
    {
        public var game:IGame;
        private var gameLoader:GameLoader;
        private var back_btn:BackInGame_btn;
        private var chatText:TextInput;
        public var notice_MC:Sprite;
        private var noticeTimeoutID:int;
        private var _txtMatchInfo:TextField;
        private var _OKhoa_mc:OKhoa_mc;
        private var _star_mc:Star_mc;
        private var _jackPot:Jackpot;
        private var _compoHeaderBarInGame:CompoHeaderBarInGame;
        private var _compoBottomBarInGame:CompoBottomBarInGame;
        private static var isInstanced:Boolean = false;

        public function GameScreen(param1:GameLoader)
        {
            this.gameLoader = GameLoader.getInstance();
            if (isInstanced)
            {
                throw new Error("Cannot instance more than once");
            }
            isInstanced = true;
            this.addEventListener(Event.ADDED_TO_STAGE, this.onAddedToStage);
            return;
        }// end function

        private function onAddedToStage(event:Event) : void
        {
            removeEventListener(Event.ADDED_TO_STAGE, this.onAddedToStage);
            if (this.game)
            {
                if (this.contains(this.game as DisplayObject) == false)
                {
                    this.addChild(this.game as DisplayObject);
                }
            }
            this.initUI();
            return;
        }// end function

        private function initUI() : void
        {
            this.back_btn = new BackInGame_btn();
            this.back_btn.scaleX = this.gameLoader.appScaleSize;
            this.back_btn.scaleY = this.gameLoader.appScaleSize;
            this.back_btn.btn.addEventListener(MouseEvent.CLICK, this.onBack);
            this.addChild(this.back_btn);
            this.notice_MC = new Sprite();
            var _loc_1:* = new TextFormat("Arial", 30, 16776234, false);
            _loc_1.align = "center";
            var _loc_2:* = new TextField();
            _loc_2.multiline = true;
            _loc_2.wordWrap = true;
            _loc_2.width = 470;
            _loc_2.height = 75;
            _loc_2.x = 10;
            _loc_2.x = 5;
            var _loc_3:* = new thongbaokickBG();
            _loc_3.name = "background";
            this.notice_MC.addChild(_loc_3);
            _loc_2.defaultTextFormat = _loc_1;
            _loc_2.name = "textInfo";
            _loc_2.cacheAsBitmap = true;
            this.notice_MC.addChild(_loc_2);
            this.notice_MC.x = this.back_btn.width + this.gameLoader.getScaleHorizontal(10);
            this.notice_MC.y = this.gameLoader.getScaleVertical(10);
            this.notice_MC.scaleX = this.gameLoader.appScaleSize;
            this.notice_MC.scaleY = this.gameLoader.appScaleSize;
            this.addChild(this.notice_MC);
            this.notice_MC.visible = false;
            var _loc_4:* = new TextFormat();
            _loc_4.font = "Arial";
            _loc_4.size = 40;
            _loc_4.color = 16777215;
            this.chatText = new TextInput();
            this.chatText.setStyle("textFormat", _loc_4);
            this.chatText.setStyle("upSkin", new Sprite());
            this.chatText.width = this.gameLoader.stage.fullScreenWidth;
            this.chatText.height = 50;
            this.chatText.y = this.gameLoader.stage.fullScreenHeight - this.chatText.height;
            this.chatText.visible = false;
            this.compoBottomBarInGame.visible = false;
            this.gameLoader.globalComponents.compoMenuMyInfo.visible = false;
            if (isMobile)
            {
                this.chatText.addEventListener(SoftKeyboardEvent.SOFT_KEYBOARD_DEACTIVATE, this.onDeactiveSoftKeyBoard);
            }
            this.addEventListener("COLLAPSE_EXPAND", this.onCollapseOrExpand);
            this.addChild(this.chatText);
            return;
        }// end function

        private function onCollapseOrExpand(event:Event) : void
        {
            this.gameLoader.playSoundClick();
            return;
        }// end function

        private function onViewMatchResult(event:MouseEvent) : void
        {
            this.gameLoader.globalComponents.compoMatchResult.Show();
            return;
        }// end function

        public function set Notice(param1:String) : void
        {
            var _loc_2:TextField = null;
            if (this.notice_MC)
            {
                clearTimeout(this.noticeTimeoutID);
                this.notice_MC.visible = true;
                this.setChildIndex(this.notice_MC, (this.numChildren - 1));
                _loc_2 = this.notice_MC.getChildByName("textInfo") as TextField;
                _loc_2.y = 0;
                if (_loc_2)
                {
                    _loc_2.text = param1;
                    _loc_2.cacheAsBitmap = true;
                    this.noticeTimeoutID = setTimeout(this.hideNotice, 3000);
                    this.verticalAlignTextField(_loc_2);
                }
            }
            return;
        }// end function

        public function verticalAlignTextField(param1:TextField) : void
        {
            var _loc_2:* = param1.y;
            param1.y = param1.y + Math.round((param1.height - param1.textHeight) / 2);
            var _loc_3:* = this.notice_MC.getChildByName("background") as thongbaokickBG;
            if (param1.y < _loc_3.y)
            {
                param1.y = _loc_2;
            }
            return;
        }// end function

        private function hideNotice() : void
        {
            this.notice_MC.visible = false;
            return;
        }// end function

        public function InitBg() : void
        {
            var _loc_1:* = new Matrix();
            _loc_1.rotate(-2.38);
            this.graphics.clear();
            if (this.gameLoader.global.IdBg == 1)
            {
                this.graphics.beginBitmapFill(new patternBGBlue_bm(), _loc_1);
            }
            else
            {
                this.graphics.beginBitmapFill(new patternBGRed_bm(), _loc_1);
            }
            this.graphics.drawRect(0, 0, this.gameLoader.stage.stageWidth, this.gameLoader.stage.stageHeight);
            this.graphics.endFill();
            return;
        }// end function

        private function onDeactiveSoftKeyBoard(event:SoftKeyboardEvent) : void
        {
            if (this.gameLoader.global.MyInfo.isPlayer == false && this.gameLoader.isGame())
            {
                this.Notice = this.gameLoader.global.viewerCannotChatMessage;
                return;
            }
            if (this.gameLoader.isLobby() == false && this.gameLoader.global.isCanChat == false && this.gameLoader.global.isTourRoom)
            {
                return;
            }
            var _loc_2:* = this.chatText.text;
            if (_loc_2.length > 0)
            {
                _loc_2 = _loc_2.substr(0, int(GlobalConstants.MaxChatLen));
                if (this.gameLoader.global.hasInvalidText(_loc_2))
                {
                    return;
                }
                this.gameLoader.controller.sendTextChat(GlobalConstants.TAB_PHONG + "", "Ph", StringFormat.ConvertTags(_loc_2));
                this.chatText.text = "";
            }
            return;
        }// end function

        private function onChat(param1 = null) : void
        {
            if (this.gameLoader.global.isTourRoomAndShowMessage())
            {
                return;
            }
            this.gameLoader.onOpenChat();
            return;
        }// end function

        private function onBack(event:MouseEvent) : void
        {
            this.gameLoader.playSoundClick();
            this.gameLoader.dispatchEvent(new HeaderEvent(HeaderEvent.GO_BACK_TO_PHONGCHO, null));
            return;
        }// end function

        public function refreshUI() : void
        {
            this.removeToolTest(this.gameLoader.global.MyInfo.toolKind);
            this.compoHeaderBarInGame.SetBetCoin(Format.MobileCoinFormat(this.gameLoader.global.getRoomBetCoin()));
            this.compoHeaderBarInGame.ShowAll();
            if (this.gameLoader.global.isGameTaiXiu || this.gameLoader.global.isTourRoom)
            {
                this.compoHeaderBarInGame.visible = false;
            }
            else
            {
                this.compoHeaderBarInGame.visible = true;
            }
            this.compoBottomBarInGame.visible = true;
            clearTimeout(this.noticeTimeoutID);
            this.notice_MC.visible = false;
            this.setChildIndex(this.back_btn, (this.numChildren - 1));
            this.setChildIndex(this.compoHeaderBarInGame, this.numChildren - 2);
            this.starMC.show();
            return;
        }// end function

        private function removeToolTest(param1:Number) : void
        {
            var _loc_2:* = this.game.getChildObjectbyName("chiaBaiTest");
            if (_loc_2 != null)
            {
                _loc_2.visible = param1 > 0;
            }
            return;
        }// end function

        public function updateMatchId(param1:String, param2:Number, param3:Boolean) : void
        {
            var _loc_5:String = null;
            var _loc_4:String = "";
            if (param3)
            {
                param1 = param1.split("_")[1];
            }
            if (param2 == 0 || isNaN(param2))
            {
                _loc_5 = "";
            }
            else
            {
                _loc_5 = param2.toString();
            }
            if (this.gameLoader.global.isVongGiauMat())
            {
                _loc_4 = "";
                param1 = "";
            }
            if (this.gameLoader.global.isGameTaiXiu)
            {
                _loc_4 = "ID: " + _loc_5;
                this.txtMatchInfo.visible = true;
            }
            else
            {
                this.txtMatchInfo.visible = false;
            }
            this.txtMatchInfo.text = _loc_4;
            this.compoHeaderBarInGame.SetBoardID(param1);
            this.compoHeaderBarInGame.SetMatchID(_loc_5);
            this.compoHeaderBarInGame.SetBetCoin(Format.MobileCoinFormat(this.gameLoader.global.getRoomBetCoin()));
            return;
        }// end function

        public function enableCompoSettings(param1:Boolean) : void
        {
            if (this.gameLoader.global.isRoomDefault && this.gameLoader.global.MyInfo.isRoomOwner && this.gameLoader.global.MyInfo.isPlayer)
            {
                this.gameLoader.globalComponents.compoSetting.enableButtons(true);
                this.gameLoader.globalComponents.compoSetting.enableBetCoin(false);
            }
            else if (this.gameLoader.global.MyInfo.isRoomOwner)
            {
                this.gameLoader.globalComponents.compoSetting.enableButtons(true);
                this.gameLoader.globalComponents.compoSetting.enableBetCoin(true);
            }
            else
            {
                this.gameLoader.globalComponents.compoSetting.enableBetCoin(false);
                this.gameLoader.globalComponents.compoSetting.enableButtons(false);
            }
            return;
        }// end function

        public function get txtMatchInfo() : TextField
        {
            var _loc_1:TextFormat = null;
            var _loc_2:Sprite = null;
            if (this._txtMatchInfo == null)
            {
                this._txtMatchInfo = new TextField();
                this._txtMatchInfo.name = "txtMatchId";
                this._txtMatchInfo.width = 200;
                this._txtMatchInfo.height = 50;
                this._txtMatchInfo.selectable = false;
                _loc_1 = new TextFormat();
                _loc_1.color = 16777215;
                _loc_1.size = 24;
                this._txtMatchInfo.defaultTextFormat = _loc_1;
                _loc_2 = new Sprite();
                _loc_2.mouseChildren = false;
                _loc_2.mouseEnabled = false;
                this._txtMatchInfo.cacheAsBitmap = true;
                _loc_2.addChild(this._txtMatchInfo);
                _loc_2.scaleX = this.gameLoader.appScaleSize;
                _loc_2.scaleY = this.gameLoader.appScaleSize;
                _loc_2.x = this.gameLoader.getScaleHorizontal(815);
                _loc_2.y = this.gameLoader.getScaleVertical(25);
                _loc_2.cacheAsBitmap = true;
                this.addChild(_loc_2);
                this._txtMatchInfo.mouseEnabled = false;
            }
            return this._txtMatchInfo;
        }// end function

        public function get OKhoa() : OKhoa_mc
        {
            if (this._OKhoa_mc == null)
            {
                this._OKhoa_mc = new OKhoa_mc();
                this._OKhoa_mc.name = "OKhoa_mc";
                this._OKhoa_mc.visible = false;
                this.addChild(this._OKhoa_mc);
                this._OKhoa_mc.x = this.gameLoader.getScaleHorizontal(6);
                this._OKhoa_mc.y = this.gameLoader.getScaleVertical(85);
            }
            if (this.gameLoader.isGame())
            {
                this._OKhoa_mc.buttonMode = true;
                this._OKhoa_mc.addEventListener(MouseEvent.CLICK, this.onLockBoardClick, false, 0, true);
            }
            else
            {
                this._OKhoa_mc.buttonMode = false;
                if (this._OKhoa_mc.hasEventListener(MouseEvent.CLICK))
                {
                    this._OKhoa_mc.removeEventListener(MouseEvent.CLICK, this.onLockBoardClick);
                }
            }
            return this._OKhoa_mc;
        }// end function

        private function onLockBoardClick(event:MouseEvent) : void
        {
            this.gameLoader.playSoundClick();
            if (this.gameLoader.global.MyInfo.isRoomOwner && this.gameLoader.global.isRoomDefault == false)
            {
                this.gameLoader.global.isLocked = !this.gameLoader.global.isLocked;
                this.gameLoader.controller.sendLockBoard(this.gameLoader.global.isLocked);
            }
            event = null;
            return;
        }// end function

        public function get starMC() : Star_mc
        {
            if (this._star_mc == null)
            {
                this._star_mc = new Star_mc();
                this._star_mc.y = 0;
                this._star_mc.scaleX = this.gameLoader.appScaleSize;
                this._star_mc.scaleY = this.gameLoader.appScaleSize;
                this.addChild(this._star_mc);
            }
            if (this.gameLoader.global.isGameDanhChan)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(948.6);
            }
            else if (this.gameLoader.global.isGameBinh)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(697);
            }
            else if (this.gameLoader.global.isGameTLMN)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(705);
            }
            else if (this.gameLoader.global.isGameSam)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(697);
            }
            else if (this.gameLoader.global.isGameLieng)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(700);
            }
            else if (this.gameLoader.global.isGameU9La)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(1028);
            }
            else if (this.gameLoader.global.isGameXiTo)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(697);
            }
            else if (this.gameLoader.global.isGameTaiXiu)
            {
                this._star_mc.x = this.gameLoader.getScaleHorizontal(350);
            }
            if (this._compoHeaderBarInGame)
            {
                this.setChildIndex(this._star_mc, (this.getChildIndex(this._compoHeaderBarInGame) - 1));
            }
            return this._star_mc;
        }// end function

        public function playMove(param1:Object) : void
        {
            this.game.playMove(param1);
            return;
        }// end function

        public function onGameData(param1:Object) : void
        {
            this.game.playMove(param1);
            return;
        }// end function

        public function getChildObjectbyName(param1:String) : DisplayObject
        {
            return this.game.getChildObjectbyName(param1);
        }// end function

        public function setGame(param1:Object, param2:Object) : void
        {
            if (this.game)
            {
                if (this.contains(this.game as DisplayObject))
                {
                    this.removeChild(this.game as DisplayObject);
                }
            }
            this.game = param1 as IGame;
            if (this.contains(this.game as DisplayObject) == false)
            {
                this.addChild(this.game as DisplayObject);
            }
            this.game.setGameConfig(param2);
            return;
        }// end function

        public function setInterfaceBoard(param1:Boolean) : void
        {
            this.game.setInterfaceBoard(param1);
            return;
        }// end function

        public function setCardStyle(param1:Boolean) : void
        {
            this.game.setCardStyle(param1);
            return;
        }// end function

        public function getInterfaceBoard() : Boolean
        {
            return this.game.getInterfaceBoard();
        }// end function

        public function getCardStyle() : Boolean
        {
            return this.game.getCardStyle();
        }// end function

        public function updateInterfaceWhenEndMatchAndGetResultString(param1:Array, param2:String) : String
        {
            return this.game.updateInterfaceWhenEndMatchAndGetResultString(param1, param2);
        }// end function

        public function processGameDataForViewer(param1:Object) : void
        {
            this.game.processGameDataForViewer(param1);
            return;
        }// end function

        public function updateCompoUserInfoPlay(param1:Number) : void
        {
            this.game.updateCompoUserInfoPlay(param1);
            return;
        }// end function

        public function setLockBoard(param1:Boolean) : void
        {
            this.game.setLockBoard(param1);
            return;
        }// end function

        public function addUserSit(param1:Number) : void
        {
            this.game.addUserSit(param1);
            this.updateCurrencyAllCompoUserInfoPlay();
            return;
        }// end function

        public function updateBoardOwner(param1:Number, param2:Number) : void
        {
            this.game.updateBoardOwner(param1, param2);
            return;
        }// end function

        public function clearUI() : void
        {
            this.txtMatchInfo.text = "";
            this.gameLoader.global.resetBoardInfo();
            this.game.clearUI();
            this.gameLoader.globalComponents.compoMatchResult.isNotDisplayAgain = true;
            this.compoHeaderBarInGame.ClearAll();
            this.compoBottomBarInGame.reset();
            this.compoBottomBarInGame.visible = false;
            this.starMC.reset();
            return;
        }// end function

        public function updateDealerUser(param1:Number) : void
        {
            this.game.setDisplayDealerButton(param1);
            return;
        }// end function

        public function isPlaying(param1:Number) : Boolean
        {
            return this.game.isPlaying(param1);
        }// end function

        public function getTotalPlayer() : int
        {
            return this.game.getTotalPlayer();
        }// end function

        final public function updatePosition(param1:Room, param2:Boolean) : void
        {
            var _loc_3:* = param1.getPlayerList();
            this.game.updatePosition(_loc_3, param2);
            this.updateCurrencyAllCompoUserInfoPlay();
            _loc_3 = null;
            return;
        }// end function

        public function userLeaveGame(param1:Number, param2:int) : void
        {
            this.game.userLeaveGame(param1, param2);
            return;
        }// end function

        public function handleUnknownObject(param1:String, param2:Object) : void
        {
            this.game.handleUnknownObject(param1, param2);
            return;
        }// end function

        public function hideStartButton() : void
        {
            this.game.hideStartButton();
            return;
        }// end function

        public function getListCardTest() : Array
        {
            return [];
        }// end function

        private function updateCurrencyAllCompoUserInfoPlay() : void
        {
            var _loc_2:Object = null;
            var _loc_1:int = 1;
            while (_loc_1 <= this.gameLoader.global.maxPlayer)
            {
                
                _loc_2 = this.getChildObjectbyName("compoUserInfoPlay_" + _loc_1);
                if (_loc_2 != null)
                {
                    _loc_2.currency = this.gameLoader.global.currency;
                    _loc_2.MyInfoUserType = this.gameLoader.global.MyInfo.userKind;
                }
                _loc_1++;
            }
            return;
        }// end function

        public function get jackPot() : Jackpot
        {
            if (this._jackPot == null)
            {
                this._jackPot = new Jackpot();
                this._jackPot.x = this.gameLoader.getScaleHorizontal(145);
                this._jackPot.y = this.gameLoader.getScaleVertical(13);
                this._jackPot.scaleX = this.gameLoader.appScaleSize;
                this._jackPot.scaleY = this.gameLoader.appScaleSize;
                this.addChild(this._jackPot);
            }
            if (this.gameLoader.global.gameID == GlobalConstants.BinhGameId)
            {
                this.setChildIndex(this._jackPot, 0);
            }
            else
            {
                this.setChildIndex(this._jackPot, (this.numChildren - 1));
            }
            return this._jackPot;
        }// end function

        public function get compoHeaderBarInGame() : CompoHeaderBarInGame
        {
            if (this._compoHeaderBarInGame == null)
            {
                this._compoHeaderBarInGame = new CompoHeaderBarInGame();
                this._compoHeaderBarInGame.scaleX = this.gameLoader.appScaleSize;
                this._compoHeaderBarInGame.scaleY = this.gameLoader.appScaleSize;
                this._compoHeaderBarInGame.x = this.gameLoader.stage.stageWidth - this._compoHeaderBarInGame.width;
                this._compoHeaderBarInGame.playSoundCLick = this.gameLoader.playSoundClick;
                this._compoHeaderBarInGame.name = "compoHeaderBarInGame";
                this.addChild(this._compoHeaderBarInGame);
            }
            return this._compoHeaderBarInGame;
        }// end function

        public function get compoBottomBarInGame() : CompoBottomBarInGame
        {
            if (this._compoBottomBarInGame == null)
            {
                this._compoBottomBarInGame = new CompoBottomBarInGame(false);
                this._compoBottomBarInGame.scaleX = this.gameLoader.appScaleSize;
                this._compoBottomBarInGame.scaleY = this.gameLoader.appScaleSize;
                this._compoBottomBarInGame.name = "compoBottomBarInGame";
                this._compoBottomBarInGame.gameLoader = this.gameLoader;
                this.addChild(this._compoBottomBarInGame);
                this._compoBottomBarInGame.addEventListener("CHAT", this.onChat);
            }
            this._compoBottomBarInGame.y = this.gameLoader.stage.stageHeight - this._compoBottomBarInGame.height;
            this.setChildIndex(this._compoBottomBarInGame, (this.numChildren - 1));
            return this._compoBottomBarInGame;
        }// end function

        public static function get isMobile() : Boolean
        {
            return Capabilities.manufacturer.indexOf("iOS") > -1 || Capabilities.manufacturer.indexOf("Android") > -1;
        }// end function

    }
}
