package net.mgame.ui
{
    import flash.display.*;
    import jackpot.*;
    import net.mgame.components.*;
    import net.mgame.defaultcomponents.*;
    import net.mgame.keys.*;
    import net.mgame.mchat.*;

    public class GlobalComponents extends Object
    {
        private var gameLoader:GameLoader;
        private var reconnectEffect_mc:ReconnectEffect_mc;
        private var loginOtherSession:LoginOtherSessionMC;
        private var _maskForReconnect:Sprite;
        private var _compoNotify:CompoNotify;
        private var _compoBETDialog:CompoBetDialogM;
        private var _compoMatchResult:CompoMatchResult = null;
        private var _compoMenuMyInfo:CompoMenuMyInfo;
        public var _compoSetting:CompoSettingM;
        private var _standUpPopUp_mc:StandUpPopUpMC;
        private var _compoReceiveInviteJoinBoard:CompoReceiveInviteJoinBoard;
        private var _compoChat:CompoChat;
        private var _compoCountDown:CompoCountDown;
        private var _compoHistoryJackpot:CompoHistoryJackpot;
        private var _compoPUBInGame:CompoPUBInGame;
        private var _compoInputpass:CompoInputPassword;
        private static var isInstanced:Boolean = false;

        public function GlobalComponents(param1:GameLoader)
        {
            if (isInstanced)
            {
                throw new Error("Cannot instance more than once");
            }
            this.gameLoader = param1;
            return;
        }// end function

        private function get maskForReconnect() : Sprite
        {
            if (this._maskForReconnect == null)
            {
                this._maskForReconnect = this.gameLoader.global.createMask(this.gameLoader.appRealWidth, this.gameLoader.appRealHeight, 0, 0.5);
                this.reconnectEffect_mc = new ReconnectEffect_mc();
                this.reconnectEffect_mc.x = this.gameLoader.appRealWidth / 2 - this.reconnectEffect_mc.width / 2;
                this.reconnectEffect_mc.y = this.gameLoader.appRealHeight / 2 - this.reconnectEffect_mc.height / 2;
                this.loginOtherSession = new LoginOtherSessionMC();
                this.loginOtherSession.x = this.gameLoader.appRealWidth / 2 - this.loginOtherSession.width / 2;
                this.loginOtherSession.y = this.gameLoader.appRealHeight / 2 - this.loginOtherSession.height / 2;
                this._maskForReconnect.addChild(this.reconnectEffect_mc);
                this._maskForReconnect.addChild(this.loginOtherSession);
                this._maskForReconnect.scaleX = this.gameLoader.preloader.appScaleSize;
                this._maskForReconnect.scaleY = this.gameLoader.preloader.appScaleHeight;
                this.gameLoader.addChild(this._maskForReconnect);
            }
            return this._maskForReconnect;
        }// end function

        public function showEffectWaitingReconnect() : void
        {
            this.maskForReconnect.visible = true;
            this.reconnectEffect_mc.visible = true;
            this.loginOtherSession.visible = false;
            return;
        }// end function

        public function showEffectLoginOtherSession() : void
        {
            this.maskForReconnect.visible = true;
            this.reconnectEffect_mc.visible = false;
            this.loginOtherSession.visible = true;
            return;
        }// end function

        public function hideEffectWaitingReconnect() : void
        {
            this.maskForReconnect.visible = false;
            return;
        }// end function

        public function get compoNotify() : CompoNotify
        {
            if (this._compoNotify == null)
            {
                this._compoNotify = new CompoNotify();
                this._compoNotify.name = "CompoNotify";
                this._compoNotify.visible = false;
                this._compoNotify.scaleX = this.gameLoader.appScaleSize;
                this._compoNotify.scaleY = this.gameLoader.appScaleSize;
                this._compoNotify.playSoundClick = this.gameLoader.playSoundClick;
                this.gameLoader.addChild(this._compoNotify);
            }
            this.gameLoader.setChildIndex(this._compoNotify, (this.gameLoader.numChildren - 1));
            this.gameLoader.setToCenterPoint(this._compoNotify);
            return this._compoNotify;
        }// end function

        public function get compoBETDialog() : CompoBetDialogM
        {
            if (this._compoBETDialog == null)
            {
                this._compoBETDialog = new CompoBetDialogM();
                this._compoBETDialog.name = "CompoBETDialog";
                this._compoBETDialog.visible = false;
                this._compoBETDialog.scaleX = this.gameLoader.appScaleSize;
                this._compoBETDialog.scaleY = this.gameLoader.appScaleSize;
                this.gameLoader.addChild(this._compoBETDialog);
                this._compoBETDialog.height = this.gameLoader.stage.fullScreenHeight;
            }
            this.gameLoader.setChildIndex(this._compoBETDialog, (this.gameLoader.numChildren - 1));
            return this._compoBETDialog;
        }// end function

        public function get compoMatchResult() : CompoMatchResult
        {
            if (this._compoMatchResult == null)
            {
                this._compoMatchResult = new CompoMatchResult();
                this._compoMatchResult.name = "CompoMatchResult";
                this._compoMatchResult.visible = false;
                this._compoMatchResult.scaleX = this.gameLoader.appScaleSize;
                this._compoMatchResult.scaleY = this.gameLoader.appScaleSize;
                this._compoMatchResult.isNotDisplayAgain = true;
                this.gameLoader.addChild(this._compoMatchResult);
            }
            if (this.gameLoader.global.isGameXiTo)
            {
                this._compoMatchResult.setResultStyle(CompoMatchResult.RESULT_STYLE_1ROW);
            }
            else if (this.gameLoader.global.isGameLieng)
            {
                this._compoMatchResult.setResultStyle(CompoMatchResult.RESULT_STYLE_HaveListCard);
            }
            else
            {
                this._compoMatchResult.setResultStyle(CompoMatchResult.RESULT_STYLE_2ROW);
            }
            this._compoMatchResult.Currency = this.gameLoader.global.currency;
            this._compoMatchResult.x = this.gameLoader.stage.stageWidth - this._compoMatchResult.width >> 1;
            this.gameLoader.setChildIndex(this._compoMatchResult, (this.gameLoader.numChildren - 1));
            this.gameLoader.setToCenterPoint(this._compoMatchResult);
            return this._compoMatchResult;
        }// end function

        public function get compoMenuMyInfo() : CompoMenuMyInfo
        {
            if (this._compoMenuMyInfo == null)
            {
                this._compoMenuMyInfo = new CompoMenuMyInfo();
                this._compoMenuMyInfo.name = "CompoMenuMyInfo";
                this._compoMenuMyInfo.visible = false;
                this._compoMenuMyInfo.scaleX = this.gameLoader.appScaleSize;
                this._compoMenuMyInfo.scaleY = this.gameLoader.appScaleSize;
                this._compoMenuMyInfo.playSoundClick = this.gameLoader.playSoundClick;
                this.gameLoader.addChild(this._compoMenuMyInfo);
                this._compoMenuMyInfo.width = this.gameLoader.stage.stageWidth + this.gameLoader.getScaleHorizontal(8);
                this._compoMenuMyInfo.height = this.gameLoader.stage.stageHeight + this.gameLoader.getScaleVertical(4);
            }
            this._compoMenuMyInfo.Currency = this.gameLoader.global.currency;
            this.gameLoader.setChildIndex(this._compoMenuMyInfo, (this.gameLoader.numChildren - 1));
            return this._compoMenuMyInfo;
        }// end function

        public function get compoSetting() : CompoSettingM
        {
            if (this._compoSetting == null)
            {
                this._compoSetting = new CompoSettingM();
                this._compoSetting.name = "CompoSetting";
                this._compoSetting.visible = false;
                this._compoSetting.scaleX = this.gameLoader.appScaleSize;
                this._compoSetting.scaleY = this.gameLoader.appScaleSize;
                this.gameLoader.addChild(this._compoSetting);
                if (this.gameLoader.global.gameID == GlobalConstants.BinhGameId)
                {
                    this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextBinh;
                }
                else if (this.gameLoader.global.gameID == GlobalConstants.CoCaNguaId)
                {
                    this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextCoCaNgua;
                }
                else
                {
                    this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextDefault;
                }
            }
            this.gameLoader.setChildIndex(this._compoSetting, (this.gameLoader.numChildren - 1));
            return this._compoSetting;
        }// end function

        public function get standUpPopUp_mc() : StandUpPopUpMC
        {
            if (this._standUpPopUp_mc == null)
            {
                this._standUpPopUp_mc = new StandUpPopUpMC();
                this._standUpPopUp_mc.name = "standUpPopUp_mc";
                this._standUpPopUp_mc.visible = false;
                this._standUpPopUp_mc.resetStateBtn();
                this._standUpPopUp_mc.scaleX = this.gameLoader.appScaleSize;
                this._standUpPopUp_mc.scaleY = this.gameLoader.appScaleSize;
                this.gameLoader.setToCenterPoint(this._standUpPopUp_mc);
                this.gameLoader.addChild(this._standUpPopUp_mc);
            }
            this.gameLoader.setChildIndex(this._standUpPopUp_mc, (this.gameLoader.numChildren - 1));
            return this._standUpPopUp_mc;
        }// end function

        public function get compoReceiveInviteJoinBoard() : CompoReceiveInviteJoinBoard
        {
            if (this._compoReceiveInviteJoinBoard == null)
            {
                this._compoReceiveInviteJoinBoard = new CompoReceiveInviteJoinBoard();
                this._compoReceiveInviteJoinBoard.name = "compoReceiveInviteJoinBoard";
                this._compoReceiveInviteJoinBoard.AvatarPath = this.gameLoader.global.avatarPath;
                this._compoReceiveInviteJoinBoard.isIOS = this.gameLoader.isIOS;
                this._compoReceiveInviteJoinBoard.scaleX = this.gameLoader.appScaleSize;
                this._compoReceiveInviteJoinBoard.scaleY = this.gameLoader.appScaleSize;
                this._compoReceiveInviteJoinBoard.playSoundClick = this.gameLoader.playSoundClick;
                this.gameLoader.addChild(this._compoReceiveInviteJoinBoard);
            }
            return this._compoReceiveInviteJoinBoard;
        }// end function

        public function get compoChat() : CompoChat
        {
            var _loc_1:Number = NaN;
            if (this._compoChat == null)
            {
                this._compoChat = new CompoChat();
                this._compoChat.visible = false;
                this._compoChat.name = "compoChat";
                _loc_1 = this.gameLoader.stage.fullScreenHeight / 700;
                this._compoChat.scaleX = _loc_1;
                this._compoChat.scaleY = _loc_1;
                this._compoChat.x = this.gameLoader.stage.stageWidth - 586 * _loc_1;
                this._compoChat.playSoundClick = this.gameLoader.playSoundClick;
                this.gameLoader.addChild(this._compoChat);
            }
            this.gameLoader.setChildIndex(this._compoChat, (this.gameLoader.numChildren - 1));
            return this._compoChat;
        }// end function

        public function get compoCountDown() : CompoCountDown
        {
            if (this._compoCountDown == null)
            {
                this._compoCountDown = new CompoCountDown();
                this._compoCountDown.name = "CompoCountDown";
                this._compoCountDown.visible = false;
                this._compoCountDown.x = this.gameLoader.getScaleHorizontal(550);
                this._compoCountDown.y = this.gameLoader.getScaleVertical(60);
                this._compoCountDown.scaleX = 1.3 * this.gameLoader.appScaleSize;
                this._compoCountDown.scaleY = 1.3 * this.gameLoader.appScaleSize;
                this.gameLoader.addChild(this._compoCountDown);
            }
            this.gameLoader.setChildIndex(this._compoCountDown, (this.gameLoader.numChildren - 1));
            return this._compoCountDown;
        }// end function

        public function get compoHistoryJackpot() : CompoHistoryJackpot
        {
            if (this._compoHistoryJackpot == null)
            {
                this._compoHistoryJackpot = new CompoHistoryJackpot();
                this._compoHistoryJackpot.name = "CompoHistoryJackpot";
                this._compoHistoryJackpot.preLoader = this.gameLoader.preloader;
                this._compoHistoryJackpot.isIOS = this.gameLoader.isIOS;
                this._compoHistoryJackpot.scaleX = this.gameLoader.appScaleSize;
                this._compoHistoryJackpot.scaleY = this.gameLoader.appScaleSize;
                this._compoHistoryJackpot.functionActiveJackpot = this.gameLoader.controller.sendUpdateActiveJackpot;
                this._compoHistoryJackpot.playSoundClick = this.gameLoader.playSoundClick;
                this.gameLoader.addChild(this._compoHistoryJackpot);
            }
            this.gameLoader.setChildIndex(this._compoHistoryJackpot, (this.gameLoader.numChildren - 1));
            return this._compoHistoryJackpot;
        }// end function

        public function get compoPUBInGame() : CompoPUBInGame
        {
            if (this._compoPUBInGame == null)
            {
                this._compoPUBInGame = new CompoPUBInGame();
                this._compoPUBInGame.name = "CompoPUBInGame";
                this._compoPUBInGame.preLoader = this.gameLoader.preloader;
                this._compoPUBInGame.scaleX = this.gameLoader.appScaleSize;
                this._compoPUBInGame.scaleY = this.gameLoader.appScaleSize;
                this._compoPUBInGame.playSoundClick = this.gameLoader.playSoundClick;
                this._compoPUBInGame.callBackViewProfile = this.gameLoader.preloader.showPopupUserInfo;
                this.gameLoader.addChild(this._compoPUBInGame);
            }
            this.gameLoader.setChildIndex(this._compoPUBInGame, (this.gameLoader.numChildren - 1));
            return this._compoPUBInGame;
        }// end function

        public function get compoInputPassword() : CompoInputPassword
        {
            if (this._compoInputpass == null)
            {
                this._compoInputpass = new CompoInputPassword();
                this._compoInputpass.name = "CompoInputPassword";
                this.gameLoader.addChild(this._compoInputpass);
                this._compoInputpass.scaleX = this.gameLoader.appScaleSize;
                this._compoInputpass.scaleY = this.gameLoader.appScaleSize;
                this.gameLoader.setChildIndex(this._compoInputpass, (this.gameLoader.numChildren - 1));
            }
            this.gameLoader.setToCenterPoint(this._compoInputpass);
            return this._compoInputpass;
        }// end function

        public function refreshComponents() : void
        {
            if (this._compoBETDialog)
            {
                this._compoBETDialog.reset();
            }
            if (this._compoSetting == null)
            {
                return;
            }
            if (this.gameLoader.global.gameID == GlobalConstants.BinhGameId)
            {
                this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextBinh;
            }
            else if (this.gameLoader.global.gameID == GlobalConstants.CoCaNguaId)
            {
                this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextCoCaNgua;
            }
            else
            {
                this._compoSetting.TimeOut = this.gameLoader.global.timeOutTextDefault;
            }
            this.gameLoader.lobbyScreen.compoBottomControlBar.ShowBtnTaoBan(this.gameLoader.global.isGameTaiXiu == false);
            this.gameLoader.gameScreen.starMC.reset();
            return;
        }// end function

    }
}
