package net.mgame.ui
{
    import MGameEvents.*;
    import flash.display.*;
    import flash.events.*;
    import flash.text.*;
    import net.king.*;
    import net.king.entities.*;
    import net.mgame.*;
    import net.mgame.components.*;
    import net.mgame.defaultcomponents.*;
    import net.mgame.keys.*;
    import net.mgame.lobby.*;
    import net.mgame.models.*;
    import net.mgame.ui.listboard.*;
    import net.mgame.ui.lobby.headerInfo.*;
    import net.mgame.ui.lobby.listgame.*;
    import net.mgame.ui.thongtin.*;

    public class LobbyScreen extends Sprite
    {
        public var gameLoader:GameLoader;
        public var listGroupRoom:Array;
        public var compoBottomControlBar:CompoBottomControlBar;
        public var compoListGame:CompoListGame;
        public var back_btn:BackInLobby_btn;
        private var titleRoomType:TextField;
        public var header_mc:Sprite;
        public var headerLobbyInfo:HeaderLobbyInfo;
        public var listBoard:ListBoardNew;
        public var thongTinScreen:ThongTinScreen;
        private var _compoBottomBarInGame:CompoBottomBarInGame;
        private var headerTextFormat:TextFormat;
        private static var isInstanced:Boolean = false;

        public function LobbyScreen(param1:GameLoader)
        {
            this.listGroupRoom = [];
            if (isInstanced)
            {
                throw new Error("Cannot instance more than once");
            }
            isInstanced = true;
            this.gameLoader = param1;
            this.listBoard = new ListBoardNew();
            this.listBoard.x = param1.getScaleHorizontal(260);
            this.listBoard.y = param1.headerHeight;
            this.listBoard.scaleX = param1.appScaleSize;
            this.listBoard.scaleY = param1.appScaleSize;
            this.compoBottomControlBar = new CompoBottomControlBar();
            this.compoBottomControlBar.name = "CompoBottomControlBar";
            this.compoBottomControlBar.x = param1.getScaleHorizontal(0);
            this.compoBottomControlBar.scaleX = param1.appScaleSize;
            this.compoBottomControlBar.scaleY = param1.appScaleSize;
            this.compoBottomControlBar.y = param1.stage.stageHeight - this.compoBottomControlBar.height;
            this.compoBottomControlBar.preLoader = param1.preloader;
            this.addChild(this.compoBottomControlBar);
            this.compoBottomControlBar.ShowNapGoldButton(false);
            this.initBackgroundListBoard();
            this.addChild(this.compoBottomBarInGame);
            var _loc_2:* = (param1.stage.fullScreenHeight - param1.headerHeight - this.compoBottomControlBar.height + 1) / param1.appScaleSize;
            this.compoListGame = new CompoListGame(param1.preloader.loadGame, this, _loc_2);
            this.compoListGame.scaleX = param1.appScaleSize;
            this.compoListGame.scaleY = param1.appScaleSize;
            this.compoListGame.Load(param1.preloader.getTexturesOfGameIcon(param1.preloader.urlGamePath.GameIconPath));
            this.compoListGame.y = param1.headerHeight;
            this.addChild(this.listBoard);
            this.addChild(this.compoListGame);
            this.initHeader();
            this.compoListGame.onExtendClick(null);
            return;
        }// end function

        public function loadDataThongTinScreen() : void
        {
            if (this.thongTinScreen == null)
            {
                this.thongTinScreen = new ThongTinScreen();
                this.thongTinScreen.preLoader = this.gameLoader.preloader;
                this.thongTinScreen.gameLoader = this.gameLoader;
                this.thongTinScreen.scaleX = this.gameLoader.preloader.appScaleSize;
                this.thongTinScreen.scaleY = this.gameLoader.preloader.appScaleHeight;
                this.addChild(this.thongTinScreen);
            }
            this.thongTinScreen.visible = true;
            this.setChildIndex(this.thongTinScreen, (this.numChildren - 1));
            this.thongTinScreen.loadDataThongTinScreen();
            return;
        }// end function

        public function get compoBottomBarInGame() : CompoBottomBarInGame
        {
            if (this._compoBottomBarInGame == null)
            {
                this._compoBottomBarInGame = new CompoBottomBarInGame(true);
                this._compoBottomBarInGame.scaleX = this.gameLoader.appScaleSize;
                this._compoBottomBarInGame.scaleY = this.gameLoader.appScaleSize;
                this._compoBottomBarInGame.name = "compoBottomBarInLobby";
                this._compoBottomBarInGame.gameLoader = this.gameLoader;
                this.addChild(this._compoBottomBarInGame);
                this._compoBottomBarInGame.addEventListener("CHAT", this.onChat);
            }
            this._compoBottomBarInGame.y = this.gameLoader.stage.stageHeight - this._compoBottomBarInGame.height;
            this.setChildIndex(this._compoBottomBarInGame, (this.numChildren - 1));
            return this._compoBottomBarInGame;
        }// end function

        private function onChat(param1 = null) : void
        {
            this.gameLoader.onOpenChat();
            return;
        }// end function

        private function initBackgroundListBoard() : void
        {
            this.graphics.beginFill(4260097);
            this.graphics.drawRect(0, this.gameLoader.headerHeight, this.gameLoader.stage.stageWidth, this.gameLoader.stage.stageHeight - this.gameLoader.headerHeight);
            this.graphics.endFill();
            return;
        }// end function

        private function initHeader() : void
        {
            this.header_mc = new Sprite();
            var _loc_1:* = new Sprite();
            _loc_1.mouseChildren = false;
            _loc_1.mouseEnabled = false;
            _loc_1.graphics.beginBitmapFill(new headerBar_bitmap());
            _loc_1.graphics.drawRect(0, 0, this.gameLoader.stage.stageWidth, 80);
            _loc_1.graphics.endFill();
            _loc_1.scaleY = this.gameLoader.appScaleSize;
            this.header_mc.addChild(_loc_1);
            this.header_mc.mouseEnabled = false;
            if (this.headerTextFormat == null)
            {
                this.headerTextFormat = new TextFormat("Arial", 45, 16777215, true);
                this.headerTextFormat.align = TextFormatAlign.CENTER;
            }
            this.titleRoomType = new TextField();
            this.titleRoomType.name = "title";
            this.titleRoomType.selectable = false;
            this.titleRoomType.defaultTextFormat = this.headerTextFormat;
            this.titleRoomType.width = 500;
            this.titleRoomType.height = 55;
            this.titleRoomType.text = "";
            this.titleRoomType.mouseEnabled = false;
            this.titleRoomType.mouseWheelEnabled = false;
            this.titleRoomType.scaleX = this.gameLoader.appScaleSize;
            this.titleRoomType.scaleY = this.gameLoader.appScaleSize;
            this.titleRoomType.y = 80 - this.titleRoomType.height >> 1;
            this.titleRoomType.x = (this.gameLoader.stage.stageWidth - this.titleRoomType.width) * 0.5;
            this.titleRoomType.cacheAsBitmap = true;
            this.header_mc.addChild(this.titleRoomType);
            this.addChild(this.header_mc);
            this.titleRoomType = this.header_mc.getChildByName("title") as TextField;
            this.back_btn = new BackInLobby_btn();
            this.back_btn.scaleX = this.gameLoader.appScaleSize;
            this.back_btn.scaleY = this.gameLoader.appScaleSize;
            this.back_btn.x = this.gameLoader.getScaleHorizontal(5);
            this.back_btn.y = this.gameLoader.getScaleVertical(5);
            this.back_btn.btn.addEventListener(MouseEvent.CLICK, this.onBack);
            this.header_mc.addChild(this.back_btn);
            this.headerLobbyInfo = new HeaderLobbyInfo();
            this.headerLobbyInfo.x = this.back_btn.x + this.back_btn.width + this.gameLoader.getScaleHorizontal(50);
            this.headerLobbyInfo.scaleX = this.gameLoader.appScaleSize;
            this.headerLobbyInfo.scaleY = this.gameLoader.appScaleSize;
            this.headerLobbyInfo.y = this.gameLoader.getScaleVertical(5);
            this.headerLobbyInfo.name = "headerLobbyInfo";
            this.header_mc.addChild(this.headerLobbyInfo);
            return;
        }// end function

        private function onOpenPopUpSupportAndGold(event:MouseEvent) : void
        {
            this.dispatchEvent(new CustomEvent(CustomEvent.HOTLINE, null, true));
            return;
        }// end function

        public function onBack(event:MouseEvent = null, param2:String = "") : void
        {
            var e:* = event;
            var message:* = param2;
            this.gameLoader.preloader.showLog("-------->onBack: " + message);
            this.titleRoomType.text = "";
            this.gameLoader.playSoundClick();
            this.gameLoader.global.resetForJoinNewGroup();
            if (this.gameLoader.global.isJoinAnotherGameInLobby == false)
            {
                this.gameLoader.dispatchEvent(new CustomEvent(CustomEvent.REMOVE_GAME, {message:message}, true));
            }
            try
            {
                if (KF.socket.isConnected(this.gameLoader.global.socketKey))
                {
                    this.gameLoader.global.isBackingToMenuGame = true;
                    KF.socket.closeSocket(this.gameLoader.global.socketKey);
                }
            }
            catch (error:Error)
            {
                KF.showLog("onBack: " + error.getStackTrace());
            }
            return;
        }// end function

        final public function loadDataForCompoListBoard(event:MouseEvent = null) : void
        {
            this.listBoard.endLoad();
            var _loc_2:* = KF.socket.getRoomManager().getRoomList();
            this.listBoard.LoadListBoard(_loc_2);
            _loc_2 = null;
            return;
        }// end function

        public function updateBoardData(param1:String) : void
        {
            var _loc_3:RoomInfo = null;
            var _loc_2:* = this.gameLoader.global.getRoom(Number(param1));
            if (_loc_2)
            {
                _loc_3 = new RoomInfo(_loc_2);
                this.listBoard.updateArrNick(_loc_2);
                _loc_2 = null;
                _loc_3 = null;
            }
            return;
        }// end function

        public function addRoomToCompoListBoard(param1:Room) : void
        {
            this.listBoard.addBoard(param1);
            return;
        }// end function

        public function removeBoard(param1:String) : void
        {
            this.listBoard.removeBoard(param1);
            return;
        }// end function

        final public function updateCompoPUB(param1:Room) : void
        {
            return;
        }// end function

        final public function appendUser(param1:User) : void
        {
            var _loc_2:* = UserInfo.fromUser(param1);
            var _loc_3:* = _loc_2.nickName;
            if (_loc_3 == null)
            {
                return;
            }
            if (_loc_2.userKind != GlobalConstants.ADMIN_USERTYPE && _loc_2.userKind != GlobalConstants.MOD_USERTYPE || _loc_2.userId == this.gameLoader.global.Me.getId())
            {
            }
            return;
        }// end function

        final public function removeUser(param1:User) : void
        {
            param1 = null;
            return;
        }// end function

        public function destroy() : void
        {
            this.listBoard.removeAll();
            this.listBoard.deactive();
            this.compoListGame.deactive();
            return;
        }// end function

        public function updateBoardStatus(param1:String, param2:String) : void
        {
            return;
        }// end function

        public function updateBetCoin(param1:String, param2:Number) : void
        {
            this.listBoard.updateBetCoin(param1, param2);
            return;
        }// end function

        public function updateCompMenuListRoom(param1:Room) : void
        {
            if (this.listGroupRoom == null)
            {
                return;
            }
            var _loc_2:* = RoomInfo.fromRoom(param1);
            this.setMinMaxBet(_loc_2.roomId);
            return;
        }// end function

        private function setMinMaxBet(param1:int) : void
        {
            var _loc_3:Array = null;
            var _loc_4:String = null;
            var _loc_5:Array = null;
            var _loc_2:* = this.gameLoader.lobbyScreen.listGroupRoom;
            for each (_loc_3 in _loc_2)
            {
                
                if (int(_loc_3[0]) == param1)
                {
                    _loc_4 = _loc_3[6];
                    _loc_5 = _loc_4.split(":");
                    this.gameLoader.global.minBet = _loc_5[0];
                    this.gameLoader.global.maxBet = _loc_5[1];
                }
            }
            return;
        }// end function

        public function updateLockBoard(param1:String, param2:Boolean) : void
        {
            this.listBoard.updateLockBoard(param1, param2);
            return;
        }// end function

        public function updatePasswordBoardStatus(param1:String, param2:Boolean) : void
        {
            this.listBoard.updatePasswordBoardStatus(param1, param2);
            return;
        }// end function

        public function updateRule(param1:String, param2:String) : void
        {
            this.listBoard.updateRule(param1, param2);
            return;
        }// end function

        public function updateTitleRoomType() : void
        {
            var _loc_2:String = null;
            var _loc_1:* = this.gameLoader.global.roomType;
            switch(_loc_1)
            {
                case 5:
                {
                    _loc_2 = "PHNG TOUR";
                    break;
                }
                case 3:
                {
                    _loc_2 = "PHNG VIP";
                    break;
                }
                case 2:
                {
                    _loc_2 = "PHNG A";
                    break;
                }
                case 1:
                {
                    _loc_2 = "PHNG B";
                    break;
                }
                default:
                {
                    _loc_2 = "PHNG";
                    break;
                    break;
                }
            }
            return;
        }// end function

        public function loadHeaderListRoom() : void
        {
            var _loc_1:* = this.header_mc.getChildByName("headerLobbyInfo") as HeaderLobbyInfo;
            if (_loc_1)
            {
                _loc_1.loadRoom(this.listGroupRoom);
            }
            return;
        }// end function

        public function updateHeaderLobbyInfoListRoom(param1:Room) : void
        {
            var _loc_2:* = RoomInfo.fromRoom(param1);
            var _loc_3:* = this.header_mc.getChildByName("headerLobbyInfo") as HeaderLobbyInfo;
            if (_loc_3)
            {
                _loc_3.SelectionRoom = _loc_2.roomId;
            }
            return;
        }// end function

        public function updateListGame() : void
        {
            this.compoListGame.arrangeItemGame(this.gameLoader.global.gameID);
            return;
        }// end function

        public function expandListBoard() : void
        {
            this.listBoard.x = this.gameLoader.getScaleHorizontal(65);
            this.listBoard.expandListBoard();
            return;
        }// end function

        public function collapseListBoard() : void
        {
            this.listBoard.x = this.gameLoader.getScaleHorizontal(260);
            this.listBoard.collapseListBoard();
            return;
        }// end function

        public function activeFocusListGame(param1:Boolean) : void
        {
            this.compoListGame.mouseChildren = param1;
            this.compoListGame.mouseEnabled = param1;
            return;
        }// end function

        public function updateAvatar(param1:String) : void
        {
            if (this.compoBottomControlBar)
            {
                this.compoBottomControlBar.Avatar = param1;
            }
            if (this.thongTinScreen)
            {
                this.thongTinScreen.Avatar = param1;
            }
            return;
        }// end function

    }
}
