package net.mgame.ui.jackpot
{
    import MGameUtilities.*;
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.text.*;
    import net.mgame.lobby.*;
    import net.mgame.utils.*;

    public class Jackpot extends Sprite
    {
        private var gameLoader:GameLoader;
        public var jackpotCoin_txt:TextField;
        private var scrollingMessage:ScrollingMessage;
        public var score:Number = 0;
        public var jackpot_mc:Jackpot_mc;
        public var btn_QuestionJackpot:ButtonQuestion;
        private var bitmapJackpot:Bitmap;
        public var listHistoryJackpot:Array;
        public var listRateJackpot:String;
        private var winJackpot_mc:WinJackpot_mc;
        private var coinFly:CoinFly_mc;
        public var listTypeJackPot:Array;

        public function Jackpot()
        {
            this.gameLoader = GameLoader.getInstance();
            this.listHistoryJackpot = [];
            this.listTypeJackPot = [];
            this.initUI();
            return;
        }// end function

        private function initUI() : void
        {
            this.jackpot_mc = new Jackpot_mc();
            this.addChild(this.jackpot_mc);
            this.bitmapJackpot = new Bitmap();
            this.bitmapJackpot.width = this.jackpot_mc.width;
            this.bitmapJackpot.height = this.jackpot_mc.height;
            this.jackpot_mc.addChild(this.bitmapJackpot);
            this.btn_QuestionJackpot = new ButtonQuestion();
            this.btn_QuestionJackpot.x = this.jackpot_mc.x + this.jackpot_mc.width - 15;
            this.btn_QuestionJackpot.y = 3;
            addChild(this.btn_QuestionJackpot);
            var _loc_1:* = new TextFormat();
            _loc_1.bold = "bold";
            _loc_1.color = 16777215;
            _loc_1.size = 22;
            var _loc_2:* = new GlowFilter();
            _loc_2.color = 679560;
            _loc_2.strength = 8;
            _loc_2.blurX = 8;
            _loc_2.blurY = 8;
            _loc_2.quality = BitmapFilterQuality.LOW;
            this.jackpotCoin_txt = new TextField();
            this.jackpotCoin_txt.x = 50;
            this.jackpotCoin_txt.y = 8;
            this.jackpotCoin_txt.width = 166;
            this.jackpotCoin_txt.height = 33;
            this.jackpotCoin_txt.defaultTextFormat = _loc_1;
            this.jackpotCoin_txt.selectable = false;
            this.jackpotCoin_txt.mouseEnabled = false;
            this.jackpotCoin_txt.filters = [_loc_2];
            this.jackpotCoin_txt.cacheAsBitmap = true;
            this.jackpot_mc.addChild(this.jackpotCoin_txt);
            this.jackpot_mc.addEventListener(MouseEvent.CLICK, this.onActiveJackpot, false, 0, true);
            this.btn_QuestionJackpot.addEventListener(MouseEvent.CLICK, this.onShowHistoryJackpot, false, 0, true);
            this.scrollingMessage = new ScrollingMessage();
            this.scrollingMessage.x = 750;
            this.scrollingMessage.y = 33;
            this.addChild(this.scrollingMessage);
            this.processActiveJackpot();
            this.hide();
            return;
        }// end function

        public function show() : void
        {
            if (this.listRateJackpot != null && this.listRateJackpot != "")
            {
                this.initDataInfoJackPot();
            }
            this.visible = true;
            if (this.gameLoader.global.isGameTLMN || this.gameLoader.global.isGameSam)
            {
                this.btn_QuestionJackpot.visible = false;
            }
            else
            {
                this.btn_QuestionJackpot.visible = true;
            }
            return;
        }// end function

        private function initDataInfoJackPot() : void
        {
            var _loc_1:Array = null;
            var _loc_2:Array = null;
            var _loc_3:Object = null;
            var _loc_4:int = 0;
            if (this.listTypeJackPot[0] == null || this.listTypeJackPot[0] == "")
            {
                _loc_1 = this.listRateJackpot.split(";");
                if (this.checkGameHavejackpot())
                {
                    _loc_4 = 0;
                    while (_loc_4 < _loc_1.length)
                    {
                        
                        _loc_2 = _loc_1[_loc_4].split(":");
                        _loc_3 = new Object();
                        _loc_3 = {n:_loc_2[0], p:_loc_2[1]};
                        this.listTypeJackPot.push(_loc_3);
                        _loc_4++;
                    }
                    this.gameLoader.globalComponents.compoHistoryJackpot.setTypeListJackpot(this.listTypeJackPot);
                }
            }
            return;
        }// end function

        public function hide() : void
        {
            this.visible = false;
            this.gameLoader.globalComponents.compoHistoryJackpot.hide();
            this.listRateJackpot = "";
            this.listTypeJackPot = [];
            return;
        }// end function

        private function onActiveJackpot(event:MouseEvent) : void
        {
            if (this.gameLoader.global.MyInfo.position < 1)
            {
                return;
            }
            this.gameLoader.playSoundClick();
            this.gameLoader.controller.sendUpdateActiveJackpot(!this.gameLoader.global.MyInfo.isActiveJackPot);
            return;
        }// end function

        private function onShowHistoryJackpot(event:MouseEvent) : void
        {
            this.gameLoader.playSoundClick();
            if (this.gameLoader.globalComponents.compoHistoryJackpot.visible)
            {
                this.gameLoader.globalComponents.compoHistoryJackpot.hide();
            }
            else if (!this.showHistoryJackpot())
            {
                this.gameLoader.controller.sendGetHistoryJackpot();
            }
            if (this.listRateJackpot == null || this.listRateJackpot == "")
            {
                this.gameLoader.controller.sendGetRateJackpot();
            }
            return;
        }// end function

        public function set coin(param1:Number) : void
        {
            param1 = param1 / 1000;
            TweenLite.to(this, 2.5, {score:param1, onUpdate:this.showScore, ease:Linear.easeNone, onComplete:this.onCompleteTween});
            return;
        }// end function

        private function onCompleteTween() : void
        {
            TextFilterFormat.generateBitmap(this.jackpotCoin_txt, this.bitmapJackpot);
            return;
        }// end function

        private function showScore() : void
        {
            this.jackpotCoin_txt.text = Format.MobileCoinFormat(Math.round(this.score) * 1000);
            return;
        }// end function

        public function showMessage(param1:String) : void
        {
            this.scrollingMessage.showMessage(param1);
            return;
        }// end function

        public function showHistoryJackpot() : Boolean
        {
            if (this.gameLoader.global.isPlaying)
            {
                this.gameLoader.globalComponents.compoHistoryJackpot.show(this.listHistoryJackpot, this.gameLoader.global.gameID, this.gameLoader.global.matchId);
            }
            else
            {
                this.gameLoader.globalComponents.compoHistoryJackpot.show(this.listHistoryJackpot, this.gameLoader.global.gameID);
            }
            return false;
        }// end function

        public function processActiveJackpot() : void
        {
            if (this.checkGameHavejackpot())
            {
                this.jackpot_mc.status.gotoAndStop(this.gameLoader.global.MyInfo.isActiveJackPot ? (1) : (2));
                this.gameLoader.globalComponents.compoHistoryJackpot.setStatusActiveJackpot(this.gameLoader.global.MyInfo.isActiveJackPot);
            }
            return;
        }// end function

        private function checkGameHavejackpot() : Boolean
        {
            if (this.gameLoader.global.isGameXiTo || this.gameLoader.global.isGameTLMN || this.gameLoader.global.isGameU9La || this.gameLoader.global.isGameSam || this.gameLoader.global.isGameBinh)
            {
                return true;
            }
            return false;
        }// end function

    }
}
