package net.mgame.ui.jackpot
{
    import com.greensock.*;
    import com.greensock.easing.*;
    import flash.display.*;
    import flash.text.*;

    public class ScrollingMessage extends Sprite
    {
        private var tween:TweenMax;
        private var message_txt:TextField;
        private var arrMessage:Array;
        private var isPlaying:Boolean = false;

        public function ScrollingMessage()
        {
            this.arrMessage = [];
            var _loc_1:* = new Sprite();
            _loc_1.graphics.beginFill(16777215);
            _loc_1.graphics.drawRect(0, 0, 240, 25);
            _loc_1.graphics.endFill();
            this.addChild(_loc_1);
            this.mask = _loc_1;
            var _loc_2:* = new TextFormat();
            _loc_2.bold = "bold";
            _loc_2.color = 16777215;
            _loc_2.size = 16;
            _loc_2.font = "Arial";
            this.message_txt = new TextField();
            this.message_txt.x = 0;
            this.message_txt.width = 240;
            this.message_txt.height = 25;
            this.message_txt.defaultTextFormat = _loc_2;
            this.message_txt.selectable = false;
            this.message_txt.mouseEnabled = false;
            this.message_txt.cacheAsBitmap = true;
            this.addChild(this.message_txt);
            return;
        }// end function

        public function showMessage(param1:String, param2:int = 2) : void
        {
            if (this.isPlaying)
            {
                this.arrMessage.push(param1);
                return;
            }
            this.message_txt.text = param1;
            this.message_txt.x = this.message_txt.textWidth + 10;
            this.message_txt.width = this.message_txt.textWidth + 10;
            this.tween = new TweenMax(this.message_txt, 8, {x:-this.message_txt.textWidth, ease:Linear.easeNone, onComplete:this.onFinishTween});
            this.tween.repeat(param2);
            this.tween.play();
            this.isPlaying = true;
            return;
        }// end function

        private function onFinishTween() : void
        {
            this.reset();
            this.isPlaying = false;
            if (this.arrMessage.length > 0)
            {
                this.showMessage(this.arrMessage.shift());
            }
            return;
        }// end function

        private function reset() : void
        {
            this.message_txt.x = 0;
            this.message_txt.width = 240;
            this.message_txt.height = 25;
            this.message_txt.text = "";
            return;
        }// end function

        public function stop() : void
        {
            this.tween.kill();
            this.reset();
            return;
        }// end function

    }
}
