package net.mgame.ui.listboard
{
    import net.king.entities.*;
    import net.mgame.models.*;

    public class BoardData extends Object
    {
        public var boardName:String = "";
        public var boardId:Number = 0;
        public var betCoin:Number = 0;
        public var textRule:String = "";
        public var numUser:uint = 0;
        public var roomId:Number = 0;
        public var isGame:Boolean = false;
        public var isLocked:Boolean = false;
        public var hasPassword:Boolean = false;
        public var ownerName:String = "";
        public var ownerNameFull:String = "";
        public var roomOwnerID:int = 0;
        public var listNick:Array;
        public var isDefaultBoard:Boolean;
        public var view:ListBoardNewItem;
        public var isDefaultBoardWithHardMaxTayRule:Boolean = false;
        public var isSolo:Boolean = false;
        public var isGopGa:Boolean = false;

        public function BoardData(param1:Room)
        {
            var _loc_2:* = RoomInfo.fromRoom(param1);
            this.roomId = param1.getId();
            var _loc_3:* = param1.getName();
            if (_loc_3.indexOf("Default_") > -1)
            {
                this.boardName = "M?c d?nh";
                _loc_3 = _loc_3.replace("Default_", "");
            }
            else
            {
                this.boardName = _loc_3;
            }
            this.isDefaultBoard = _loc_2.isDefault;
            this.boardId = Number(_loc_3);
            this.betCoin = _loc_2.betCoin;
            this.textRule = _loc_2.rules;
            this.numUser = _loc_2.arrNick.length;
            this.ownerName = "";
            this.ownerNameFull = "";
            this.roomOwnerID = _loc_2.ownerId;
            this.updateOwnerName(_loc_2.arrNick);
            this.listNick = _loc_2.arrNick;
            this.isLocked = _loc_2.oKhoa == 1;
            this.isSolo = _loc_2.isSolo;
            this.isGopGa = _loc_2.isGopGa;
            return;
        }// end function

        public function updateOwnerName(param1:Array) : void
        {
            var _loc_2:UserInBoard = null;
            var _loc_3:int = 0;
            var _loc_4:int = 0;
            if (param1 != null && param1.length != 0)
            {
                _loc_3 = param1.length;
                _loc_4 = 0;
                while (_loc_4 < _loc_3)
                {
                    
                    _loc_2 = param1[_loc_4];
                    if (_loc_2.userId == this.roomOwnerID)
                    {
                        this.ownerName = _loc_2.nickName;
                        this.ownerNameFull = _loc_2.nickName;
                        if (this.ownerName.length > 12)
                        {
                            this.ownerName = this.ownerName.substr(0, 12) + "...";
                        }
                        break;
                    }
                    _loc_4++;
                }
            }
            else
            {
                this.ownerName = "";
                this.ownerNameFull = "";
            }
            return;
        }// end function

        public function release() : void
        {
            this.view = null;
            return;
        }// end function

        public function refeshView() : void
        {
            if (this.view != null)
            {
                if (this.isSolo)
                {
                    this.view.maxPlayer = 2;
                }
                else
                {
                    this.view.maxPlayer = GameLoader.getInstance().global.maxPlayer;
                }
                this.view.betCoin = this.betCoin;
                this.view.roomId = this.roomId;
                this.view.boardName = this.boardName;
                this.view.numUser = this.numUser;
                if (this.isSolo && this.textRule.indexOf("Solo") < 0)
                {
                    this.textRule = this.textRule + " Solo";
                }
                else if (!this.isSolo && this.textRule.indexOf("Solo") > -1)
                {
                    this.textRule = this.textRule.replace("Solo", "");
                }
                if (this.isGopGa && this.textRule.indexOf("G") < 0)
                {
                    this.textRule = this.textRule + " G";
                }
                else if (!this.isGopGa && this.textRule.indexOf("G") > -1)
                {
                    this.textRule = this.textRule.replace("G", "");
                }
                this.view.textRule = this.textRule;
                this.view.hasPassword = this.hasPassword;
                this.view.isLocked = this.isLocked;
                this.view.visible = true;
                this.view.ownerName = this.ownerName;
                this.view.ownerNameFull = this.ownerNameFull;
                this.view.gotoAndStop(1);
                this.view.listNick = this.listNick;
                if (this.listNick.length == 0)
                {
                    this.view.visibleExpandICon = false;
                }
                else
                {
                    this.view.visibleExpandICon = true;
                }
            }
            return;
        }// end function

    }
}
