package net.mgame.ui.listboard
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import net.mgame.*;

    public class CustomScrollPane extends Sprite
    {
        private var _mouseDown:Boolean = false;
        private var _velocity:Number = 0;
        private var _mouseDownY:Number = 0;
        private var _mouseDownPoint:Point;
        private var _lastMouseDownPoint:Point;
        private var _scrollRate:Number = 0;
        private var PERFECT_RATE:Number = 0;
        private var _canvasHeight:Number = 0;
        private var myCanvas:Sprite;
        public var myScrollElement:Sprite;
        private var _isAlwayShowScroll:Boolean = false;
        private var _contentWidth:Number = 0;
        private var _contentHeight:Number = 0;
        private var w:Number;
        private var h:Number;
        private const SCREEN_WIDTH:int = 1215;
        private var _itemX:Number = 0;
        private var listBoard:ListBoardNew;
        private var global:Global;
        private var targetDown:ListBoardNewItem;
        private var _moveTime:int = 0;
        private var lastY:Number = 0;
        private static var DECAY:Number = 0.93;
        private static var MOUSE_DOWN_DECAY:Number = 0.7;
        private static var SPEED_SPRINGNESS:Number = 0.4;
        private static var BOUNCING_SPRINGESS:Number = 0.08;

        public function CustomScrollPane(param1:Number, param2:Number, param3:ListBoardNew)
        {
            this._mouseDownPoint = new Point();
            this._lastMouseDownPoint = new Point();
            this.w = param1;
            this.h = param2;
            this.listBoard = param3;
            this.myCanvas = new Sprite();
            this.myCanvas.buttonMode = true;
            this.addChild(this.myCanvas);
            this._canvasHeight = param2;
            var _loc_4:* = new Sprite();
            _loc_4.graphics.lineStyle(0, 0);
            _loc_4.graphics.beginFill(0);
            _loc_4.graphics.drawRect(0, 0, param1, param2);
            _loc_4.graphics.endFill();
            this.myCanvas.addChild(_loc_4);
            this.myCanvas.mask = _loc_4;
            var _loc_5:* = new Sprite();
            _loc_5.graphics.lineStyle(0, 0);
            _loc_5.graphics.beginFill(16711680);
            _loc_5.graphics.drawRect(0, 0, param1, param2);
            _loc_5.graphics.endFill();
            _loc_5.alpha = 0;
            this.myCanvas.addChildAt(_loc_5, 0);
            this.myScrollElement = this.listBoard.boardContainer;
            this.myCanvas.addChild(this.myScrollElement);
            this.myCanvas.addEventListener(MouseEvent.MOUSE_DOWN, this.on_mouse_down, false, 0, true);
            this.myCanvas.addEventListener(MouseEvent.MOUSE_OVER, this.onMouseOver, false, 0, true);
            this.global = GameLoader.getInstance().global;
            return;
        }// end function

        private function on_enter_frame(event:Event) : void
        {
            var _loc_2:Number = NaN;
            var _loc_3:Number = NaN;
            var _loc_4:Number = NaN;
            var _loc_5:Number = NaN;
            if (this._mouseDown)
            {
                this._velocity = this._velocity * MOUSE_DOWN_DECAY;
            }
            else
            {
                this._velocity = this._velocity * DECAY;
            }
            if (!this._mouseDown)
            {
                _loc_2 = this.getScrollHeight();
                _loc_3 = this.myScrollElement.y;
                _loc_4 = 0;
                if (_loc_3 > 0)
                {
                    _loc_4 = (-_loc_3) * BOUNCING_SPRINGESS;
                }
                else if (_loc_3 + _loc_2 < this._canvasHeight)
                {
                    _loc_4 = (this._canvasHeight - _loc_2 - _loc_3) * BOUNCING_SPRINGESS;
                }
                _loc_5 = this.myScrollElement.y - (_loc_3 + this._velocity + _loc_4);
                if (Math.abs(_loc_5) < 0.5)
                {
                    this._velocity = 0;
                    _loc_4 = 0;
                }
                this.itemY = _loc_3 + this._velocity + _loc_4;
            }
            return;
        }// end function

        private function on_mouse_down(event:MouseEvent) : void
        {
            if (!this._mouseDown)
            {
                if (this.listBoard.listBoardData.length > 5 && this.hasEventListener(Event.ENTER_FRAME) == false)
                {
                    this.addEventListener(Event.ENTER_FRAME, this.on_enter_frame);
                }
                this._mouseDownPoint = new Point(event.stageX, event.stageY);
                this._lastMouseDownPoint = new Point(event.stageX, event.stageY);
                this._mouseDown = true;
                this._mouseDownY = this.myScrollElement.y;
                stage.addEventListener(MouseEvent.MOUSE_UP, this.on_mouse_up, false, 0, true);
                stage.addEventListener(MouseEvent.MOUSE_MOVE, this.on_mouse_move, false, 0, true);
                this.targetDown = event.target as ListBoardNewItem;
                if (this.targetDown != null)
                {
                    this.targetDown.gotoAndStop(2);
                    this._moveTime = -5;
                }
            }
            return;
        }// end function

        public function stopEnterFrame() : void
        {
            this.myScrollElement.y = 0;
            this.removeEventListener(Event.ENTER_FRAME, this.on_enter_frame);
            return;
        }// end function

        private function onMouseOver(event:MouseEvent) : void
        {
            this.myCanvas.addEventListener(MouseEvent.MOUSE_OUT, this.onMouseOut, false, 0, true);
            return;
        }// end function

        private function onMouseOut(event:MouseEvent) : void
        {
            this.myCanvas.removeEventListener(MouseEvent.MOUSE_OUT, this.onMouseOut);
            return;
        }// end function

        private function on_mouse_move(event:MouseEvent) : void
        {
            var _loc_2:Point = null;
            if (this._mouseDown)
            {
                if (this.myScrollElement.height < this.h)
                {
                    return;
                }
                var _loc_3:String = this;
                var _loc_4:* = this._moveTime + 1;
                _loc_3._moveTime = _loc_4;
                _loc_2 = new Point(event.stageX, event.stageY);
                this.itemY = this._mouseDownY + (_loc_2.y - this._mouseDownPoint.y);
                this._velocity = this._velocity + (_loc_2.y - this._lastMouseDownPoint.y) * SPEED_SPRINGNESS;
                this._lastMouseDownPoint = _loc_2;
            }
            return;
        }// end function

        private function on_mouse_up(event:MouseEvent) : void
        {
            var _loc_2:Boolean = false;
            var _loc_3:ListBoardNewItem = null;
            if (this._mouseDown)
            {
                _loc_2 = false;
                this._mouseDown = false;
                _loc_3 = event.target as ListBoardNewItem;
                if (this.targetDown != null)
                {
                    if (this.targetDown == _loc_3)
                    {
                        if (this._moveTime < 0)
                        {
                            if (this.targetDown.mouseX >= this.targetDown.getXBoundOfExpandButton() && this.targetDown.mouseX <= this.targetDown.getXBoundOfExpandButton() + 60 && this.targetDown.mouseY >= 16 && this.targetDown.mouseY <= 66 && this.targetDown.visibleExpandICon == true && this.global.isTourRoom == false)
                            {
                                _loc_2 = this.listBoard.popUp.show(this.targetDown.listNick, this.targetDown.ownerNameFull, this.targetDown);
                                this.listBoard.popUp.x = this.targetDown.parent.parent.parent.localToGlobal(new Point(this.targetDown.x, this.targetDown.y)).x + 400;
                                this.listBoard.popUp.y = this.targetDown.parent.parent.parent.localToGlobal(new Point(this.targetDown.x, this.targetDown.y)).y / this.parent.scaleY - this.targetDown.height;
                                if (this.listBoard.popUp.y <= 0)
                                {
                                    this.listBoard.popUp.y = 0;
                                }
                                if (this.listBoard.popUp.y + this.listBoard.popUp.height >= this.h)
                                {
                                    this.listBoard.popUp.y = this.h - this.listBoard.popUp.height;
                                }
                            }
                            else
                            {
                                this.listBoard.onClickBoard(this.targetDown);
                            }
                        }
                    }
                    this.targetDown.gotoAndStop(1);
                }
                if (_loc_2 == false)
                {
                    this.listBoard.popUp.hide();
                }
                this.targetDown = null;
                if (stage)
                {
                    stage.removeEventListener(MouseEvent.MOUSE_UP, this.on_mouse_up);
                    stage.removeEventListener(MouseEvent.MOUSE_MOVE, this.on_mouse_move);
                }
            }
            this._moveTime = -5;
            return;
        }// end function

        public function UpdateDisplay() : void
        {
            this._scrollRate = 1;
            return;
        }// end function

        public function updateStatusBoard() : void
        {
            return;
        }// end function

        private function getScrollHeight() : int
        {
            return this.myScrollElement.height;
        }// end function

        public function refesh() : void
        {
            var _loc_2:ListBoardNewItem = null;
            var _loc_4:Number = NaN;
            var _loc_5:Number = NaN;
            var _loc_1:* = this.listBoard.listBoardData.length;
            var _loc_3:int = 0;
            if (_loc_1 > 1)
            {
                this.lastY = this.myScrollElement.y;
                _loc_4 = -76 - this.lastY;
                _loc_5 = _loc_4 + this.h + 76;
                _loc_3 = 0;
                while (_loc_3 < _loc_1)
                {
                    
                    _loc_2 = this.listBoard.listBoardData[_loc_3].view;
                    if (_loc_2.y >= _loc_4 && _loc_2.y <= _loc_5)
                    {
                        _loc_2.visible = true;
                    }
                    else
                    {
                        _loc_2.visible = false;
                    }
                    _loc_3++;
                }
            }
            return;
        }// end function

        public function set itemY(param1:Number) : void
        {
            this.myScrollElement.y = param1;
            if (Math.abs(this.lastY - param1) > 5)
            {
                this.refesh();
            }
            return;
        }// end function

    }
}
