package net.mgame.ui.listboard
{
    import MGameEvents.*;
    import __AS3__.vec.*;
    import flash.display.*;
    import flash.events.*;
    import net.king.entities.*;
    import net.mGame.controllers.*;
    import net.mgame.keys.*;
    import net.mgame.listboard.*;
    import net.mgame.models.*;

    public class ListBoardNew extends CompoWithLoading
    {
        private var bg:img_bgListboard;
        public var boardContainer:Sprite;
        private var gameLoader:GameLoader;
        public var listBoardData:Vector.<BoardData>;
        private var scroll:CustomScrollPane;
        private var SORT_BET:int = 1;
        private var SORT_NUMBERUSER:int = 2;
        public var popUp:PopupUserInBoard;
        private var _height:Number = 0;
        private var sortBetCoinLonToiNho:Boolean = false;
        private var sortNumUserLonToiNho:Boolean = false;
        private var currentSortType:int;

        public function ListBoardNew()
        {
            this.gameLoader = GameLoader.getInstance();
            this.listBoardData = new Vector.<BoardData>(0);
            this.currentSortType = this.SORT_BET;
            this.bg = new img_bgListboard();
            this.bg.bg_header.visible = false;
            this.addChild(this.bg);
            this.bg.btnSortCuoc.addEventListener(MouseEvent.CLICK, this.onClickSort);
            this.bg.btnSortNumUser.addEventListener(MouseEvent.CLICK, this.onClickSort);
            this.boardContainer = new Sprite();
            this.addEventListener(Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.popUp = new PopupUserInBoard();
            this.popUp.playSoundClick = this.gameLoader.playSoundClick;
            this.addChild(this.popUp);
            return;
        }// end function

        private function onAddedToStage(event:Event) : void
        {
            removeEventListener(Event.ADDED_TO_STAGE, this.onAddedToStage);
            var _loc_2:* = this.gameLoader.stage.stageHeight * (1 / this.scaleY);
            var _loc_3:* = (this.gameLoader.headerHeight + 60 * this.scaleY + this.gameLoader.lobbyScreen.compoBottomControlBar.height) * (1 / this.scaleY);
            this._height = _loc_2 - _loc_3;
            this.scroll = new CustomScrollPane(1215, this._height, this);
            this.scroll.y = 60;
            this.addChild(this.scroll);
            this.initBackgroundListBoard();
            return;
        }// end function

        public function LoadListBoard(param1:Array) : void
        {
            var _loc_4:BoardData = null;
            this.removeAll();
            var _loc_2:* = param1.concat();
            var _loc_3:* = _loc_2.length;
            var _loc_5:int = 0;
            while (_loc_5 < _loc_3)
            {
                
                if (_loc_2[_loc_5].IsGame() == true)
                {
                    _loc_4 = new BoardData(_loc_2[_loc_5]);
                    if (this.gameLoader.global.isGameTaiXiu)
                    {
                        _loc_4.numUser = RoomInfo.fromRoom(_loc_2[_loc_5]).numView;
                        _loc_4.betCoin = GlobalConstants.TAI_XIU_MAX_BET_ROOM_DEFAULT;
                    }
                    else if (this.gameLoader.global.isGameXiTo && _loc_4.isDefaultBoard && RoomInfo.fromRoom(_loc_2[_loc_5]).rules.indexOf(GlobalConstants.LUAT_TAY_MAX_XITO) > -1)
                    {
                        _loc_4.isDefaultBoardWithHardMaxTayRule = true;
                    }
                    _loc_4.textRule = this.gameLoader.global.getRuleForListBoard(_loc_4.textRule, this.gameLoader.global.gameID);
                    this.listBoardData.push(_loc_4);
                }
                _loc_5++;
            }
            this.drawData();
            return;
        }// end function

        private function drawData() : void
        {
            var _loc_2:BoardData = null;
            var _loc_3:ListBoardNewItem = null;
            if (this.currentSortType == this.SORT_BET)
            {
                this.listBoardData.sort(this.SortByBetCoinForBoardData);
            }
            else
            {
                this.listBoardData.sort(this.SortByNumberUserForBoardData);
            }
            var _loc_1:* = this.listBoardData.length;
            var _loc_4:int = 0;
            var _loc_5:int = 0;
            while (_loc_5 < _loc_1)
            {
                
                if (_loc_5 >= this.boardContainer.numChildren)
                {
                    _loc_3 = new ListBoardNewItem();
                    _loc_3.Currency = this.gameLoader.global.currency;
                    this.boardContainer.addChild(_loc_3);
                    _loc_3.y = _loc_5 * 75;
                }
                else
                {
                    _loc_3 = this.boardContainer.getChildAt(_loc_5) as ListBoardNewItem;
                }
                _loc_2 = this.listBoardData[_loc_5];
                _loc_3.maxPlayer = this.gameLoader.global.maxPlayer;
                _loc_2.view = _loc_3;
                if (_loc_3.visible == false)
                {
                    _loc_3.y = _loc_5 * 75;
                }
                _loc_2.refeshView();
                if (this.bg.bg_header.width == 1215)
                {
                    _loc_3.expand();
                }
                else
                {
                    _loc_3.collapse();
                }
                _loc_5++;
            }
            while (_loc_1 < this.boardContainer.numChildren && _loc_5 < this.boardContainer.numChildren)
            {
                
                _loc_3 = this.boardContainer.getChildAt(_loc_5) as ListBoardNewItem;
                if (_loc_3 != null)
                {
                    _loc_3.visible = false;
                    _loc_3.y = _loc_1 * 75 + 2;
                }
                _loc_5++;
            }
            return;
        }// end function

        public function removeAll() : void
        {
            var _loc_1:BoardData = null;
            var _loc_2:ListBoardNewItem = null;
            this.popUp.hide();
            var _loc_3:* = this.boardContainer.numChildren;
            var _loc_4:int = 0;
            while (_loc_4 < _loc_3)
            {
                
                _loc_2 = this.boardContainer.getChildAt(_loc_4) as ListBoardNewItem;
                _loc_2.clearAll();
                _loc_2.y = 385;
                _loc_4++;
            }
            _loc_3 = this.listBoardData.length;
            _loc_4 = 0;
            while (_loc_4 < _loc_3)
            {
                
                _loc_1 = this.listBoardData[_loc_4];
                _loc_1.release();
                _loc_4++;
            }
            this.listBoardData.splice(0, this.listBoardData.length);
            return;
        }// end function

        public function onClickBoard(param1:ListBoardNewItem) : void
        {
            this.gameLoader.playSoundClick();
            this.dispatchEvent(new JoinBoardEvent(JoinBoardEvent.VIEWER_JOIN_BOARD, {boardID:param1.roomId, boardName:param1.boardName, IsJoinView:false, isLock:param1.isLocked, isSetPass:param1.hasPassword}, true));
            return;
        }// end function

        public function updateBetCoin(param1:String, param2:Number) : void
        {
            var _loc_3:BoardData = null;
            if (!isLoading)
            {
                _loc_3 = this.getBoardData(int(param1));
                if (_loc_3 != null)
                {
                    _loc_3.betCoin = param2;
                    _loc_3.refeshView();
                    this.drawData();
                }
            }
            return;
        }// end function

        public function updateRule(param1:String, param2:String) : void
        {
            var _loc_3:BoardData = null;
            if (!isLoading)
            {
                _loc_3 = this.getBoardData(int(param1));
                if (_loc_3 != null)
                {
                    _loc_3.textRule = this.gameLoader.global.getRuleForListBoard(param2, this.gameLoader.global.gameID);
                    if (this.gameLoader.global.isGameXiTo)
                    {
                        if (_loc_3.isDefaultBoardWithHardMaxTayRule && param2.split(",").length == 2)
                        {
                            _loc_3.textRule = "T?y Max";
                        }
                    }
                    _loc_3.refeshView();
                }
            }
            return;
        }// end function

        public function addBoard(param1:Room) : void
        {
            var _loc_2:BoardData = null;
            if (!isLoading)
            {
                _loc_2 = new BoardData(param1);
                _loc_2.textRule = this.gameLoader.global.getRuleForListBoard(_loc_2.textRule, this.gameLoader.global.gameID);
                this.listBoardData.push(_loc_2);
                this.drawData();
            }
            return;
        }// end function

        public function removeBoard(param1:String) : void
        {
            var _loc_2:BoardData = null;
            var _loc_3:int = 0;
            var _loc_4:int = 0;
            if (!isLoading)
            {
                _loc_3 = this.listBoardData.length;
                _loc_4 = 0;
                while (_loc_4 < _loc_3)
                {
                    
                    if (this.listBoardData[_loc_4].roomId == Number(param1))
                    {
                        this.listBoardData.splice(_loc_4, 1);
                        break;
                    }
                    _loc_4++;
                }
                this.drawData();
            }
            return;
        }// end function

        public function updateArrNick(param1:Room) : void
        {
            var _loc_2:RoomInfo = null;
            var _loc_3:BoardData = null;
            if (!isLoading)
            {
                _loc_2 = RoomInfo.fromRoom(param1);
                _loc_3 = this.getBoardData(param1.getId());
                if (_loc_3 != null)
                {
                    _loc_3.roomOwnerID = _loc_2.ownerId;
                    _loc_3.updateOwnerName(_loc_2.arrNick);
                    if (this.gameLoader.global.isGameTaiXiu)
                    {
                        _loc_3.numUser = _loc_2.numView;
                        _loc_3.betCoin = GlobalConstants.TAI_XIU_MAX_BET_ROOM_DEFAULT;
                    }
                    else
                    {
                        _loc_3.numUser = _loc_2.arrNick.length;
                    }
                    _loc_3.listNick = _loc_2.arrNick;
                    _loc_3.isSolo = _loc_2.isSolo;
                    _loc_3.isGopGa = _loc_2.isGopGa;
                    _loc_3.refeshView();
                }
                this.drawData();
            }
            return;
        }// end function

        public function updateSoloBoard(param1:String, param2:Boolean) : void
        {
            var _loc_4:RoomInfo = null;
            var _loc_5:BoardData = null;
            var _loc_3:* = this.gameLoader.global.getRoom(Number(param1));
            if (_loc_3)
            {
                _loc_4 = RoomInfo.fromRoom(_loc_3);
                _loc_5 = this.getBoardData(_loc_3.getId());
                if (_loc_5)
                {
                    _loc_5.isSolo = param2;
                }
            }
            return;
        }// end function

        public function updateGopGa(param1:String, param2:Boolean) : void
        {
            var _loc_4:RoomInfo = null;
            var _loc_5:BoardData = null;
            var _loc_3:* = this.gameLoader.global.getRoom(Number(param1));
            if (_loc_3)
            {
                _loc_4 = RoomInfo.fromRoom(_loc_3);
                _loc_5 = this.getBoardData(_loc_3.getId());
                if (_loc_5)
                {
                    _loc_5.isGopGa = param2;
                }
            }
            return;
        }// end function

        public function updateLockBoard(param1:String, param2:Boolean) : void
        {
            var _loc_3:BoardData = null;
            if (!isLoading)
            {
                _loc_3 = this.getBoardData(Number(param1));
                if (_loc_3 != null)
                {
                    _loc_3.isLocked = param2;
                    _loc_3.refeshView();
                }
            }
            return;
        }// end function

        public function updatePasswordBoardStatus(param1:String, param2:Boolean) : void
        {
            var _loc_3:BoardData = null;
            if (!isLoading)
            {
                _loc_3 = this.getBoardData(Number(param1));
                if (_loc_3 != null)
                {
                    _loc_3.hasPassword = param2;
                    _loc_3.refeshView();
                }
            }
            return;
        }// end function

        private function getBoardData(param1:int) : BoardData
        {
            var _loc_2:BoardData = null;
            var _loc_3:* = this.listBoardData.length;
            var _loc_4:int = 0;
            while (_loc_4 < _loc_3)
            {
                
                _loc_2 = this.listBoardData[_loc_4];
                if (_loc_2.roomId == param1)
                {
                    return _loc_2;
                }
                _loc_4++;
            }
            return null;
        }// end function

        public function expandListBoard() : void
        {
            var _loc_1:BoardData = null;
            this.bg.bg_header.width = 1215;
            this.bg.bg_header.x = -8.68;
            this.bg.txtBoardid.x = 17.36;
            this.bg.txtBetCoin.x = 166.222;
            this.bg.txtNumUser.x = 416.764;
            this.bg.txtOnwername.x = 652.426;
            this.bg.txtGhiChu.x = 957.528;
            this.bg.btnSortCuoc.x = 194.68;
            this.bg.btnSortNumUser.x = 429.66;
            var _loc_2:int = 0;
            while (_loc_2 < this.listBoardData.length)
            {
                
                _loc_1 = this.listBoardData[_loc_2];
                _loc_1.view.expand();
                _loc_2++;
            }
            this.initBackgroundListBoard();
            return;
        }// end function

        public function collapseListBoard() : void
        {
            var _loc_1:BoardData = null;
            this.bg.bg_header.width = 1020;
            this.bg.bg_header.x = -7;
            this.bg.txtBoardid.x = 14;
            this.bg.txtBetCoin.x = 134.05;
            this.bg.txtNumUser.x = 336.1;
            this.bg.txtOnwername.x = 526.15;
            this.bg.txtGhiChu.x = 772.2;
            this.bg.btnSortCuoc.x = 157;
            this.bg.btnSortNumUser.x = 346.5;
            var _loc_2:int = 0;
            while (_loc_2 < this.listBoardData.length)
            {
                
                _loc_1 = this.listBoardData[_loc_2];
                _loc_1.view.collapse();
                _loc_2++;
            }
            this.initBackgroundListBoard();
            return;
        }// end function

        public function showLoading() : void
        {
            this.startLoad(0, 0, this.bg.bg_header.width, this.height / this.gameLoader.appScaleSize, 0, 15000, 0);
            return;
        }// end function

        public function endLoading() : void
        {
            this.endLoad();
            return;
        }// end function

        private function SortByBetCoinForBoardData(param1:BoardData, param2:BoardData) : Number
        {
            var _loc_3:* = param1.betCoin;
            var _loc_4:* = param2.betCoin;
            var _loc_5:* = param1.numUser;
            var _loc_6:* = param2.numUser;
            var _loc_7:* = param1.boardId;
            var _loc_8:* = param2.boardId;
            return this.compareBetCoinOrRoomIdForBoardData(_loc_3, _loc_4, _loc_5, _loc_6, _loc_7, _loc_8, this.sortBetCoinLonToiNho, this.sortNumUserLonToiNho);
        }// end function

        private function SortByNumberUserForBoardData(param1:BoardData, param2:BoardData) : Number
        {
            var _loc_3:* = param1.betCoin;
            var _loc_4:* = param2.betCoin;
            var _loc_5:* = param1.numUser;
            var _loc_6:* = param2.numUser;
            var _loc_7:* = param1.boardId;
            var _loc_8:* = param2.boardId;
            return this.compareBetCoinOrRoomIdForBoardData(_loc_5, _loc_6, _loc_3, _loc_4, _loc_7, _loc_8, this.sortNumUserLonToiNho, this.sortBetCoinLonToiNho);
        }// end function

        private function initBackgroundListBoard() : void
        {
            this.graphics.clear();
            this.graphics.drawRect(0, 0, this.bg.bg_header.width, this._height + 60);
            this.graphics.endFill();
            return;
        }// end function

        private function onClickSort(event:MouseEvent) : void
        {
            this.gameLoader.playSoundClick();
            var _loc_2:* = event.currentTarget as MovieClip;
            if (_loc_2)
            {
                switch(_loc_2.name)
                {
                    case "btnSortCuoc":
                    {
                        this.sortBetCoinLonToiNho = !this.sortBetCoinLonToiNho;
                        this.currentSortType = this.SORT_BET;
                        break;
                    }
                    case "btnSortNumUser":
                    {
                        this.sortNumUserLonToiNho = !this.sortNumUserLonToiNho;
                        this.currentSortType = this.SORT_NUMBERUSER;
                        break;
                    }
                    default:
                    {
                        break;
                    }
                }
                if (_loc_2.currentFrame == 2)
                {
                    _loc_2.gotoAndStop(1);
                }
                else
                {
                    _loc_2.gotoAndStop(2);
                }
            }
            this.drawData();
            return;
        }// end function

        private function compareBetCoinOrRoomIdForBoardData(param1:int, param2:int, param3:int, param4:int, param5:int, param6:int, param7:Boolean, param8:Boolean) : int
        {
            var _loc_9:int = 1;
            var _loc_10:int = 1;
            if (param7 == false)
            {
                _loc_9 = -1;
            }
            if (param8 == false)
            {
                _loc_10 = -1;
            }
            if (param1 > param2)
            {
                return Array.DESCENDING * _loc_9;
            }
            if (param1 < param2)
            {
                return (-Array.DESCENDING) * _loc_9;
            }
            if (param3 > param4)
            {
                return Array.DESCENDING * _loc_10;
            }
            if (param3 < param4)
            {
                return (-Array.DESCENDING) * _loc_10;
            }
            if (param5 > param6)
            {
                return Array.DESCENDING;
            }
            if (param5 < param6)
            {
                return -Array.DESCENDING;
            }
            return 0;
        }// end function

        public function deactive() : void
        {
            this.scroll.stopEnterFrame();
            return;
        }// end function

    }
}
