package net.mgame.ui.listboard
{
    import MGameUtilities.*;
    import flash.display.*;
    import net.mgame.listboard.*;
    import net.mgame.utils.*;
    import pxBitmapFont.*;

    public class ListBoardNewItem extends Sprite
    {
        private var bg:img_bgRowListboard;
        private var _roomId:uint = 0;
        private var _betCoin:Number = 0;
        private var _isPlaying:Boolean = true;
        private var _textRule:String = "";
        private var _numUser:uint = 0;
        private var _isLock:Boolean = false;
        private var _isKey:Boolean = false;
        private var _isLocked:Boolean = false;
        private var _hasPassword:Boolean = false;
        public var listNick:Array;
        public var ownerNameFull:String = "";
        public var maxPlayer:uint = 0;
        private var txtBoardId:PxTextField;
        private var txtBetCoin:PxTextField;
        private var txtNumUser:PxTextField;
        private var txtOwnerName:PxTextField;
        private var txtRule:PxTextField;
        private var txtCurrency:PxTextField;
        private var _boardName:String = "";
        private static var font2:PxBitmapFont = AssetsFonts.getFonts("Arial");

        public function ListBoardNewItem()
        {
            this.bg = new img_bgRowListboard();
            this.addChild(this.bg);
            this.mouseChildren = false;
            this.isLocked = false;
            this.hasPassword = false;
            this.iniTextField();
            return;
        }// end function

        private function iniTextField() : void
        {
            this.txtBoardId = this.createPxTextField(font2, 7, 121);
            this.txtCurrency = this.createPxTextField(font2, 138, 27);
            this.txtCurrency.color = 16776960;
            this.txtBetCoin = this.createPxTextField(font2, 167, 168.95);
            this.txtNumUser = this.createPxTextField(font2, 394.95, 87);
            this.txtOwnerName = this.createPxTextField(font2, 533, 168);
            this.txtRule = this.createPxTextField(font2, 703, 314.95);
            this.collapse();
            return;
        }// end function

        private function createPxTextField(param1:PxBitmapFont, param2:Number, param3:int = 100) : PxTextField
        {
            var _loc_4:* = new PxTextField(param1);
            _loc_4.y = 18;
            _loc_4.x = param2;
            _loc_4.fixedWidth = false;
            _loc_4.alignment = PxTextAlign.CENTER;
            _loc_4.width = param3;
            this.bg.addChild(_loc_4);
            return _loc_4;
        }// end function

        public function get roomId() : uint
        {
            return this._roomId;
        }// end function

        public function set roomId(param1:uint) : void
        {
            this._roomId = param1;
            return;
        }// end function

        public function set boardName(param1:String) : void
        {
            this.txtBoardId.text = param1;
            this._boardName = param1;
            return;
        }// end function

        public function get boardName() : String
        {
            return this._boardName;
        }// end function

        public function get betCoin() : Number
        {
            return this._betCoin;
        }// end function

        public function set betCoin(param1:Number) : void
        {
            this._betCoin = param1;
            this.txtBetCoin.text = Format.Coin(param1.toString());
            return;
        }// end function

        public function get textRule() : String
        {
            return this._textRule;
        }// end function

        public function set textRule(param1:String) : void
        {
            this._textRule = param1;
            this.txtRule.text = param1;
            return;
        }// end function

        public function get numUser() : uint
        {
            return this._numUser;
        }// end function

        public function set numUser(param1:uint) : void
        {
            this._numUser = param1;
            if (param1 == this.maxPlayer)
            {
                this.txtNumUser.color = 16774656;
                this.txtNumUser.text = "Full";
                this.gotoAndStop(3);
            }
            else
            {
                this.txtNumUser.color = 16777215;
                this.txtNumUser.text = param1 + "/" + this.maxPlayer;
            }
            return;
        }// end function

        public function get isBoardFull() : Boolean
        {
            return this.numUser == this.maxPlayer;
        }// end function

        public function get isLocked() : Boolean
        {
            return this._isLocked;
        }// end function

        public function set isLocked(param1:Boolean) : void
        {
            this._isLocked = param1;
            this.bg.lock_mc.visible = param1;
            if (param1 == false)
            {
                this.hasPassword = false;
            }
            return;
        }// end function

        public function get hasPassword() : Boolean
        {
            return this._hasPassword;
        }// end function

        public function set hasPassword(param1:Boolean) : void
        {
            this._hasPassword = param1;
            return;
        }// end function

        public function set ownerName(param1:String) : void
        {
            this.txtOwnerName.text = param1;
            return;
        }// end function

        public function get ownerName() : String
        {
            return this.txtOwnerName.text;
        }// end function

        public function clearAll() : void
        {
            this.visible = false;
            return;
        }// end function

        public function gotoAndStop(param1:int) : void
        {
            if (this.isBoardFull == true && param1 == 1)
            {
                this.bg.bg.gotoAndStop(3);
            }
            else
            {
                this.bg.bg.gotoAndStop(param1);
            }
            return;
        }// end function

        public function expand() : void
        {
            this.bg.bg.width = 1215;
            this.bg.bg.x = 0;
            this.txtBoardId.x = 8.54;
            this.txtBetCoin.x = 200;
            this.txtNumUser.x = 450;
            this.txtRule.x = 857.66;
            this.txtOwnerName.x = 635.26;
            this.bg.btnShowUser.x = 442;
            this.bg.lock_mc.x = 407;
            this.txtCurrency.x = 170;
            return;
        }// end function

        public function collapse() : void
        {
            this.bg.bg.width = 1020;
            this.bg.bg.x = 0;
            this.txtBoardId.x = 15;
            this.txtBetCoin.x = 160;
            this.txtNumUser.x = 360;
            this.txtRule.x = 710;
            this.txtOwnerName.x = 530;
            this.bg.btnShowUser.x = 343;
            this.bg.lock_mc.x = 342;
            this.txtCurrency.x = 134;
            return;
        }// end function

        public function getXBoundOfExpandButton() : Number
        {
            return this.bg.btnShowUser.x + 134;
        }// end function

        public function set Currency(param1:String) : void
        {
            this.txtCurrency.text = param1;
            return;
        }// end function

        public function set visibleExpandICon(param1:Boolean) : void
        {
            this.bg.btnShowUser.visible = param1;
            return;
        }// end function

        public function get visibleExpandICon() : Boolean
        {
            return this.bg.btnShowUser.visible;
        }// end function

    }
}
