package net.mgame.ui.lobby.listgame
{
    import com.greensock.events.*;
    import com.greensock.loading.*;
    import fl.motion.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import net.mgame.*;
    import net.mgame.ui.*;

    public class ItemGame extends Sprite
    {
        private var bg:BGListGame;
        private var loader:ImageLoader;
        private var iconContainer:Sprite;
        public var gameId:int;
        private var enterGame:Function;
        private var lobby:LobbyScreen;
        private var oriX:Number;
        private var oriY:Number;
        private var timeMove:uint = 0;

        public function ItemGame(param1:LobbyScreen)
        {
            this.lobby = param1;
            this.bg = new BGListGame();
            this.iconContainer = new Sprite();
            this.iconContainer.graphics.lineStyle(0, 0, 0);
            this.iconContainer.graphics.beginFill(0, 0);
            this.iconContainer.graphics.drawRect(0, 0, 200, 200);
            this.iconContainer.graphics.endFill();
            this.iconContainer.x = 53;
            this.iconContainer.mouseChildren = false;
            this.addChild(this.bg);
            this.addChild(this.iconContainer);
            return;
        }// end function

        public function ParseData(param1:Object, param2:AdjustColor, param3:Function) : void
        {
            this.gameId = param1.gameId;
            this.enterGame = param3;
            if (param1.isOpen == false)
            {
                this.filters = [new ColorMatrixFilter(param2.CalculateFinalFlatArray())];
            }
            else
            {
                this.iconContainer.addEventListener(MouseEvent.MOUSE_DOWN, this.onDown);
                this.iconContainer.addEventListener(MouseEvent.CLICK, this.onClick);
            }
            var _loc_4:* = new Shape();
            this.iconContainer.addChild(_loc_4);
            var _loc_5:* = param1.imagePath as BitmapData;
            _loc_4.graphics.clear();
            _loc_4.graphics.beginBitmapFill(_loc_5, null, true, true);
            _loc_4.graphics.drawRect(0, 0, _loc_5.width, _loc_5.height);
            _loc_4.graphics.endFill();
            _loc_4.scaleX = 0.67;
            _loc_4.scaleY = 0.67;
            _loc_4.x = 100 - _loc_4.width >> 1;
            _loc_4.y = this.iconContainer.height - _loc_4.height >> 1;
            return;
        }// end function

        public function resetOriPos() : void
        {
            this.oriX = this.x;
            this.oriY = this.y;
            return;
        }// end function

        private function onDown(event:MouseEvent) : void
        {
            this.timeMove = 0;
            if (isNaN(this.oriX))
            {
                this.oriX = this.x;
                this.oriY = this.y;
            }
            this.scaleX = 1.1;
            this.scaleY = 1.1;
            this.x = this.oriX - 15;
            this.y = this.oriY - 15;
            this.iconContainer.addEventListener(MouseEvent.MOUSE_UP, this.scaleIcon);
            this.iconContainer.addEventListener(MouseEvent.MOUSE_OUT, this.scaleIcon);
            this.iconContainer.addEventListener(MouseEvent.MOUSE_MOVE, this.onMove);
            this.iconContainer.removeEventListener(MouseEvent.MOUSE_DOWN, this.onClick);
            return;
        }// end function

        private function onMove(event:MouseEvent) : void
        {
            var _loc_2:String = this;
            var _loc_3:* = this.timeMove + 1;
            _loc_2.timeMove = _loc_3;
            return;
        }// end function

        private function onLoadImage(event:LoaderEvent) : void
        {
            var _loc_2:* = event.target.content as DisplayObject;
            if (_loc_2 != null)
            {
                _loc_2.scaleX = 0.67;
                _loc_2.scaleY = 0.67;
                _loc_2.x = 100 - _loc_2.width >> 1;
                _loc_2.y = this.iconContainer.height - _loc_2.height >> 1;
                _loc_2 = null;
            }
            return;
        }// end function

        private function onClick(event:MouseEvent) : void
        {
            this.lobby.gameLoader.playSoundClick();
            this.scaleX = 1;
            this.scaleY = 1;
            this.x = this.oriX;
            this.y = this.oriY;
            if (this.lobby.gameLoader.global.gameID == this.gameId || this.timeMove > 5)
            {
                return;
            }
            this.lobby.gameLoader.global.isJoinAnotherGameInLobby = true;
            this.lobby.onBack();
            if (this.enterGame != null)
            {
                this.lobby.activeFocusListGame(false);
                this.enterGame(this.gameId);
            }
            return;
        }// end function

        private function scaleIcon(event:MouseEvent) : void
        {
            this.scaleX = 1;
            this.scaleY = 1;
            this.x = this.oriX;
            this.y = this.oriY;
            this.iconContainer.addEventListener(MouseEvent.MOUSE_DOWN, this.onDown);
            this.iconContainer.removeEventListener(MouseEvent.MOUSE_UP, this.scaleIcon);
            this.iconContainer.removeEventListener(MouseEvent.MOUSE_OUT, this.scaleIcon);
            return;
        }// end function

    }
}
