package pxBitmapFont
{
    import flash.display.*;
    import flash.geom.*;
    import flash.utils.*;

    public class PxBitmapFont extends Object
    {
        private var _glyphs:Array;
        private var _glyphString:String;
        private var _maxHeight:int;
        private var _matrix:Matrix;
        private var _colorTransform:ColorTransform;
        private var _point:Point;
        private var dicGlyph:Dictionary;
        private static var _storedFonts:Dictionary = new Dictionary();
        private static var ZERO_POINT:Point = new Point();

        public function PxBitmapFont()
        {
            this.dicGlyph = new Dictionary();
            this._maxHeight = 0;
            this._point = new Point();
            this._matrix = new Matrix();
            this._colorTransform = new ColorTransform();
            this._glyphs = [];
            return;
        }// end function

        public function loadPixelizer(param1:BitmapData, param2:String) : PxBitmapFont
        {
            var _loc_3:Array = null;
            var _loc_4:Rectangle = null;
            var _loc_5:int = 0;
            var _loc_6:BitmapData = null;
            this.reset();
            this._glyphString = param2;
            if (param1 != null)
            {
                _loc_3 = [];
                this.grabFontData(param1, _loc_3);
                _loc_5 = 0;
                while (_loc_5 < _loc_3.length)
                {
                    
                    _loc_4 = _loc_3[_loc_5];
                    _loc_6 = new BitmapData(Math.floor(_loc_4.width), Math.floor(_loc_4.height), true, 0);
                    _loc_6.copyPixels(param1, _loc_4, ZERO_POINT, null, null, true);
                    this.setGlyph(this._glyphString.charCodeAt(_loc_5), {image:_loc_6, xadvance:_loc_4.width});
                    _loc_5++;
                }
            }
            return this;
        }// end function

        public function loadAngelCode(param1:BitmapData, param2:XML) : PxBitmapFont
        {
            var _loc_3:XMLList = null;
            var _loc_4:int = 0;
            var _loc_5:Rectangle = null;
            var _loc_6:Point = null;
            var _loc_7:XML = null;
            var _loc_8:BitmapData = null;
            var _loc_9:String = null;
            var _loc_10:int = 0;
            var _loc_11:int = 0;
            var _loc_12:int = 0;
            this.reset();
            if (param1 != null)
            {
                this._glyphString = "";
                _loc_3 = param2.chars[0].char;
                _loc_4 = _loc_3.length();
                _loc_5 = new Rectangle();
                _loc_6 = new Point();
                _loc_10 = 0;
                while (_loc_10 < _loc_4)
                {
                    
                    _loc_7 = _loc_3[_loc_10];
                    _loc_9 = String.fromCharCode(_loc_7.@id);
                    this._glyphString = this._glyphString + _loc_9;
                    _loc_5.x = int(_loc_7.@x);
                    _loc_5.y = int(_loc_7.@y);
                    _loc_5.width = int(_loc_7.@width);
                    _loc_5.height = int(_loc_7.@height);
                    _loc_6.x = int(_loc_7.@xoffset);
                    _loc_6.y = int(_loc_7.@yoffset);
                    _loc_11 = int(_loc_7.@xadvance);
                    _loc_12 = _loc_11;
                    if (_loc_5.width > _loc_11)
                    {
                        _loc_12 = int(_loc_5.width);
                        _loc_6.x = 0;
                    }
                    if (_loc_9 != " " && _loc_9 != "")
                    {
                        _loc_8 = new BitmapData(_loc_12, int(_loc_7.@height) + int(_loc_7.@yoffset), true, 0);
                    }
                    else
                    {
                        _loc_8 = new BitmapData(_loc_12, 1, true, 0);
                    }
                    _loc_8.copyPixels(param1, _loc_5, _loc_6, null, null, true);
                    this.setGlyph(_loc_7.@id, {image:_loc_8, xadvance:_loc_11, xOffset:int(_loc_7.@xoffset), yOffset:int(_loc_7.@yoffset)});
                    _loc_10++;
                }
            }
            this.getDefaultPreparedGlyphs();
            return this;
        }// end function

        private function reset() : void
        {
            this.dispose();
            this._maxHeight = 0;
            this._glyphs = [];
            this._glyphString = "";
            return;
        }// end function

        public function grabFontData(param1:BitmapData, param2:Array) : void
        {
            var _loc_5:int = 0;
            var _loc_6:int = 0;
            var _loc_7:int = 0;
            var _loc_8:int = 0;
            var _loc_9:int = 0;
            var _loc_10:int = 0;
            var _loc_3:* = param1.getPixel(0, 0);
            var _loc_4:int = 0;
            while (_loc_4 < param1.height)
            {
                
                _loc_6 = 0;
                _loc_5 = 0;
                while (_loc_5 < param1.width)
                {
                    
                    if (param1.getPixel(_loc_5, _loc_4) != _loc_3)
                    {
                        _loc_7 = _loc_5;
                        _loc_8 = _loc_4;
                        while (param1.getPixel(_loc_7, _loc_4) != _loc_3)
                        {
                            
                            _loc_7++;
                        }
                        while (param1.getPixel(_loc_5, _loc_8) != _loc_3)
                        {
                            
                            _loc_8++;
                        }
                        _loc_9 = _loc_7 - _loc_5;
                        _loc_10 = _loc_8 - _loc_4;
                        param2.push(new Rectangle(_loc_5, _loc_4, _loc_9, _loc_10));
                        if (_loc_10 > _loc_6)
                        {
                            _loc_6 = _loc_10;
                        }
                        if (_loc_10 > this._maxHeight)
                        {
                            this._maxHeight = _loc_10;
                        }
                        _loc_5 = _loc_5 + _loc_9;
                    }
                    _loc_5++;
                }
                _loc_4 = _loc_4 + (_loc_6 + 1);
            }
            return;
        }// end function

        public function getPreparedGlyphs(param1:Number, param2:int, param3:Boolean = true) : Array
        {
            var _loc_6:BitmapData = null;
            var _loc_7:BitmapData = null;
            var _loc_8:* = undefined;
            var _loc_9:int = 0;
            var _loc_10:int = 0;
            var _loc_11:Object = null;
            var _loc_12:* = undefined;
            var _loc_4:Array = [];
            this._matrix.identity();
            this._matrix.scale(param1, param1);
            var _loc_5:Number = 0.00392;
            this._colorTransform.redOffset = param2 >> 16;
            this._colorTransform.greenOffset = param2 >> 8 & 255;
            this._colorTransform.blueOffset = param2 & 255;
            this._colorTransform.redMultiplier = 0;
            this._colorTransform.greenMultiplier = 0;
            this._colorTransform.blueMultiplier = 0;
            for (_loc_8 in this._glyphs)
            {
                
                _loc_6 = this._glyphs[_loc_8].image;
                if (_loc_6 != null)
                {
                    if (param1 > 0)
                    {
                        _loc_9 = Math.ceil(_loc_6.width * param1);
                        _loc_10 = Math.ceil(_loc_6.height * param1);
                    }
                    else
                    {
                        _loc_9 = 1;
                        _loc_10 = 1;
                    }
                    _loc_7 = new BitmapData(_loc_9, _loc_10, true, 0);
                    if (param3)
                    {
                        _loc_7.draw(_loc_6, this._matrix, this._colorTransform);
                    }
                    else
                    {
                        _loc_7.draw(_loc_6, this._matrix);
                    }
                    _loc_11 = {};
                    for (_loc_12 in this._glyphs[_loc_8])
                    {
                        
                        _loc_11[_loc_12] = this._glyphs[_loc_8][_loc_12];
                    }
                    _loc_11.image = _loc_7;
                    _loc_4[_loc_8] = _loc_11;
                }
            }
            return _loc_4;
        }// end function

        public function getDefaultPreparedGlyphs() : Array
        {
            if (this.dicGlyph["Trang"] == null)
            {
                this.dicGlyph["Trang"] = this.getPreparedGlyphs(1, 16777215, false);
            }
            return this.dicGlyph["Trang"];
        }// end function

        public function dispose() : void
        {
            var _loc_1:BitmapData = null;
            var _loc_2:* = undefined;
            for (_loc_2 in this._glyphs)
            {
                
                _loc_1 = this._glyphs[_loc_2].image;
                if (_loc_1 != null)
                {
                    _loc_1.dispose();
                }
            }
            if (this._glyphs)
            {
                this._glyphs.length = 0;
            }
            this._glyphs = null;
            return;
        }// end function

        public function getFontData() : String
        {
            var _loc_3:* = undefined;
            var _loc_4:int = 0;
            var _loc_5:BitmapData = null;
            var _loc_6:int = 0;
            var _loc_7:int = 0;
            var _loc_1:String = "";
            var _loc_2:int = 0;
            for (_loc_3 in this._glyphString)
            {
                
                _loc_4 = this._glyphString.charCodeAt(_loc_3);
                _loc_5 = this._glyphs[_loc_4].image;
                _loc_1 = _loc_1 + this._glyphString.substr(_loc_2, 1);
                _loc_1 = _loc_1 + _loc_5.width;
                _loc_1 = _loc_1 + _loc_5.height;
                _loc_6 = 0;
                while (_loc_6 < _loc_5.height)
                {
                    
                    _loc_7 = 0;
                    while (_loc_7 < _loc_5.width)
                    {
                        
                        _loc_1 = _loc_1 + (_loc_5.getPixel32(_loc_7, _loc_6) != 0 ? ("1") : ("0"));
                        _loc_7++;
                    }
                    _loc_6++;
                }
                _loc_2++;
            }
            return _loc_1;
        }// end function

        public function getAvailableChars() : Array
        {
            var _loc_1:Array = [];
            var _loc_2:int = 0;
            while (_loc_2 < this._glyphString.length)
            {
                
                _loc_1.push(this._glyphString.substr(_loc_2, 1));
                _loc_2++;
            }
            return _loc_1;
        }// end function

        private function setGlyph(param1:int, param2:Object) : void
        {
            var _loc_3:* = param2.image;
            if (this._glyphs[param1] != null)
            {
                this._glyphs[param1].image.dispose();
            }
            this._glyphs[param1] = param2;
            if (_loc_3.height > this._maxHeight)
            {
                this._maxHeight = _loc_3.height;
            }
            return;
        }// end function

        public function render(param1:BitmapData, param2:Array, param3:String, param4:uint, param5:int, param6:int, param7:int, param8:Number = 0) : void
        {
            var _loc_9:BitmapData = null;
            var _loc_12:int = 0;
            var _loc_13:int = 0;
            var _loc_14:int = 0;
            var _loc_15:int = 0;
            this._point.x = param5;
            this._point.y = param6;
            var _loc_10:* = new Point();
            var _loc_11:int = 0;
            while (_loc_11 < param3.length)
            {
                
                _loc_12 = param3.charCodeAt(_loc_11);
                if (!(_loc_12 in param2))
                {
                }
                else
                {
                    _loc_13 = param2[_loc_12].xadvance;
                    _loc_14 = param2[_loc_12].xOffset;
                    _loc_15 = param2[_loc_12].yOffset;
                    _loc_9 = param2[_loc_12].image;
                    if (_loc_9 != null)
                    {
                        _loc_10.setTo(this._point.x, this._point.y);
                        param1.copyPixels(_loc_9, _loc_9.rect, _loc_10, null, null, true);
                        this._point.x = this._point.x + (_loc_13 + param7);
                    }
                }
                _loc_11++;
            }
            return;
        }// end function

        public function getTextWidth(param1:String, param2:int = 0, param3:Number = 1) : int
        {
            var _loc_7:int = 0;
            var _loc_8:Object = null;
            var _loc_4:int = 0;
            var _loc_5:* = param1.length;
            var _loc_6:int = 0;
            while (_loc_6 < _loc_5)
            {
                
                _loc_7 = param1.charCodeAt(_loc_6);
                _loc_8 = this._glyphs[_loc_7];
                if (_loc_8 != null)
                {
                    _loc_4 = _loc_4 + _loc_8.xadvance;
                }
                _loc_6++;
            }
            _loc_4 = Math.round(_loc_4 * param3) + 4;
            if (_loc_5 > 1)
            {
                _loc_4 = _loc_4 + (_loc_5 - 1) * param2;
            }
            return _loc_4;
        }// end function

        public function getFontHeight() : int
        {
            return this._maxHeight;
        }// end function

        public function get numLetters() : int
        {
            return this._glyphs.length;
        }// end function

        public static function store(param1:String, param2:PxBitmapFont) : void
        {
            _storedFonts[param1] = param2;
            return;
        }// end function

        public static function remove(param1:String) : void
        {
            var _loc_2:PxBitmapFont = null;
            if (param1 in _storedFonts)
            {
                _loc_2 = _storedFonts[param1];
                _loc_2.dispose();
                delete _storedFonts[param1];
            }
            return;
        }// end function

        public static function fetch(param1:String) : PxBitmapFont
        {
            var _loc_2:* = _storedFonts[param1];
            return _loc_2;
        }// end function

    }
}
