package pxBitmapFont
{
    import flash.display.*;
    import flash.geom.*;

    public class PxTextField extends Shape
    {
        private var _font:PxBitmapFont;
        private var _text:String;
        private var _color:int;
        private var _useColor:Boolean;
        private var _outline:Boolean;
        private var _outlineColor:int;
        private var _shadow:Boolean;
        private var _shadowColor:int;
        private var _background:Boolean;
        private var _backgroundColor:int;
        private var _alignment:int;
        private var _padding:int;
        private var _lineSpacing:int;
        private var _letterSpacing:int;
        private var _fontScale:Number;
        private var _autoUpperCase:Boolean;
        private var _wordWrap:Boolean;
        private var _fixedWidth:Boolean;
        private var _numSpacesInTab:int;
        private var _tabSpaces:String;
        private var _pendingTextChange:Boolean;
        private var _fieldWidth:int;
        private var _multiLine:Boolean;
        public var bitmapData:BitmapData;
        private var _bitmap:Bitmap;
        private var _preparedTextGlyphs:Array;
        private var _preparedShadowGlyphs:Array;
        private var _preparedOutlineGlyphs:Array;
        private var _colorTransform:ColorTransform;

        public function PxTextField(param1:PxBitmapFont = null)
        {
            this._colorTransform = new ColorTransform();
            this._text = "";
            this._color = 16777215;
            this._useColor = true;
            this._outline = false;
            this._outlineColor = 0;
            this._shadow = false;
            this._shadowColor = 0;
            this._background = false;
            this._backgroundColor = 16777215;
            this._alignment = PxTextAlign.LEFT;
            this._padding = 0;
            this._pendingTextChange = false;
            this._fieldWidth = 1;
            this._multiLine = false;
            this._lineSpacing = 0;
            this._letterSpacing = 0;
            this._fontScale = 1;
            this._autoUpperCase = false;
            this._fixedWidth = true;
            this._wordWrap = true;
            this._numSpacesInTab = 4;
            this._tabSpaces = "    ";
            if (param1 == null)
            {
                if (PxBitmapFont.fetch("default") == null)
                {
                    PxDefaultFontGenerator.generateAndStoreDefaultFont();
                }
                this._font = PxBitmapFont.fetch("default");
            }
            else
            {
                this._font = param1;
            }
            this.clearPreparedGlyphs(this._preparedTextGlyphs);
            this._preparedTextGlyphs = param1.getDefaultPreparedGlyphs();
            this.bitmapData = new BitmapData(1, 1, true);
            this._pendingTextChange = true;
            return;
        }// end function

        public function destroy() : void
        {
            this._font = null;
            this.graphics.clear();
            this._bitmap = null;
            this.bitmapData.dispose();
            this.bitmapData = null;
            this.clearPreparedGlyphs(this._preparedTextGlyphs);
            this.clearPreparedGlyphs(this._preparedShadowGlyphs);
            this.clearPreparedGlyphs(this._preparedOutlineGlyphs);
            return;
        }// end function

        public function get numSpacesInTab() : int
        {
            return this._numSpacesInTab;
        }// end function

        public function set numSpacesInTab(param1:int) : void
        {
            var _loc_2:int = 0;
            if (this._numSpacesInTab != param1 && param1 > 0)
            {
                this._numSpacesInTab = param1;
                this._tabSpaces = "";
                _loc_2 = 0;
                while (_loc_2 < param1)
                {
                    
                    this._tabSpaces = this._tabSpaces + " ";
                    _loc_2++;
                }
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get text() : String
        {
            return this._text;
        }// end function

        public function set text(param1:String) : void
        {
            if (param1 != this._text)
            {
                this._text = param1;
                this._pendingTextChange = true;
                this.update();
            }
            return;
        }// end function

        private function updateBitmapData() : void
        {
            var _loc_6:Boolean = false;
            var _loc_10:int = 0;
            var _loc_11:String = null;
            var _loc_12:String = null;
            var _loc_15:Array = null;
            var _loc_16:int = 0;
            var _loc_17:String = null;
            var _loc_18:Boolean = false;
            var _loc_19:String = null;
            var _loc_20:String = null;
            var _loc_21:String = null;
            var _loc_22:String = null;
            var _loc_23:int = 0;
            var _loc_24:String = null;
            var _loc_25:int = 0;
            var _loc_26:int = 0;
            var _loc_27:int = 0;
            var _loc_28:int = 0;
            if (this._font == null)
            {
                return;
            }
            var _loc_1:* = this._autoUpperCase ? (this._text.toUpperCase()) : (this._text);
            var _loc_2:* = this._fieldWidth;
            var _loc_3:Array = [];
            var _loc_4:* = Math.floor(this._font.getFontHeight() * this._fontScale);
            var _loc_5:* = this._alignment;
            var _loc_7:* = _loc_1.split("\n");
            var _loc_8:int = -1;
            var _loc_9:int = -1;
            if (!this._multiLine)
            {
                _loc_7 = [_loc_7[0]];
            }
            while (++_loc_8 < _loc_7.length)
            {
                
                if (this._fixedWidth)
                {
                    _loc_6 = false;
                    _loc_15 = [];
                    if (!this.wordWrap)
                    {
                        _loc_15 = _loc_7[_loc_8].split("\t").join(this._tabSpaces).split(" ");
                    }
                    else
                    {
                        _loc_15 = _loc_7[_loc_8].split("\t").join(" \t ").split(" ");
                    }
                    if (_loc_15.length > 0)
                    {
                        _loc_16 = 0;
                        _loc_17 = "";
                        while (!_loc_6)
                        {
                            
                            _loc_11 = _loc_15[_loc_16];
                            _loc_18 = false;
                            _loc_19 = _loc_17 + _loc_11;
                            if (this._wordWrap)
                            {
                                _loc_20 = _loc_16 > 0 ? (_loc_15[(_loc_16 - 1)]) : ("");
                                _loc_21 = _loc_16 < _loc_15.length ? (_loc_15[(_loc_16 + 1)]) : ("");
                                if (_loc_20 != "\t")
                                {
                                    _loc_19 = _loc_19 + " ";
                                }
                                if (this._font.getTextWidth(_loc_19, this._letterSpacing, this._fontScale) > this._fieldWidth)
                                {
                                    if (_loc_17 == "")
                                    {
                                        _loc_15.splice(0, 1);
                                    }
                                    else
                                    {
                                        _loc_3.push(_loc_17.substr(0, (_loc_17.length - 1)));
                                    }
                                    _loc_17 = "";
                                    if (this._multiLine)
                                    {
                                        if (_loc_11 == "\t" && _loc_16 < _loc_15.length)
                                        {
                                            _loc_15.splice(0, (_loc_16 + 1));
                                        }
                                        else
                                        {
                                            _loc_15.splice(0, _loc_16);
                                        }
                                    }
                                    else
                                    {
                                        _loc_15.splice(0, _loc_15.length);
                                    }
                                    _loc_16 = 0;
                                    _loc_18 = true;
                                }
                                else
                                {
                                    if (_loc_11 == "\t")
                                    {
                                        _loc_17 = _loc_17 + this._tabSpaces;
                                    }
                                    if (_loc_21 == "\t" || _loc_20 == "\t")
                                    {
                                        _loc_17 = _loc_17 + _loc_11;
                                    }
                                    else
                                    {
                                        _loc_17 = _loc_17 + (_loc_11 + " ");
                                    }
                                    _loc_16++;
                                }
                            }
                            else if (this._font.getTextWidth(_loc_19, this._letterSpacing, this._fontScale) > this._fieldWidth)
                            {
                                if (_loc_11 != "")
                                {
                                    _loc_9 = 0;
                                    _loc_12 = "";
                                    _loc_10 = _loc_11.length;
                                    while (_loc_9 < _loc_10)
                                    {
                                        
                                        _loc_19 = _loc_17 + _loc_11.charAt(_loc_9);
                                        if (this._font.getTextWidth(_loc_19, this._letterSpacing, this._fontScale) > this._fieldWidth)
                                        {
                                            _loc_3.push(_loc_17.substr(0, (_loc_17.length - 1)));
                                            _loc_17 = "";
                                            _loc_11 = "";
                                            _loc_16 = _loc_15.length;
                                            _loc_9 = _loc_10;
                                            _loc_18 = true;
                                        }
                                        else
                                        {
                                            _loc_17 = _loc_17 + _loc_11.charAt(_loc_9);
                                        }
                                        _loc_9++;
                                    }
                                }
                                else
                                {
                                    _loc_18 = false;
                                    _loc_16 = _loc_15.length;
                                }
                            }
                            else
                            {
                                _loc_17 = _loc_17 + (_loc_11 + "");
                                _loc_16++;
                            }
                            if (_loc_16 >= _loc_15.length)
                            {
                                if (!_loc_18)
                                {
                                    _loc_2 = Math.floor(Math.max(_loc_2, this._font.getTextWidth(_loc_17, this._letterSpacing, this._fontScale)));
                                    _loc_3.push(_loc_17);
                                }
                                _loc_6 = true;
                            }
                        }
                    }
                    else
                    {
                        _loc_3.push("");
                    }
                    continue;
                }
                _loc_22 = _loc_7[_loc_8].split("\t").join(this._tabSpaces);
                _loc_2 = Math.floor(Math.max(_loc_2, this._font.getTextWidth(_loc_22, this._letterSpacing, this._fontScale)));
                _loc_3.push(_loc_22);
            }
            var _loc_13:* = _loc_2 + this._padding * 2 + (this._outline ? (2) : (0)) + 4;
            var _loc_14:* = Math.floor(this._padding * 2 + Math.max(1, _loc_3.length * _loc_4 + (this._shadow ? (1) : (0)) + (this._outline ? (2) : (0)))) + (_loc_3.length >= 1 ? (this._lineSpacing * (_loc_3.length - 1)) : (0));
            if (this.bitmapData != null)
            {
                if (_loc_13 != this.bitmapData.width || _loc_14 != this.bitmapData.height)
                {
                    this.bitmapData.dispose();
                    this.bitmapData = null;
                }
            }
            if (this.bitmapData == null)
            {
                this.bitmapData = new BitmapData(_loc_13, _loc_14, !this._background, this._backgroundColor);
            }
            else
            {
                this.bitmapData.fillRect(this.bitmapData.rect, this._backgroundColor);
            }
            if (this._fontScale > 0)
            {
                this.bitmapData.lock();
                _loc_23 = 0;
                for each (_loc_24 in _loc_3)
                {
                    
                    _loc_25 = 0;
                    _loc_26 = 0;
                    if (_loc_5 == PxTextAlign.CENTER)
                    {
                        if (this._fixedWidth)
                        {
                            _loc_25 = Math.floor((this._fieldWidth - this._font.getTextWidth(_loc_24, this._letterSpacing, this._fontScale)) / 2);
                        }
                        else
                        {
                            _loc_25 = Math.floor((_loc_13 - this._font.getTextWidth(_loc_24, this._letterSpacing, this._fontScale)) / 2);
                        }
                    }
                    if (_loc_5 == PxTextAlign.RIGHT)
                    {
                        if (this._fixedWidth)
                        {
                            _loc_25 = this._fieldWidth - Math.floor(this._font.getTextWidth(_loc_24, this._letterSpacing, this._fontScale));
                        }
                        else
                        {
                            _loc_25 = _loc_13 - Math.floor(this._font.getTextWidth(_loc_24, this._letterSpacing, this._fontScale)) - 2 * this.padding;
                        }
                    }
                    if (this._outline)
                    {
                        _loc_27 = 0;
                        while (_loc_27 <= 2)
                        {
                            
                            _loc_28 = 0;
                            while (_loc_28 <= 2)
                            {
                                
                                this._font.render(this.bitmapData, this._preparedOutlineGlyphs, _loc_24, this._outlineColor, _loc_28 + _loc_25 + this._padding, _loc_27 + _loc_23 * (_loc_4 + this._lineSpacing) + this._padding, this._letterSpacing);
                                _loc_28++;
                            }
                            _loc_27++;
                        }
                        _loc_25 = _loc_25 + 1;
                        _loc_26 = _loc_26 + 1;
                    }
                    if (this._shadow)
                    {
                        this._font.render(this.bitmapData, this._preparedShadowGlyphs, _loc_24, this._shadowColor, 1 + _loc_25 + this._padding, 1 + _loc_26 + _loc_23 * (_loc_4 + this._lineSpacing) + this._padding, this._letterSpacing);
                    }
                    this._font.render(this.bitmapData, this._preparedTextGlyphs, _loc_24, this._color, _loc_25 + this._padding, _loc_26 + _loc_23 * (_loc_4 + this._lineSpacing) + this._padding, this._letterSpacing);
                    _loc_23++;
                }
                this.bitmapData.unlock();
            }
            this._pendingTextChange = false;
            return;
        }// end function

        public function update() : void
        {
            if (this._pendingTextChange)
            {
                this.updateBitmapData();
                this.drawText(this.bitmapData);
            }
            return;
        }// end function

        private function drawText(param1:BitmapData) : void
        {
            var _loc_2:BitmapData = null;
            this.graphics.clear();
            if (this._color != 16777215)
            {
                this._colorTransform.redOffset = this._color >> 16;
                this._colorTransform.greenOffset = this._color >> 8 & 255;
                this._colorTransform.blueOffset = this._color & 255;
                this._colorTransform.redMultiplier = 0;
                this._colorTransform.greenMultiplier = 0;
                this._colorTransform.blueMultiplier = 0;
                _loc_2 = new BitmapData(param1.width, param1.height, true, 16777215);
                _loc_2.draw(param1, null, this._colorTransform);
                this.graphics.beginBitmapFill(_loc_2);
            }
            else
            {
                this.graphics.beginBitmapFill(param1);
            }
            this.graphics.drawRect(0, 0, param1.width, param1.height);
            this.graphics.endFill();
            return;
        }// end function

        public function get background() : Boolean
        {
            return this._background;
        }// end function

        public function set background(param1:Boolean) : void
        {
            if (this._background != param1)
            {
                this._background = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get backgroundColor() : int
        {
            return this._backgroundColor;
        }// end function

        public function set backgroundColor(param1:int) : void
        {
            if (this._backgroundColor != param1)
            {
                this._backgroundColor = param1;
                if (this._background)
                {
                    this._pendingTextChange = true;
                }
            }
            return;
        }// end function

        public function get shadow() : Boolean
        {
            return this._shadow;
        }// end function

        public function set shadow(param1:Boolean) : void
        {
            if (this._shadow != param1)
            {
                this._shadow = param1;
                this._outline = false;
                this.updateGlyphs(false, this._shadow, false);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get shadowColor() : int
        {
            return this._shadowColor;
        }// end function

        public function set shadowColor(param1:int) : void
        {
            if (this._shadowColor != param1)
            {
                this._shadowColor = param1;
                this.updateGlyphs(false, this._shadow, false);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get padding() : int
        {
            return this._padding;
        }// end function

        public function set padding(param1:int) : void
        {
            if (this._padding != param1)
            {
                this._padding = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get color() : int
        {
            return this._color;
        }// end function

        public function set color(param1:int) : void
        {
            if (this._color != param1)
            {
                this._color = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get useColor() : Boolean
        {
            return this._useColor;
        }// end function

        public function set useColor(param1:Boolean) : void
        {
            if (this._useColor != param1)
            {
                this._useColor = param1;
                this.updateGlyphs(true, false, false);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        override public function set width(param1:Number) : void
        {
            if (param1 < 1)
            {
                param1 = 1;
            }
            if (param1 != this._fieldWidth)
            {
                this._fieldWidth = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get alignment() : int
        {
            return this._alignment;
        }// end function

        public function set alignment(param1:int) : void
        {
            if (this._alignment != param1)
            {
                this._alignment = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get multiLine() : Boolean
        {
            return this._multiLine;
        }// end function

        public function set multiLine(param1:Boolean) : void
        {
            if (this._multiLine != param1)
            {
                this._multiLine = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get outline() : Boolean
        {
            return this._outline;
        }// end function

        public function set outline(param1:Boolean) : void
        {
            if (this._outline != param1)
            {
                this._outline = param1;
                this._shadow = false;
                this.updateGlyphs(false, false, true);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get outlineColor() : int
        {
            return this._outlineColor;
        }// end function

        public function set outlineColor(param1:int) : void
        {
            if (this._outlineColor != param1)
            {
                this._outlineColor = param1;
                this.updateGlyphs(false, false, this._outline);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get font() : PxBitmapFont
        {
            return this._font;
        }// end function

        public function set font(param1:PxBitmapFont) : void
        {
            if (this._font != param1)
            {
                this._font = param1;
                this.updateGlyphs(true, this._shadow, this._outline);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get lineSpacing() : int
        {
            return this._lineSpacing;
        }// end function

        public function set lineSpacing(param1:int) : void
        {
            if (this._lineSpacing != param1)
            {
                this._lineSpacing = Math.floor(Math.abs(param1));
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get fontScale() : Number
        {
            return this._fontScale;
        }// end function

        public function set fontScale(param1:Number) : void
        {
            var _loc_2:* = Math.abs(param1);
            if (_loc_2 != this._fontScale)
            {
                this._fontScale = _loc_2;
                this.updateGlyphs(true, this._shadow, this._outline);
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get letterSpacing() : int
        {
            return this._letterSpacing;
        }// end function

        public function set letterSpacing(param1:int) : void
        {
            var _loc_2:* = Math.floor(Math.abs(param1));
            if (_loc_2 != this._letterSpacing)
            {
                this._letterSpacing = _loc_2;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get autoUpperCase() : Boolean
        {
            return this._autoUpperCase;
        }// end function

        public function set autoUpperCase(param1:Boolean) : void
        {
            if (this._autoUpperCase != param1)
            {
                this._autoUpperCase = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get wordWrap() : Boolean
        {
            return this._wordWrap;
        }// end function

        public function set wordWrap(param1:Boolean) : void
        {
            if (this._wordWrap != param1)
            {
                this._wordWrap = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        public function get fixedWidth() : Boolean
        {
            return this._fixedWidth;
        }// end function

        public function set fixedWidth(param1:Boolean) : void
        {
            if (this._fixedWidth != param1)
            {
                this._fixedWidth = param1;
                this._pendingTextChange = true;
            }
            return;
        }// end function

        private function updateGlyphs(param1:Boolean = false, param2:Boolean = false, param3:Boolean = false) : void
        {
            if (param1)
            {
                this.clearPreparedGlyphs(this._preparedTextGlyphs);
                this._preparedTextGlyphs = this._font.getPreparedGlyphs(this._fontScale, this._color, this._useColor);
            }
            if (param2)
            {
                this.clearPreparedGlyphs(this._preparedShadowGlyphs);
                this._preparedShadowGlyphs = this._font.getPreparedGlyphs(this._fontScale, this._shadowColor);
            }
            if (param3)
            {
                this.clearPreparedGlyphs(this._preparedOutlineGlyphs);
                this._preparedOutlineGlyphs = this._font.getPreparedGlyphs(this._fontScale, this._outlineColor);
            }
            return;
        }// end function

        private function clearPreparedGlyphs(param1:Array) : void
        {
            var _loc_2:Object = null;
            if (param1 != null)
            {
                for each (_loc_2 in param1)
                {
                    
                    if (_loc_2 != null)
                    {
                        _loc_2.image.dispose();
                    }
                }
                param1 = null;
            }
            return;
        }// end function

    }
}
